e_native_adaptor.e
------------------

Note: This is the adaptor used for native e ports (i.e. when you do
an e-to-e bind). 

This is not the adaptor used for NULL simulator.

<'
struct e_native_adaptor like esi_adaptor {
    
    init() is also {
	name = "e_native";
    };

    -- Create the stubs for this adaptor by calling the append_stub() method.
    -- Called upon "write stubs -esi" for all relevant adaptors.
    write_stubs(units: list of any_unit, ports: list of any_port) is {
	
	-- Create code for call ports
	for each call_port (p) in ports do {
	    if p.direction == client {  -- Client only gets changed
	        for each (m) in p.methods {
		    add_method_code(p, m);
		};
	    };
	};
    };


    -- Add the method category if needed
    add_method_code(p: call_port, m: port_method_struct) is {
	
	var server_unit_name:= rf_manager.get_struct_by_instance(
				p.channel.server).get_name();
	var key:= append("Calling e method ", server_unit_name, ".", 
							m.method_name, "()");
	if not esi_manager.has_method_code(m, key) then {
	    var rf_method:= rf_manager.get_struct_by_instance(m).
				get_method("call");
	    -- Create the code
	    var code:= append(
		  (rf_method.get_result_type() == NULL ? "" : "return "),
		  "channel.server.as_a(", server_unit_name, ").",
		  m.method_name, "(", 
		  str_join(rf_method.get_parameters().apply(.get_name()), ", "),
		  ");");

	    esi_manager.add_method_code(m, key, code);

	    -- If we want to add to the unit, put here:
	    -- var q:= append("extend ....");
	    -- esi_manager.append_stub("stubs.e", {q})
	};
    };


    -- Get the description of each port
    get_description(port: any_port): list of string is {
	var x:= port.get_channel().ports.all(it != port).apply(.e_path());
        return {
	    append("bound to ", str_join(x, " "));
	};
    };
};

extend esi_manager {
    init() is also {
	add_adaptor(new e_native_adaptor);
    };
};
'>

