#!/bin/csh -f

set debug_mode = jar
set pkg = ""
set verb = 0
set src_dir = .
set out_dir = .


if (! ($?JSPECVIEW_JAVA_EXE)) then
  set JSPECVIEW_JAVA_EXE = "JRE1.1"
endif

#=======================================================
#===   first loop - get options  =======================
#=======================================================
set argc = $#argv
while ($argc > 0)
    # get first character
    set flag = $1

    switch( $flag )

        case -debug_mode:
            shift
	    if ("$1" == "") then
	      goto USAGE
            endif
	    set debug_mode = "$1"
            shift
            breaksw

        case -out_dir:
            shift
	    if ("$1" == "") then
	      goto USAGE
            endif
	    set out_dir = "$1"
            shift
            breaksw

        case -src_dir:
            shift
	    if ("$1" == "") then
	      goto USAGE
            endif
	    set src_dir = "$1"
            shift
            breaksw

        case -h:
        case -help:
            goto USAGE
            breaksw

        case -v:
        case -verbose:
            set verb = 1
            shift
            breaksw

        default:
	    set pkg = "$*"
            goto START
            breaksw
    endsw
    set argc = $#argv
end
#=======================================================
#===   END first loop            =======================
#=======================================================

START:

if ("$pkg" == "") then
  echo "*** Error: No package was specified"
  goto USAGE
endif




# JAVA ENVIRONMENT
if ("$JSPECVIEW_JAVA_EXE" == "JRE1.2") then
  # Use jdk 1.2.2
  echo "Compiling with JDK1.2"
  setenv JAVA_HOME "/proj/Spider/jbuilder30/jdk1.2.2"
else
  # Use jdk 1.1.7
  setenv JAVA_HOME "/proj/Spider/java/jdk1.1.7"
endif


set general_classpath = ${JAVA_HOME}/lib/classes.zip{:}$SPECMAN_HOME/japp/jar/swing.jar{:}$SPECMAN_HOME/japp/jar/motif.jar{:}$SPECMAN_HOME/japp/jar/windows.jar 

set debug_mode = jar
set jspecview_class_dir = ""


switch( $debug_mode )
  case debug:
    set jspecview_class_dir = $SPECMAN_HOME/jdev/class_d
    breaksw

  case no_debug:
    set jspecview_class_dir = $SPECMAN_HOME/jdev/class
    breaksw

  case jar:
    set jspecview_class_dir = "$SPECMAN_HOME/japp/jspecview/jar/jspecview.jar"
    breaksw

  default:
    echo "*** Error: uknown debug mode: $debug_mode"
    exit -1
endsw
if ($verb) echo "jspecview_class_dir $jspecview_class_dir"

if ($verb) echo "Compiling class files to dir: $out_dir"


set classpath = $src_dir{:}$out_dir{:}$jspecview_class_dir{:}$general_classpath
if ($verb) echo "classpath $classpath"

if ($verb) then
  set verb_arg = "-v"
else
  set verb_arg = ""
endif

if ($verb) then
  echo "jmk_one_pkg.sh -src_dir $src_dir -out_dir $out_dir -classpath $classpath  $verb_arg $pkg"
endif
$SPECMAN_HOME/tools/jmk_one_pkg.sh -src_dir $src_dir -out_dir $out_dir -classpath $classpath  $verb_arg $pkg


exit 0

USAGE:
echo ""
echo "Usage: jmk_test.sh [-help] [-debug_mode debug | no_debug | jar] <pkg>"
