<'
import ../jbrowsers/jbrowsers.e;


define <show_class'command> "show class[ <any>]" as {
    
    p_classbrowser.p_classbrowser_deli.show_class_browser("<any|sys>")
        
};

//define <show_class_by_input'command> "show class" as {
//
//    do {
//        var tcl_cmd := appendf("[get_input %s {%s} {%s} 40 {%s} ]",
//            ".main0", "Input Window", "Enter class name (struct or unit) to show in Class Browser:", "");
//        var s_class := display.get_tcl_exp_value(tcl_cmd);
//        
//        if (s_class != "__@CANCEL@__") then {
//            
//            p_classbrowser.p_classbrowser_deli.show_class_browser(s_class);
//        };
//        
//    };
//};

extend global {
    
    p_classbrowser: sn_classbrowser;
    
    init() is also {
        p_classbrowser = NEW sn_classbrowser.ctor();
    };
};



struct sn_classbrowser {
    
    p_classbrowser_deli: sn_classbrowser_deli;
    p_eclassbrowser_service: sn_eclassbrowser_service;
    p_dirty: bool;
    
    ctor() is {
        p_classbrowser_deli = NEW sn_classbrowser_deli.ctor();
        p_eclassbrowser_service = NEW sn_eclassbrowser_service.ctor();
        p_dirty = FALSE;
        
        //orb register service p_eclassbrowser_service 
        //    sni_eclassbrowser_service 
        //    ECLASSBROWSER_SERVICE_NAME;
        
    };
    
    
    register_service() is {
        orb register service p_eclassbrowser_service sni_eclassbrowser_service ECLASSBROWSER_SERVICE_NAME;
    };

    raise_dirty_flag() is {
        p_dirty = TRUE;
    };
    
    refresh_if_dirty() is {
        if (p_dirty) {
            p_dirty = FALSE;
            if (p_classbrowser_deli != NULL) {
                p_classbrowser_deli.refresh();            
            };
        };
    };
    
};

extend sn_jbrowsers {
    raise_dirty_flag() is also {
        p_classbrowser.raise_dirty_flag();
    };
    
    refresh_if_dirty() is also {
        p_classbrowser.refresh_if_dirty();
    };
};


struct sn_eclassbrowser_service like sni_eclassbrowser_service {
    
    ctor() is {
        ;        
    };

    is_class_exists(s_class: string): bool is {
        //print s_class;
        var sd: struct_descriptor = NULL;
        
        try {
            sd = p_get_struct_descriptor(s_class);
        };
        
        result = (sd != NULL);
            
        
    };
    
    get_class_content_node(s_class: string, 
        f_give_error: bool): sn_class_content_node_info is {
        
        try {
            var sd: struct_descriptor = p_get_struct_descriptor(s_class);
            
            result = NEW sn_class_content_node_info.ctor_stct(sd);
        } else {
            if (f_give_error) {
                write_the_error();
            } else {
                result = NULL;
            };
        };
        
        
    };
    
    get_class_inherit_node(s_class: string, 
        f_give_error: bool): sn_class_inherit_node_info is {
        
        try {

            var sd: struct_descriptor = p_get_struct_descriptor(s_class);
            
            if (sd != NULL) {
                sd = sd.elem_type().as_a(struct_descriptor);
                result = NEW sn_class_inherit_node_info.ctor(sd);
            };
            
        } else {
            if (f_give_error) {
                write_the_error();
            } else {
                result = NULL;
            };
        };
        
        
        //print 1999, result;
    };
    
    get_top_class_inherit(): sn_class_inherit_node_info is {
        var sd: struct_descriptor = type_called("base_struct").as_a(struct_descriptor);
        ASSERT (sd != NULL);

        result = NEW sn_class_inherit_node_info.ctor(sd);
        
    };
    p_get_struct_descriptor(s_class: string): struct_descriptor is {
        try {
            var td: type_descriptor = type_called(s_class);
            if (td.is_a_struct()) {
                result = td.as_a(struct_descriptor);
            } else {
                
                error("There is no struct called ", s_class);
            };
            
        } else {
            
            error("There is no type called ", s_class);
        };
    
    };
    
    p_get_struct_kind(td: type_descriptor, member: source_item): int is {
        result = KIND_UNDEF;
        
        if (td != NULL) {

     
            if (td.is_unit()) {
                
                if (member == NULL) {
                    result = KIND_UNIT_INSTANCE;
                } else {
                    // its a member field
                    
                    if member is a field (a_field) {
                        if (a_field.is_instance) {
                            result = KIND_UNIT_INSTANCE;
                        } else {
                            result = KIND_UNIT_REF;
                        };
                    };
                };
            
            } else if (td.is_a_struct()) {
                result = KIND_STRUCT;
            
            } else {
                result = KIND_SCALAR;
            };
        } else {
            result = KIND_UNDEF;
        };
        
    };

    p_get_member_kind(member: source_item): int is {
        if (member == NULL) {
            result = MEMBER_KIND_NONE;
            
        } else if member is a method (M) {
            if (M.as_a(tcm) != NULL) {
                result = MEMBER_KIND_TCM;
            } else {
                result = MEMBER_KIND_METHOD
            };
                
        } else if member is a event_type {
            result = MEMBER_KIND_EVENT;
            
        } else if member is a gen_constraint {
            result = MEMBER_KIND_CONSTRAINT;
            
        } else if member is a field {
            result = MEMBER_KIND_FIELD;
            
        } else if member is a sn_cover_group_descriptor {
            result = MEMBER_KIND_COVER_GROUP;
            
        } else if member is a sn_cover_item_descriptor {
            result = MEMBER_KIND_COVER_ITEM;
            
        };
    };
    
    get_matching_classes(s_re: string, n_max_items: int): sn_class_list is {
        result = new sn_class_list;
        
        var lst_structs: list of type_descriptor = 
            global.all_types.all(
            (it.name ~ s_re) &&
            (it.short_type == STRUCT_TYPE) &&
            (! it.is_a_list()));

        if (lst_structs.size() <= n_max_items) {
            result = NEW sn_class_list.sn_ctor_sn_class_list(
                lst_structs.name.sort(it), lst_structs.size(), FALSE);
        } else {
            result = NEW sn_class_list.sn_ctor_sn_class_list(
                {}, lst_structs.size(), TRUE);
        };
	//print result.lst_s_classes;

    };
    
};

extend global {
    register_jb_services() is also {
        p_classbrowser.register_service();
    };
};

struct sn_classbrowser_deli {
    p_jclassbrowser_service: sni_jclassbrowser_service;
        
    ctor() is {
        p_jclassbrowser_service = NULL;
    };
    
    is_service_active(): bool is {
        result = (p_jclassbrowser_service != NULL);
    };
    
    p_get_service(): sni_jclassbrowser_service is {
        
        if (p_jclassbrowser_service == NULL) {
            
            var s_err: string = 
                jspecview_deli.start_japp_class(
                "com.verisity.classbrowser.JClassBrowserService");
            
            if (s_err != "") { 
                error("Failed starting classbrowser : ", s_err); 
            } else {
                // out("Started JClassBrowser");
            };
            
            p_jclassbrowser_service =
                orb lookup service sni_jclassbrowser_service 
                JCLASSBROWSER_SERVICE_NAME;
            
            ASSERT(p_jclassbrowser_service != NULL);
                
        };
        
        result = p_jclassbrowser_service;
    };
    
    show_class_browser(s_class: string) is {

        //var class_content_node: sn_class_content_node_info = 
        //    p_classbrowser.p_eclassbrowser_service.get_class_content_node(
        //    s_class,TRUE);
        //
        //ASSERT(class_content_node != NULL);
        //  
        //p_get_service().open_class_browser(class_content_node);
        p_get_service().open_class_browser(s_class);
    };
    
    refresh() is {
        if (is_service_active()) {

            p_get_service().refresh_class();
        };
    };
    
    
};
    
extend sn_class_list {
    ctor() is {
    };
};
    

struct sn_class_content_node_model like sni_class_content_node_model {
    
    p_member: source_item;
    p_td: type_descriptor;
    p_lst_member_children: list of source_item;
    p_children: list of sn_class_content_node_info;
    p_f_extention: bool;
    
    ctor_member(a_member: source_item, f_extention: bool) is {
        p_member = a_member;
        
        p_f_extention = f_extention;
     
        if p_member is a field (F) {
            me.p_ctor(F.base_type);
        } else {
            me.p_ctor(NULL);
        };
    };
    
    ctor_stct(sd: struct_descriptor) is {
        me.p_ctor(sd);
    };
    
    p_ctor(td: type_descriptor) is {
        p_td= td;
        
        p_create_children();
    };

    p_get_member_name(): string is {
        if (p_member == NULL) {
            result = "";
            
        } else if p_member is a field (F) {
            result = F.name;
            
        } else if p_member is a method (M) {
            if (p_is_extention()) {
                result = appendf("%s() %s%s [%s]: %s", 
                    M.name, M.kind == is ? "" : "is ", M.kind, M.Context_struct.name, M.source_ref);
            } else {
                result = M.name;
            };
            
        } else if p_member is a event_type (E) {
            result = E.event_name;
            
        } else if p_member is a gen_constraint (C) {
            result = files.source_item_to_clear_line(C);
            
        } else if p_member is a sn_cover_group_descriptor (CG) {
            result = CG.name;
            
        } else if p_member is a sn_cover_item_descriptor (I) {
            result = I.name;
            
        };

    };
    
    p_get_type_name(): string is {
        if (p_td != NULL) {
            result = p_td.name;
        };
    };
    
    p_get_atomic_type_name(): string is {
        if (p_td != NULL) {
            result = p_td.elem_type().name;
        };
    };
    
    p_is_leaf(): bool is {
        result = (p_lst_member_children.is_empty());
    };
    
    p_is_when(): bool is {
        // leat means: not a list, nor a struct
        if (p_td != NULL) {
            result = (p_td.as_a(subtype_descriptor) != NULL);
        } else {
            result = FALSE;
        };
            
    };

    p_is_list(): bool is {
        if (p_td != NULL) {
            result = p_td.is_a_list();
        } else {
            result = FALSE;
        };
    };
    
    p_get_kind(): int is {
        if (p_td == NULL) {
            result = KIND_UNDEF;
        } else {
            result = p_classbrowser.p_eclassbrowser_service.p_get_struct_kind(
                p_td.elem_type(), p_member);
        };
    };
    
    p_get_member_kind(): int is {
        result = p_classbrowser.p_eclassbrowser_service.p_get_member_kind(p_member);
    };

    p_get_source_ref(): source_ref is {
        result = (p_td != NULL ? p_td.source_ref : -1);
    };
    
    p_get_member_source_ref(): source_ref is {
        result = (p_member != NULL ? p_member.source_ref : -1);
    };

    p_is_extention(): bool is {
        result = p_f_extention;
    };
    
    p_is_backpointer(): bool is {
        if ((p_member != NULL) and (p_member.as_a(field) != NULL)) {
            // its a field
            var F: field = p_member.as_a(field);
            
            // if this is a unit - we do not chanfe back-pointer
            if (p_td.is_unit()) {
                return FALSE;
            };
            
            result = p_jbrowsers.is_backpointer_field(F);
           
        } else {
            return FALSE;
        };
    };
    
    p_is_null(): bool is {
        if (p_member == NULL) {
            result = FALSE;
            
        } else if p_member is a method (M) {
            result = (M.kind == undefined);
                
        } else {
            result = FALSE;
        };
    };
    
    p_get_description(): string is {
        result = "";
        
        // try {
        //     if p_member is a field (F) {
        //         result = F.extract_comment();
        //     } else if p_member is a method (M) {
        //         result = append(
        //             M.get_full_str(), "\n",
        //             M.extract_comment());
        //     } else if (p_td != NULL) {
        //         result = p_td.extract_comment();
        //     };
        // };
    };
    
    is_method(): bool is {
        result = (p_member != NULL) and (p_member.as_a(method) != NULL);
    };
    
    get_children(): list of sn_class_content_node_info is {
        
        if ( (p_lst_member_children.size() > 0) and
            (p_children.is_empty())) {
            
            var node_info: sn_class_content_node_info;
            var f_extention: bool = is_method();
            for each (st_member) in p_lst_member_children {
                
                node_info = NEW sn_class_content_node_info.ctor_member(st_member, f_extention);
                p_children.add(node_info);
                
            };
        };
            
        //print p_children.p_s_member;
        result = p_children;
        
    };
    

    p_create_children() is {
        
        if(p_td != NULL) {
        
            // this a a pure struct or field
            var td: type_descriptor = p_td.elem_type();
            
            if (td.is_a_struct()) {
                var sd: struct_descriptor = td.as_a(struct_descriptor);
                
                ASSERT(sd != NULL);
                

                // take fields
                var lst_raw_fields: list of field = 
                    p_reflection_manager.get_active_struct_fields(sd);
                var lst_fields: list of field;
                for each (F) in lst_raw_fields {
                    lst_fields.add(F);
                };
                
                if (get_config(jbrowsers, fields_wildcard_filter_policy) == hide_matching) {
                    // filter out ll matches
                    lst_fields = lst_fields.all(! p_jbrowsers.is_filter_wildcard_field(it));
                } else if (get_config(jbrowsers, fields_wildcard_filter_policy) == show_matching) {
                    // filter in only matches
                    lst_fields = lst_fields.all(p_jbrowsers.is_filter_wildcard_field(it));
                };
                
                if (get_config(jbrowsers, fields_type_filter_policy) == hide_matching) {
                    // filter out ll matches
                    lst_fields = lst_fields.all(! p_jbrowsers.is_filter_type_field(it));
                } else if (get_config(jbrowsers, fields_type_filter_policy) == show_matching) {
                    // filter in only matches
                    lst_fields = lst_fields.all(p_jbrowsers.is_filter_type_field(it));
                };
            
                
                
                
                // take constraints
                var lst_constraints: list of gen_constraint = 
                    p_reflection_manager.get_active_struct_constraints(sd);
                
                
                // take events
                var lst_events: list of event_type = 
                    p_reflection_manager.get_active_struct_events(sd);
                

                // take covergroups
                var lst_covergroups: list of sn_cover_group_descriptor = 
                    p_reflection_manager.get_active_struct_covergroups(sd);
                

                
                // take methods
                var lst_methods: list of method;
                if (get_config(jbrowsers, show_methods)) {
                    lst_methods = p_reflection_manager.get_active_struct_methods(sd);
                    
                    var lst_srcref_events : list of source_ref = lst_events.source_ref;
                    lst_srcref_events.add(lst_covergroups.source_ref);
                    
                    lst_methods = lst_methods.all(
                        ! (it.source_ref in lst_srcref_events));
                
                };
                
                if (get_config(jbrowsers, show_fields)) {
                    for each (F) in lst_fields {
                        p_lst_member_children.add(F);
                    };
                };
                
                
                if (get_config(jbrowsers, show_constraints)) {
                    for each (C) in lst_constraints {
                        p_lst_member_children.add(C);
                    };
                };
                
                if (get_config(jbrowsers, show_methods)) {
                
                    for each (M) in lst_methods {
                        p_lst_member_children.add(M);
                    };
                };
                
                if (get_config(jbrowsers, show_events)) {
                    for each (E) in lst_events {
                        p_lst_member_children.add(E);
                    };
                };
                
                if (get_config(jbrowsers, show_cover)) {
                    for each (CG) in lst_covergroups {
                        p_lst_member_children.add(CG);
                    };
                };    
                
                if (! get_config(jbrowsers, sort_by_member)) {
                    
                    p_lst_member_children = p_lst_member_children.sort(.source_ref);
                };
                    

                
                // take cover items
                //var lst_methods: list of method = 
                //    p_reflection_manager.get_active_struct_methods(sd);
                //
                //for each (M) in lst_methods {
                //    p_lst_member_children.add(M);
                //};
                
            };
        } else if p_member is a sn_cover_group_descriptor (covegroup) {
            // cover group - add cover items
            var lst_coveritems: list of sn_cover_item_descriptor = 
                covegroup.item_descriptors;
                
            for each (coveritem) in lst_coveritems {
                p_lst_member_children.add(coveritem);
            };
            
        } else if ((p_member.as_a(method) != NULL) and (! p_f_extention)) {
            // a method - add method extention
            var m: method = p_member.as_a(method);
            var sd: struct_descriptor = m.Context_struct;
                
            var lst_methods: list of method = 
                p_reflection_manager.get_method_extentions(m, sd);
            
            if (lst_methods.size() > 1) {
                //
                p_lst_member_children.add(
                    p_reflection_manager.get_method_extentions(m, sd));
            };
            
        };
    };
    
};
    

extend sn_class_content_node_info {
    
    ctor_member(member: source_item, f_extention: bool) is {
        p_content_node_model = 
            NEW sn_class_content_node_model.ctor_member(member, f_extention);
        me.p_ctor();
    };
    
    ctor_stct(sd: struct_descriptor) is {
        p_content_node_model = NEW sn_class_content_node_model.ctor_stct(sd);
        me.p_ctor();
    };
    
    p_ctor() is {
        var node_model: sn_class_content_node_model= 
            p_content_node_model.as_a(sn_class_content_node_model);
        
        ASSERT(node_model != NULL);
        
        p_s_member = node_model.p_get_member_name();
        p_s_type = node_model.p_get_type_name();
        p_s_atomic_type = node_model.p_get_atomic_type_name();
        p_f_leaf = node_model.p_is_leaf();
        p_f_list = node_model.p_is_list();
        p_f_when = node_model.p_is_when();
        p_n_kind = node_model.p_get_kind();
        p_n_member_kind = node_model.p_get_member_kind();
        p_n_source_ref = node_model.p_get_source_ref();
        p_n_member_source_ref = node_model.p_get_member_source_ref();
        p_f_null = node_model.p_is_null();
        p_f_extention = node_model.p_is_extention();
        p_f_backpointer = node_model.p_is_backpointer();
        p_s_description = node_model.p_get_description();
        
    };
    
};

    
    
'>


<> Inheritance tree

<'



struct sn_class_inherit_node_model like sni_class_inherit_node_model {
    
    p_sd: struct_descriptor;
    p_lst_sd_children: list of struct_descriptor;
    p_children: list of sn_class_inherit_node_info;
    p_lst_sd_ancestors: list of struct_descriptor;
    p_ancestors: list of sn_class_inherit_node_info;
    
    ctor(sd: struct_descriptor) is {
        p_sd = sd;
        
        p_create_sd_children();        
        p_create_sd_ancestors();        
    };

    p_get_type_name(): string is {
        result = p_sd.name;
    };
    
    p_get_atomic_type_name(): string is {
        if (p_sd != NULL) {
            result = p_sd.elem_type().name;
        };
    };
    
    p_is_leaf(): bool is {
        result = (p_lst_sd_children.is_empty());
    };
    
    p_is_when(): bool is {
        // leat means: not a list, nor a struct
        result = (p_sd.as_a(subtype_descriptor) != NULL);
            
    };

    p_is_list(): bool is {
        result = p_sd.is_a_list();
    };
    
    p_get_source_ref(): source_ref is {
        result = (p_sd != NULL ? p_sd.source_ref : -1);
    };
    
    
    p_get_kind(): int is {
        result = p_classbrowser.p_eclassbrowser_service.p_get_struct_kind(
            p_sd.elem_type(), NULL);
    };
    
    p_get_description(): string is {
        //result = p_sd.extract_comment();
        result = "";
    };
    
    get_children(): list of sn_class_inherit_node_info is {
        
        if ( (p_lst_sd_children.size() > 0) and
            (p_children.is_empty())) {
            
            for each (sd) in p_lst_sd_children {
                var node_info: sn_class_inherit_node_info = 
                    NEW sn_class_inherit_node_info.ctor(sd);
                
                p_children.add(node_info);
            };
        };
        
        result = p_children;
        
    };
    
    p_create_sd_children() is {
        
        ASSERT(p_sd != NULL);
        
        if p_sd.is_subtype() {
            
            p_lst_sd_children.clear();
            
        } else {
        
            var lst_like_children: list of struct_descriptor;
            var lst_when_children: list of struct_descriptor;
            
            for each (ch) in p_sd.children {
                if ch.is_subtype() then {
                    lst_when_children.add(ch);
                } else {
                    if (ch.parent == p_sd) {
                        lst_like_children.add(ch);
                    };
                };
            };
            
            var lst_children: list of struct_descriptor;
            if (! lst_like_children.is_empty()) {
                lst_children = lst_like_children;
            } else {
                lst_children = lst_when_children;
            };
            
            for each (ch) in lst_children {
                p_lst_sd_children.add(ch);
            };

            // FILTER
            if (get_config(jbrowsers, subclasses_wildcard_filter_policy) == hide_matching) {
                // filter out ll matches
                p_lst_sd_children = p_lst_sd_children.all(! p_jbrowsers.is_filter_wildcard_subclass(it));
            } else if (get_config(jbrowsers, subclasses_wildcard_filter_policy) == show_matching) {
                // filter in only matches
                p_lst_sd_children = p_lst_sd_children.all(p_jbrowsers.is_filter_wildcard_subclass(it));
            };
            
        };
        
    };
    
    get_ancestors(): list of sn_class_inherit_node_info is {
        
        if ( (p_lst_sd_ancestors.size() > 0) and
            (p_ancestors.is_empty())) {
            
            for each (sd) in p_lst_sd_ancestors {
                var node_info: sn_class_inherit_node_info = 
                    NEW sn_class_inherit_node_info.ctor(sd);
                
                p_ancestors.add(node_info);
            };
        };
        
        result = p_ancestors;
        
    };
    
    p_create_sd_ancestors() is {
        
        ASSERT(p_sd != NULL);
        
        //print p_sd.name;
        
        var lst_ancestors: list of struct_descriptor;
        var sd: struct_descriptor = p_sd;
        while (sd.parent != NULL) {
            sd = sd.parent.as_a(struct_descriptor);
            ASSERT(sd != NULL);
            if ((session.get_developer_mode() != none) ||
                (type_is_a_child_of(sd, p_reflection_manager.sd_any_struct))) {
                
                lst_ancestors.add(sd);
            };
        };

        p_lst_sd_ancestors = lst_ancestors.reverse();
        //print p_lst_sd_ancestors;
        
    };
            
};

extend sn_class_inherit_node_info {
    
    ctor(sd: struct_descriptor)is {
        //print 666;
        p_inherit_node_model = NEW sn_class_inherit_node_model.ctor(sd);
        //print 777;
        
        var node_model: sn_class_inherit_node_model= 
            p_inherit_node_model.as_a(sn_class_inherit_node_model);
        
        ASSERT(node_model != NULL);
        
        p_s_type = node_model.p_get_type_name();
        p_s_atomic_type = node_model.p_get_atomic_type_name();
        p_f_leaf = node_model.p_is_leaf();
        p_f_list = node_model.p_is_list();
        p_f_when = node_model.p_is_when();
        p_n_kind = node_model.p_get_kind();
        p_n_source_ref = node_model.p_get_source_ref();
        p_s_description = node_model.p_get_description();
    };
    
};

extend global {
    post_load_command_actions() is also {
        if (p_classbrowser != NULL) {
            p_classbrowser.raise_dirty_flag();
        };
    };
    
    screen_prompt(s: string, do_command: bool) : string is first {  
        if (p_classbrowser != NULL) {
            p_classbrowser.refresh_if_dirty();
        };
    };
};


//display user menu separator;
//display user menu "show class ..." "show class";
//display user menu "show class sys" "show class sys";
//display user menu separator;
//display user menu "@load" "@load.ecom";

extend jbrowsers config_options {

    
    pre_store_to_system(option : string, value : string)  is also {

        if (option != "source_width") {
            p_classbrowser.raise_dirty_flag();
        };
        
                
    };	 
};


'>

