<'

define JCLASSBROWSER_SERVICE_NAME "JCLASSBROWSER";
define ECLASSBROWSER_SERVICE_NAME "ECLASSBROWSER";


// the Java classbrowser service
orb interface sni_jclassbrowser_service 
    using package=com.verisity.classbrowser.model.gencode {
    
    //open_class_browser(class_content_node: sn_class_content_node_info) is sync;
    open_class_browser(s_class_name: string) is sync;

    refresh_class() is async;
    
};

struct sn_class_list {
    lst_s_classes: list of string;
    n_size: int;
    f_too_long: bool;
};
    
orb data sn_class_list
    using package=com.verisity.classbrowser.model.gencode ;


// the e classbrowser service
orb interface sni_eclassbrowser_service 
    using package=com.verisity.classbrowser.model.gencode {
    
    get_class_content_node(s_class: string, 
        f_give_error: bool): sn_class_content_node_info is sync;
    
    get_class_inherit_node(s_class: string, 
        f_give_error: bool): sn_class_inherit_node_info is sync;
    
    is_class_exists(s_class: string): bool is sync;
    
    get_top_class_inherit(): sn_class_inherit_node_info is sync;
    
    get_source(n_source_ref: int): list of string is sync;

    show_source(n_source_ref: int) is sync;
    
    get_matching_classes(s_re: string, n_max_items: int): sn_class_list is sync;
    
    set_config_bool(s_category: string, s_option: string, f_val: bool) is sync;		    
};


'>


<>  Class Contents
<'

// the main node model that represent one class content
orb interface sni_class_content_node_model  
    using package=com.verisity.classbrowser.model.gencode {
    
    get_children(): list of sn_class_content_node_info is sync

};

struct sn_class_content_node_info {
    p_content_node_model: sni_class_content_node_model;
    p_s_member: string;
    p_s_type: string;
    p_s_atomic_type: string;
    p_f_list: bool;
    p_f_leaf: bool;
    p_f_when: bool;
    p_n_kind: int;
    p_n_member_kind: int;
    p_n_source_ref: int;
    p_n_member_source_ref: int;
    p_f_null: bool;
    p_f_extention: bool;
    p_f_backpointer: bool;
    p_s_description: string;
};

orb data sn_class_content_node_info 
    using package=com.verisity.classbrowser.model.gencode ;

    
    
'>

<>  Class Inheritance

<'

// the main node model that represent one class inheritance
orb interface sni_class_inherit_node_model  
    using package=com.verisity.classbrowser.model.gencode {
    
    get_children(): list of sn_class_inherit_node_info is sync;
    get_ancestors(): list of sn_class_inherit_node_info is sync;
        
};

// The data children related for one class inheritance
struct sn_class_inherit_node_info {
    p_inherit_node_model: sni_class_inherit_node_model;
    p_s_type: string;
    p_s_atomic_type: string;
    p_f_list: bool;
    p_f_leaf: bool;
    p_f_when: bool;
    p_n_kind: int;
    p_n_source_ref: int;
    p_s_description: string;
    
};

orb data sn_class_inherit_node_info 
    using package=com.verisity.classbrowser.model.gencode ;
    
    
'>
