
    
<'

extend display {
    custom_menu_clicked(s_menu_key: string, s_menu_item_key: string, 
        s_menu_item_label: string, s_optional_param: string) is {
        dbg_out(debug.tk, appendf("Clicked Menu %s, Item %s, Label: %s, Param: %s", 
            s_menu_key, s_menu_item_key, s_menu_item_label, s_optional_param));
    };
};

extend debug {
    tk: bool;
};

extend display{
    is_custom_menu_exists(s_menu_key: string): bool is {
        
        if (! display.on) {
            return FALSE;
        };

        var s_menu_top: string = append(".main0.b0.", s_menu_key);
        var s_menu_name: string = append(s_menu_top, ".m");

        result = display.widget_exist(s_menu_name);
    };

    add_custom_menu(s_menu_key: string, s_menu_label: string,
        n_accelerator_index: int) is {

        if (! display.on) {
            return;
        };
        
        if (! is_custom_menu_exists(s_menu_key)) {

            var s_menu_top: string = append(".main0.b0.", s_menu_key);
            var s_menu_name: string = append(s_menu_top, ".m");

            var s_label: string = display.quote(s_menu_label);
            var s_accelerator: string = 
                (n_accelerator_index >= 0 ? 
                appendf(" -underline %s ", str_dec(n_accelerator_index)) : "");
                 
        
            var tk_cmd: string = appendf(
                "menubutton %s -text %s %s -font {%s} -menu %s ; menu %s -tearoff 0 ; pack %s -before .main0.b0.help -side left",
                s_menu_top, s_label, s_accelerator,
                display.menu_font, s_menu_name, s_menu_name, s_menu_top);
            do_tk(tk_cmd);
        };
    };
    
    remove_custom_menu(s_menu_key: string) is {
        
        if (is_custom_menu_exists(s_menu_key)) {
            var s_menu_top: string = append(".main0.b0.", s_menu_key);
            var tk_cmd: string = append("destroy ", s_menu_top);
            do_tk(tk_cmd);
        };
    };
    
    update_custom_menu_item(s_menu_key: string, n_menu_item_index: int,
        s_menu_item_key: string,
        s_menu_item_label: string, s_optional_param: string) is {
        
        if (! display.on) {
            return;
        };
        
        if (is_custom_menu_exists(s_menu_key)) {
            var s_menu_top: string = append(".main0.b0.", s_menu_key);
            var s_menu_name: string = append(s_menu_top, ".m");
            
            var s_command: string = get_custom_menu_item_cmd(
                s_menu_key, s_menu_item_key, s_menu_item_label, s_optional_param);
        
            var s_label: string = display.quote(s_menu_item_label);
            var tk_cmd: string = appendf("%s entryconfigure %d -label %s -command {%s}",
                s_menu_name, n_menu_item_index, s_label, s_command);
            do_tk(tk_cmd);
        };
    };

    get_custom_menu_item_cmd(s_menu_key: string, s_menu_item_key: string,
        s_menu_item_label: string, s_optional_param: string): string is {
            
        var s_callback: string = appendf(
            "display.custom_menu_clicked(\"%s\", \"%s\", \"%s\", \"%s\")",  
            s_menu_key, s_menu_item_key, s_menu_item_label, s_optional_param);
        
        result = appendf("sn_command2 {%s} specman 0 1", s_callback);
    };
            
            
    add_custom_menu_separator(s_menu_key: string) is {
        
        if (! display.on) {
            return;
        };
        
        if (is_custom_menu_exists(s_menu_key)) {
            var s_menu_top: string = append(".main0.b0.", s_menu_key);
            var s_menu_name: string = append(s_menu_top, ".m");
            
            var tk_cmd: string = appendf("%s add separator", s_menu_name);
            do_tk(tk_cmd);
        };
    };

    add_custom_menu_item(s_menu_key: string, s_menu_item_key: string,
        s_menu_item_label: string, s_optional_param: string,
        n_accelerator_index: int) is {
        
        if (! display.on) {
            return;
        };
        
        if (is_custom_menu_exists(s_menu_key)) {

            var s_menu_top: string = append(".main0.b0.", s_menu_key);
            var s_menu_name: string = append(s_menu_top, ".m");
        
            var s_command: string = get_custom_menu_item_cmd(
                s_menu_key, s_menu_item_key, s_menu_item_label, s_optional_param);
            
            var s_label: string = display.quote(s_menu_item_label);
            var s_accelerator: string = 
                (n_accelerator_index >= 0 ? 
                appendf(" -underline %s ", str_dec(n_accelerator_index)) : "");
            
            var tk_cmd: string = appendf("%s add command -label %s %s -command {%s} -font {%s}", 
                s_menu_name, s_label, s_accelerator, s_command, display.menu_font);
            
            do_tk(tk_cmd);
        };
    };

    do_tk(tk_cmd: string) is {
        dbg_out(debug.tk, tk_cmd);
        tk(tk_cmd);
    };
};


'>
