<'

import ../jbrowsers/jbrowsers.e;

define <show_data'command> "show data[ <any>]" as {
    
    //out(p_databrowser.evaluate(str_expand_dots("<any|sys>")));
    p_databrowser.p_databrowser_deli.show_data_browser(str_expand_dots("<any>"));
        
};

//define <show_data_by_input'command> "show data" as {
//
//    do {
//        var tcl_cmd := appendf("[get_input %s {%s} {%s} 40 {%s} ]",
//            ".main0", "Input Window", "Enter expression to evaluate and show in Data Browser:", "");
//        var s_data := display.get_tcl_exp_value(tcl_cmd);
//        
//        if (s_data != "__@CANCEL@__") then {
//            
//            p_databrowser.p_databrowser_deli.show_data_browser(s_data);
//        };
//        
//    };
//};

extend global {
    
    p_databrowser: sn_databrowser;
    
    init() is also {
        p_databrowser = NEW sn_databrowser.ctor();
    };
    
};

struct sn_databrowser {
    
    p_databrowser_deli: sn_databrowser_deli;
    p_edatabrowser_service: sn_edatabrowser_service;
    p_dirty: bool;

    ctor() is {
        p_databrowser_deli = NEW sn_databrowser_deli.ctor();
        p_edatabrowser_service = NEW sn_edatabrowser_service.ctor();
        
    };
    
    register_service() is {
        orb register service p_edatabrowser_service 
            sni_edatabrowser_service 
            EDATABROWSER_SERVICE_NAME;
        
    };
    
    raise_dirty_flag() is {
        p_dirty = TRUE;
    };
    
    refresh_if_dirty() is {
        if (p_dirty) {
            p_dirty = FALSE;
            if (p_databrowser_deli != NULL) {
                p_databrowser_deli.refresh();            
            };
        };
    };
    
    
};

extend sn_jbrowsers {
    raise_dirty_flag() is also {
        p_databrowser.raise_dirty_flag();
    };
    
    refresh_if_dirty() is also {
        p_databrowser.refresh_if_dirty();
    };
};


struct sn_edatabrowser_service like sni_edatabrowser_service {
    
    ctor() is {
        ;        
    };

    get_data_node(s_exp: string): sn_data_node_info is {
        if (! is_legal_exp(s_exp)) {
            result = NULL;
        } else {
            result = NEW sn_data_node_info.ctor(s_exp);
        };
    };
    
    is_legal_exp(s_exp: string): bool is {
        result = p_databrowser.p_is_legal_exp(s_exp);
    };
};

extend global {
    register_jb_services() is also {
        p_databrowser.register_service();
    };
};


define <shortcut_show_data'exp> "SDB <any>" as {
    p_databrowser.p_edatabrowser_service.get_data_node(str_expand_dots("<any>"))
};

struct sn_databrowser_deli {
    p_jdatabrowser_service: sni_jdatabrowser_service;
        
    ctor() is {
        p_jdatabrowser_service = NULL;
    };
    
    is_service_active(): bool is {
        result = (p_jdatabrowser_service != NULL);
    };
    
    p_get_service(): sni_jdatabrowser_service is {
        
        if (p_jdatabrowser_service == NULL) {
            
            var s_err: string = 
                jspecview_deli.start_japp_class(
                "com.verisity.databrowser.JDataBrowserService");
            
            if (s_err != "") { 
                error("Failed starting databrowser : ", s_err); 
            } else {
                // out("Started JDataBrowser");
            };
            
            p_jdatabrowser_service =
                orb lookup service sni_jdatabrowser_service 
                JDATABROWSER_SERVICE_NAME;
            
            ASSERT(p_jdatabrowser_service != NULL);
                
        };
        
        result = p_jdatabrowser_service;
    };
    
    show_data_browser(s_exp: string) is {

        p_get_service().open_data_browser(s_exp);
    };
    
    refresh() is {
        if (is_service_active()) {
            p_get_service().refresh_data();
        };
    };
    
};
    


struct sn_data_node_model like sni_data_node_model {
    p_s_exp: string;
    p_field: field;
    p_td: type_descriptor;
    p_n_list_size: int;
    p_s_value: string;
    p_lst_field_children: list of field;
    
    p_children: list of sn_data_node_info;
    
    ctor(s_exp: string, a_field: field) is {
        // print 1, s_exp;
        p_s_exp = s_exp;
        p_field = a_field;
        //out("Create model for: ", s_exp);
        var databrowser_value : sn_databrowser_value = p_databrowser.evaluate(s_exp);
        
        ASSERT(databrowser_value != NULL);
        p_td = databrowser_value.p_td;
        p_s_value = databrowser_value.p_s_value;
        p_n_list_size = databrowser_value.p_n_list_size;

        if (p_is_list() or p_is_scalar() or (p_get_value() == "NULL")) {
            p_lst_field_children.clear();
        } else {
            // a struct with fields
            p_lst_field_children = databrowser_value.p_lst_fields;
            
            if (get_config(jbrowsers, fields_wildcard_filter_policy) == hide_matching) {
                // filter out ll matches
                p_lst_field_children = p_lst_field_children.all(! p_jbrowsers.is_filter_wildcard_field(it));
            } else if (get_config(jbrowsers, fields_wildcard_filter_policy) == show_matching) {
                // filter in only matches
                p_lst_field_children = p_lst_field_children.all(p_jbrowsers.is_filter_wildcard_field(it));
            };
            
            if (get_config(jbrowsers, fields_type_filter_policy) == hide_matching) {
                // filter out ll matches
                p_lst_field_children = p_lst_field_children.all(! p_jbrowsers.is_filter_type_field(it));
            } else if (get_config(jbrowsers, fields_type_filter_policy) == show_matching) {
                // filter in only matches
                p_lst_field_children = p_lst_field_children.all(p_jbrowsers.is_filter_type_field(it));
            };

        };

    };
    
    p_get_type_name(): string is {
        result = p_td.elem_type().name;
    };
    
    p_is_null(): bool is {
        
        if (p_is_list()) {
            result = (p_n_list_size == 0);
            
        } else if (p_is_scalar()) {
            result = FALSE;
            
        } else {
            // struct
            result = (p_s_value == "NULL");
        };
    };
    
    p_get_value(): string is {
        if (p_is_list()) {
            // a list 
            if (p_n_list_size > 0) {
                result = appendf("%d item%s", 
                    p_n_list_size,
                    (p_n_list_size > 1) ? "s" : "");

            } else {
                result = "(empty)";
            };
        } else {
            if (p_is_scalar()) {
                // a scalar
                if (p_td.name == "string") {
                    result = append("\"", p_s_value, "\"");
                } else {
                    result = p_s_value;
                };
                
            } else {
                // a struct
                if (get_config(jbrowsers, show_inst_name)) {
                    result = p_s_value;
                };
            };
        };
    };
    
    p_is_leaf(): bool is {
        if (p_is_list()) {
            
            result = (p_n_list_size == 0);
                
        } else {

            result = (p_lst_field_children.size() == 0);
        };
        
            
    };
    
    p_is_when(): bool is {
        // leat means: not a list, nor a struct
        result = (p_td.as_a(subtype_descriptor) != NULL);
            
    };

    p_get_kind(): int is {
        var td: type_descriptor = p_td.elem_type();
        
        if (td.is_unit()) {
            var f_instance: bool;
            if (p_field == NULL) {
                f_instance = TRUE;
            } else {
                f_instance = p_field.is_instance;
            };
            
            if (f_instance) {
                result = KIND_UNIT_INSTANCE;
            } else {
                result = KIND_UNIT_REF;
            };
        } else if td.is_a_struct() {
            result = KIND_STRUCT;
        } else {
            result = KIND_SCALAR;
        };
    };
    
    p_get_source_ref(): source_ref is {
        result = (p_td != NULL ? p_td.source_ref : -1);
    };
    
    p_get_member_source_ref(): source_ref is {
        result = (p_field != NULL ? p_field.source_ref : -1);
    };
    
    p_get_size(): int is {
        if (p_is_list()) {
            result = p_n_list_size;
        } else {
            result = p_get_num_fields();
        };
    };
        
    p_is_scalar(): bool is {
        result = (p_get_kind() == KIND_SCALAR);
    };
    
    p_is_list(): bool is {
        result = (p_td.as_a(list_descriptor) != NULL);
    };
    
    p_get_list_size(): int is {
        result = p_n_list_size;
    };
    
    p_get_num_fields(): int is {
        result = p_lst_field_children.size();
    };
        
    get_children(): list of sn_data_node_info is {
        var s_child_exp: string;
        var s_field: string;
        var a_field: field;
        if (p_is_list()) {
            // this is a list
            //out("Create ", p_n_list_size ," children of list ",p_s_exp);
            if (p_children.is_empty()) {
                for i from 0 to (p_n_list_size - 1) {
                    s_child_exp = appendf("%s[%d]", p_s_exp, i);
                    s_field = (p_field == NULL ?
                        "" : appendf("%s[%d]", p_field.name, i));
                    
                    var node_info: sn_data_node_info = 
                        NEW sn_data_node_info.ctor_field(
                        s_child_exp, p_field, s_field);
                    
                    p_children.add(node_info);
                };
            };
            
        } else {

            // out("Create ", p_lst_field_children.size() ," fields of struct ",p_s_exp);
            
            //this is a structs ==> 'childrens' are fields
            if ( (p_lst_field_children.size() > 0) and
                (p_children.is_empty())) {
            
                for each (F) in p_lst_field_children {
                    s_child_exp = appendf("%s.%s", p_s_exp, F.name);
                    var node_info: sn_data_node_info = 
                        NEW sn_data_node_info.ctor_field(s_child_exp, F, F.short_name);
                    
                    p_children.add(node_info);

                };
            };
        };
        
        result = p_children;
    };
    
    p_get_description(): string is {
        result = "";
        
        // try {
        //     if (p_field == NULL) {
        //         result = p_td.extract_comment();
        //     } else {
        //         result = p_field.extract_comment();
        //     };
        // };
    };
    
    p_create_field_children() is {
        
        ASSERT(p_td != NULL);
        ASSERT(! p_is_list());
        
        var td: type_descriptor = p_td;
        var sd: struct_descriptor = NULL;
        
        //if td is a subtype_descriptor (subt) {
        //    sd = subt.subtype_parent();
        //} else if td is a struct_descriptor (real_sd) {
        //    sd = real_sd;
        //};
        
        
            
        if td.is_a_struct() {        
            
            var sd: struct_descriptor = td.as_a(struct_descriptor);
            
            //if (sd != NULL) {
            var sd_parent: struct_descriptor;
            if sd.is_subtype() {
                var subt: subtype_descriptor = sd.as_a(subtype_descriptor);
                sd_parent = subt.subtype_parent();
            } else {
                sd_parent = sd;
            };
            
            var lst_fields: list of field = sd.fields.all(
                (it != NULL) and 
                (! name_is_private(.name)) and
                (.Context_struct != NULL) and
                (type_is_a_child_of(it.Context_struct, sd_parent)) and
                (type_is_a_child_of(sd, it.Context_struct))
                );
            
            //out("Prepare ", lst_fields.size() ," fields of struct ",p_s_exp);
            
            lst_fields = sd.get_subtype_fields("//");
            lst_fields.add(sd.fields.all(
                (it != NULL) and 
                (! name_is_private(.name)) and
                (.Context_struct != NULL) and
                (.Context_struct == sd_parent)
                ));
                
            //print p_reflection_manager.get_active_fields(sys.x);
                
            for each (F) in lst_fields {

                p_lst_field_children.add(F);
            };
            
            if (get_config(jbrowsers, fields_wildcard_filter_policy) == hide_matching) {
                // filter out ll matches
                p_lst_field_children = p_lst_field_children.all(! p_jbrowsers.is_filter_wildcard_field(it));
            } else if (get_config(jbrowsers, fields_wildcard_filter_policy) == show_matching) {
                // filter in only matches
                p_lst_field_children = p_lst_field_children.all(p_jbrowsers.is_filter_wildcard_field(it));
            };
            
            if (get_config(jbrowsers, fields_type_filter_policy) == hide_matching) {
                // filter out ll matches
                p_lst_field_children = p_lst_field_children.all(! p_jbrowsers.is_filter_type_field(it));
            } else if (get_config(jbrowsers, fields_type_filter_policy) == show_matching) {
                // filter in only matches
                p_lst_field_children = p_lst_field_children.all(p_jbrowsers.is_filter_type_field(it));
            };

            
            
        };
        // print p_lst_field_children;
            
    };
};

    
extend sn_data_node_info {
    
    ctor_field(s_exp: string, a_field: field, s_field: string) is {
        // s_field might be not the field name but a
        // variant (e.g. packets[4])
        p_ctor(s_exp, a_field, s_field);
    };
        
    ctor(s_exp: string) is {
        p_ctor(s_exp, NULL, "");
    };

    p_ctor(s_exp: string, a_field: field, s_member: string) is {
        // print s_exp;
        p_node_model = NEW sn_data_node_model.ctor(s_exp, a_field);
        
        var node_model: sn_data_node_model= 
            p_node_model.as_a(sn_data_node_model);
        
        ASSERT(node_model != NULL);
        
        p_s_exp = s_exp;
        p_s_value = node_model.p_get_value();
        p_s_type = node_model.p_get_type_name();
        p_s_member = s_member;
        p_f_leaf = node_model.p_is_leaf();
        p_f_when = node_model.p_is_when();
        p_n_kind = node_model.p_get_kind();
        p_n_source_ref = node_model.p_get_source_ref();
        p_n_member_source_ref = node_model.p_get_member_source_ref();
        p_n_size = node_model.p_get_size();
        p_f_list = node_model.p_is_list();
        p_f_null = node_model.p_is_null();
        p_s_description = node_model.p_get_description();
        
    };
    
};





struct sn_databrowser_value {
    p_s_value: string;
    p_td: type_descriptor;
    p_n_list_size: int;
    p_lst_fields: list of field;
    
    ctor_list(s_value: string, td: type_descriptor, n_list_size: int) is {
        p_lst_fields.clear();
        p_ctor(s_value, td, n_list_size, p_lst_fields);
    };
        
    ctor(s_value: string, td: type_descriptor, lst_fields: list of field) is {
        p_ctor(s_value, td, 0, lst_fields);
    };
    
    p_ctor(s_value: string, td: type_descriptor, 
        n_list_size: int, lst_fields: list of field) is {
        p_s_value = s_value;
        p_td= td;
        p_n_list_size = n_list_size;
        
        for each (f) in lst_fields {
            p_lst_fields.add(f);
        };
    };
};    

extend sn_databrowser {
    p_s_value_result: string;
    p_lst_fields_result: list of field;
    p_td_value_result: type_descriptor;
    p_n_list_size_result: int;
    p_f_flag_result: bool;
    
    p_is_legal_exp(s_exp: string): bool is {
        var s_cmd: string = appendf("compute %s;", s_exp);
        var s_err: string = safe_specman_command(s_cmd, FALSE);
        if (s_err == "") {
            result = TRUE;
        } else {
            result = FALSE;
        };
    };
    
    evaluate(s_exp: string): sn_databrowser_value is {
        result = NULL;
        p_n_list_size_result = 0;
        p_td_value_result = NULL;
        p_s_value_result = "";
        p_lst_fields_result.clear();
        
        var s_err: string;
        var s_cmd: string;
        
        
        s_cmd = appendf(
            "p_databrowser.p_td_value_result = %s.declared_type();", s_exp);
        
        s_err = safe_specman_command(s_cmd, FALSE);
        //print 1, s_err;
        if (s_err != "") {
            out("Evaluate NULL for: ", s_exp);
            out("Error: ", s_err);
            return NULL;
        };
        
        //print s_exp, p_td_value_result;
        if (p_td_value_result != NULL) {
            if p_td_value_result.is_a_list() {
                
                s_cmd = appendf("p_databrowser.p_n_list_size_result = %s.size();", s_exp);
                s_err = safe_specman_command(s_cmd, FALSE);
                if (s_err != "") {
                    out("Evaluate NULL for: ", s_exp);
                    out("Error: ", s_err);
                    return NULL;
                };
                
                //result = NEW sn_databrowser_value.ctor_lst(lst_value_results, p_td_value_result);
                
                result = NEW sn_databrowser_value.ctor_list(
                    append("a ", p_td_value_result.name),
                    p_td_value_result, p_n_list_size_result);
                    
            } else {

                // handle a struct instance
                if p_databrowser.p_td_value_result.is_a_struct() {

                    // print "STRUCT";
                    
                    // first, check if this is a null instance
                    s_cmd = appendf("p_databrowser.p_f_flag_result = (%s == NULL); ", s_exp);
                    s_err = safe_specman_command(s_cmd, FALSE);
                    if (s_err != "") {
                        out("Error: ", s_err);
                        return NULL;
                    };
                    // print p_databrowser.p_f_flag_result;
                    
                    if (p_databrowser.p_f_flag_result) {
                        // a special case - this is a null instance
                        p_databrowser.p_s_value_result = "NULL";
                        result = NEW sn_databrowser_value.ctor(p_s_value_result, 
                            p_td_value_result, p_lst_fields_result);
                        
                        // print result;
                        return result;
                        
                        
                            
                    } else{
                        // if not null, calculate value and fields
                        s_cmd = appendf("%s; %s;",
                            appendf("p_databrowser.p_s_value_result = append(%s)", s_exp),
                            appendf("p_databrowser.p_lst_fields_result = p_reflection_manager.get_active_visible_fields(%s)", s_exp));
                        
                        // print s_cmd;
                    };
                    
                    
                } else {
                    
                    // handle a scalar
                    s_cmd = appendf("p_databrowser.p_s_value_result = append(%s); ", s_exp);
                };
                
                s_err = safe_specman_command(s_cmd, FALSE);
                if (s_err != "") {
                    out("Evaluate NULL for: ", s_exp);
                    out("Error: ", s_err);
                    return NULL;
                };

                result = NEW sn_databrowser_value.ctor(p_s_value_result, 
                    p_td_value_result, p_lst_fields_result);
                
                // print result;
                
            };
            
        };
        if (result == NULL) {
            out("Evaluate NULL for: ", s_exp);
        };
        
    };
    
};

extend global {
    generate_test() is also {
        if ((p_databrowser != NULL) and (p_databrowser.p_databrowser_deli != NULL)) {
            p_databrowser.p_databrowser_deli.refresh();
        };
        
    };

    post_load_command_actions() is also {
        if (p_databrowser != NULL) {
            p_databrowser.raise_dirty_flag();
        };
    };
    
    screen_prompt(s: string, do_command: bool) : string is first {  
        if (p_databrowser != NULL) {
            p_databrowser.refresh_if_dirty();
        };
    };
    
};


//display user menu separator;
//display user menu "show data ..." "show data";
//display user menu "show data sys" "show data sys";
    
extend jbrowsers config_options {

    
    pre_store_to_system(option : string, value : string)  is also {

        if (option != "source_width") {
            p_databrowser.raise_dirty_flag();
        };
        p_databrowser.refresh_if_dirty();
        
                
    };	 
};
'>
