
<'
define params_seperator "@@"; 


extend eb_node {

    
    //----------------------------------
    // general utils
    //----------------------------------
    get_form_title() : string is{
        result = me.eb_form.title;
    };
    
    pre_body() is empty;
    
    body_wrapper() is {
        pre_body();
        body();
    };
    
    //get_status() : int is {
    //    
    //    result = p_status;
    //};
    //
    //set_status(status:int) is {
    //    p_status = status;
    //};
    
    /////////////////////////////////////////////////////////
    // ADD OPTIONS TO FORM
    /////////////////////////////////////////////////////////
    

    //internal method - should be called before the user calls to create_form()
    ebi_create_form() is {
        if (me.eb_form == NULL) then {
            me.eb_form = new eb_form;
            me.eb_form.title = me.title;
            me.eb_form.node = me; // back pointer
        };
    };
    
    pre_create_form() is empty;
    
    // hook for the user to create the specific form.
    // this call adds 2 hooks( start & end) in order to build the explaination
    ebi_create_user_form() is {
        me.pre_create_form(); //internal use - add general fields to a form
        me.create_form_started();
        me.create_form();     // hook to the user
        me.create_form_ended();
    };
    
    create_form_started() is empty;
    create_form_ended() is empty;
    

    add_group(group_title:string) is {

        me.eb_form.curr_group = group_title;
    };
    
    
    add_field(field_name:string ,label:string, tool_tip:string,
        initialy_enabled: bool, notify_changes: bool) is {
        
        assert me.eb_form != NULL;      
        compute me.eb_form.ebi_add_field_n(me,field_name,label,tool_tip, 
            initialy_enabled, notify_changes);
    };
    
    add_field_with_list(field_name:string ,
        label:string, tool_tip:string,
        initialy_enabled: bool, notify_changes: bool,
        valid_values : list of string) is {
        
        assert me.eb_form != NULL;
        compute me.eb_form.ebi_add_field_n_with_list(me,
            field_name,label,tool_tip , 
            initialy_enabled, notify_changes, valid_values);
    };
        
        
    add_field_with_re(field_name:string ,
        label:string, tool_tip:string, 
        initialy_enabled: bool, notify_changes: bool,
        re:string) is {
        
        assert me.eb_form != NULL;      
        compute me.eb_form.ebi_add_field_n_with_re(me,field_name,label,tool_tip,
            initialy_enabled, notify_changes, re);
    };
    
    add_field_with_range(field_name:string, 
        label:string, tool_tip:string,
        initialy_enabled: bool, notify_changes: bool,
        min:string, max:string) is {
        
        assert me.eb_form != NULL;      
        compute me.eb_form.ebi_add_field_n_with_range(me,field_name,
            label,tool_tip, 
            initialy_enabled, notify_changes, min , max);
    };
'>    
    add_related_fields(s_fname:string, s_value: string, 
        lst_disabled_fields: list of string) is {
        
        assert me.eb_form != NULL;      
        var option: eb_form_option = me.eb_form.options.first(
            (it.field != NULL) and (it.field.name == s_fname));
        
        if (option == NULL) {
            sn_error(append("Can't find field called '", s_fname, "'.\n",
                "      Note that the field must be added before adding related fields"));
        };
        
        var pair: sn_jform_pair_enabler = NEW sn_jform_pair_enabler.ctor(
            s_value, lst_disabled_fields);
        option.lst_related_fields.add(pair);
        
    };
<'
    
    ebi_accept_form() is {
        me.p_status = EB_STATUS_FULL;
        apply();
    };
    
    apply_user_input(user_input :sn_jform_page_input): string is {
        
        ebi_save_original_values();
        
        // inside fill_from_form the range validation is done
        result = ebi_fill_from_form(user_input);
        if (result != "") {
            return result;
        };

        // hook to the user to add his own validation checks
        result = validate_form();
        if (result != "") {
            return result;
        };
        
        // accept the form
        ebi_accept_form();
        
    };

    //------------------
    // handle values
    //-----------------
    //-------------------------------------------------------
    // save/restore values while processing the form info
    //-------------------------------------------------------
    ebi_save_original_values() is {        
        me.eb_form.original_values = me.copy();
    };
    
    ebi_restore_original_values() is {
        //copy the original values from eb_form.original_values 
        // to the node' sfields
        
        //var params : list of string;
        var val_str : string ;
        var owner_struct := me.eb_form.original_values;
        var props: list of sn_item_properties;
        
        // create list of all values in the formar the fill_fields expect
        for each (option) in me.eb_form.options do {        
            
            var f := option.field;
            if ( f != NULL ) then {
                var field_value : untyped = 
                    sn_get_field_by_no(owner_struct,f.field_no).unsafe();
                val_str = symtab.any_to_string_with_radix(
                    field_value, f.base_type.d_index, DEC);
                
                
                props.add(NEW sn_item_properties.ctor(
                    f.name, val_str, option.initialy_enabled));
                //params.add(val_str);
            };
        };
        
        compute ebi_fill_fields(props);
    };
    
    
    
    ebi_fill_from_form(user_input :sn_jform_page_input): string  is {
        
        result = ebi_fill_fields(user_input.props);
    };


    ebi_fill_fields(props: list of sn_item_properties) : string is {
        
        //var idx : int = 0;

        // create list of options with field != NULL since 
        // those are the only options that should get a new value
        
        //print me;
        
        var tmp_l : list of eb_form_option = 
            me.eb_form.options.all(it.field != NULL);
        assert tmp_l.size() == props.size();       
        
        for each (prop) in props do {
            
            //var option := tmp_l[idx];
            
            var option:= tmp_l.first(it.field.name == prop.name);
            assert (option != NULL);
            var val_str: string = prop.value;
                
            --out("KEY_VAL: ", option.field.name, " ", val_str);
            result = ebi_validate_range(option, val_str);
            if( result != "") then {
                return result;
            };
            
            option.initialy_enabled = prop.enabled;
            //var f := me.eb_form.options[idx].field;
            var f : field = option.field;
            assert f != NULL;
            var arws:= a new ascii_read_write_struct;
            
            var item:= arws.string_to_value(val_str,f);
            me.unsafe_put_field(f, item);     
            
            //var field_value : untyped = 
            //    sn_get_field_by_no(me,f.field_no).unsafe();
            //var new_val_str: string = symtab.any_to_string_with_radix(
            //    field_value, f.base_type.d_index, DEC);
            //
            --out("Field f: ", f.name, " NEW VAL: ", new_val_str);
            
            //idx += 1;
        };
    };
    
    
    validate_form() : string is {
        
        return NULL;
    };
    
    
    ebi_validate_range(option:eb_form_option , val_str:string) : string is{

        var err_msg := "value out of range. Valid range is:";
        if ( option.max != "NA" && option.min != "NA" ) then {
                
            var f := option.field;
            if (f.base_type.name == "int" ) then {
                var tmp : int = val_str.as_a(int);
                var min_int := option.min.as_a(int);
                var max_int := option.max.as_a(int);
                    
                if ( min_int > tmp || max_int < tmp) then {
                    result=append(err_msg,option.min, ".." ,option.max); 
                };
                
            } else if (f.base_type.name == "uint" ) then {
                var tmp :uint = val_str.as_a(uint); 
                var min_uint := option.min.as_a(uint);
                var max_uint := option.max.as_a(uint);
                        
                if ( min_uint > tmp || max_uint < tmp) then {
                    result=append(err_msg,option.min, ".." ,option.max); 
                };
            };
            
        };
    }; 
    
    //////////////////////////
    // HANDLE BUTTONS
    /////////////////////////

    full_reset() is {
        reset(); // a hook to the content provider
        ebi_reset();
    };
        
    //-----------------------------------------------------------------------
    // this method is called when ever the user press any form button. 
    // it should be implemented by every node struct in order to support its
    // special commands.
    // NOTE:the manager is called from this context
    //-------------------------------------------------------------------------
    //button_clicked(button_name:string) is empty;
        
        // make sure that user overwrite this method if he defines any buttons
        //sn_err(BUTTON_CLICK_IMPL);


    // Reset this node
    ebi_reset() is undefined;

    set_items_properties(items_properties: list of sn_item_properties) is {
        
        p_ebuilder.get_jservice().set_items_properties(items_properties);
    };
    
    get_items_properties(items_names: list of string): list (key: name) 
        of sn_item_properties is {
    
        var props: list of sn_item_properties = 
            p_ebuilder.get_jservice().get_items_properties(items_names);
        
        for each (prop) in props {
            result.add(prop);
        };

    };

};
'>


<'
extend eb_form_option {

    set_valid_values(values : list of string) is {
         me.valid_values = values;
    };
    
    
    set_valid_re(re:string) is {
        
        if ( me.get_value_short_type()!=STRING_TYPE) then {
            sn_err(ONLY_STRING_ALLOWED);
        };
        
        me.re = re;
    };
    
    
    set_valid_range(min:string , max:string) is {
        
        var short_type := me.get_value_short_type();
                                 
        if ( !symtab.is_numeric_type(short_type)) then {
            sn_err(ONLY_NUMERIC_ALLOWED);
        };
        
        me.min = min;
        me.max = max;
    };
    
};
'>



<'
extend eb_form {
    

    ebi_add_field_n(owner_struct :eb_node, field_name:string ,label:string, 
        tool_tip:string,
        initialy_enabled: bool, notify_changes: bool) : eb_form_option is {
          
        var f : field = symtab.get_field_by_name(owner_struct , field_name);
        assert f != NULL;
        result = me.ebi_add_field(owner_struct, f ,label,tool_tip,
            initialy_enabled, notify_changes);
    };
    
    ebi_add_field_n_with_list(owner_struct:eb_node, field_name:string ,
        label:string, tool_tip:string,
        initialy_enabled: bool, notify_changes: bool,
        valid_values : list of string) :
        eb_form_option is {
        
        var f : field = symtab.get_field_by_name(owner_struct , field_name);
        assert f != NULL;
          
        result = me.ebi_add_field_with_list(owner_struct, f ,label,tool_tip,
            initialy_enabled, notify_changes, valid_values);
    };    
        
    ebi_add_field_n_with_re(owner_struct:eb_node, field_name:string ,
        label:string, tool_tip:string,
        initialy_enabled: bool, notify_changes: bool,
        re:string) :  eb_form_option is {
    
        var f : field = symtab.get_field_by_name(owner_struct , field_name);
        assert f != NULL;
        
        result = me.ebi_add_field_with_re(owner_struct,f,label,tool_tip,
            initialy_enabled, notify_changes, re);
        
    };
    

    // specify valid range for scalars
    ebi_add_field_n_with_range(
        owner_struct:eb_node , field_name:string, 
        label:string, tool_tip:string, 
        initialy_enabled: bool, notify_changes: bool,
        min:string, max:string)
        :eb_form_option is {
                
        var f : field = symtab.get_field_by_name(owner_struct , field_name);
        if ( f != NULL) then {
            result = me.ebi_add_field_with_range(owner_struct,f, 
                label, tool_tip,
                initialy_enabled, notify_changes, min, max);
        };
        
    };
    
};
'>

<'

extend eb_node {
    
    ebi_get_explain_file_name(): string is {
        try {
            result =  files.add_file_type(get_explain_file_name(),"",TRUE);
        } else {
            result = files.add_file_type("ebuilder/no_explain.html","",TRUE);
            //assert FALSE;
        };
        result = files.get_full_file_name(result);
   };
    
    get_explain_file_name(): string is empty; //{
//        return append(get_symbol("SPECMAN_GUI_EXTRAS"), "/jb/e/ebuilder/default_explain.html");
//    };

    get_jform_page(): sn_jform_page_props is {
        // lazy - the eb_form is build on demand, once.
        if (me.eb_form == NULL) {
            me.ebi_create_form();
            me.ebi_create_user_form();
        };
        
        // CREATE PAGE
        var page: sn_jform_page_props = new sn_jform_page_props with {
            it.sTitle = eb_form.title;
        };
        
        // CREATE GROUPS
        var lst_groups: list of sn_jform_group_props;
        
        var s_curr_grp_name: string = "UNDEF";
        var curr_group_props: sn_jform_group_props = NULL;
        
        for each (option) in eb_form.options {
            
            // meanwhile, we ignore non field
            if (option.field == NULL) {
                continue;
            };

            // check if we need to build a new group
            if (option.group != s_curr_grp_name) {
                s_curr_grp_name = option.group;
                curr_group_props = new sn_jform_group_props with {
                    it.sTitle = s_curr_grp_name;
                    it.sName = append("group", lst_groups.size() + 1);
                };
                lst_groups.add(curr_group_props);
            };
            
            // CREATE OPTION, AND ADD TO GROUP
            var item: sn_jform_item_props = new sn_jform_item_props;
            
            // get type
            var sh_type: short_type = option.get_value_short_type();
            case (sh_type) {
                
                // meanwhile, we ignore non field
                BOOL_TYPE {
                    item.nType = JFORM_BOOLEAN;
                };
                
                STRING_TYPE {
                    item.nType = JFORM_STRING;
                };
                
                ENUM_TYPE {
                    item.nType = JFORM_ENUM;
                };
                
                [INT_TYPE, UINT_TYPE, FLOAT_TYPE] {
                    item.nType = JFORM_INT;
                };
                
                default {
                    sn_error(append("Unknown type : ", sh_type));
                };
            };
            
            item.sOptionName = option.field.name;
            item.sLabel = option.label;
            item.sInitialText = option.get_value_as_string();
            //print item.sInitialText;
            item.fInitialyEnabled = option.initialy_enabled;
            item.fNotifyChanges = option.notify_changes;
            
            
            if ( option.max != "NA" && option.min != "NA" ) then {
                
                item.intLimits = NEW sn_pair_int_props.ctor(
                    option.min.as_a(int),
                    option.max.as_a(int));
            };
                
            item.nCharsWidth = 5;
            item.sToolTip = option.tool_tip;
            item.arrOfValues = option.get_values_list();
            item.arrOfPairEnablers = option.lst_related_fields;

            // add item to group
            curr_group_props.arrOfFormItemProps.add(item);
        };
        
        // set all groups in page
        page.arrOfFormGroupProps = lst_groups;
        
        //page.pprint();
        
        // return it
        result = page;
    };
};


extend eb_form_option {
    get_values_list() : list of string is {
        
        var sh_type: short_type = get_value_short_type();
        case (sh_type) {
            
            // meanwhile, we ignore non field
            BOOL_TYPE {
                // nothing  
            };
            
            ENUM_TYPE {
                result = session.get_enum_names_list(me.field.base_type.name);
                // out("ENUM: field: ", me.field.name, " type: " , me.field.base_type.name, " - values: ", result);
            };
            
            default {
                if (! valid_values.is_empty()) {
                    result = valid_values;
                };
            };
        };
            
    };
};

extend session {
    get_enum_names_list(s_enum_type: string): list of string is {
        
        var td: type_descriptor = type_called(s_enum_type);
        if (td == NULL) {
            return result;
        };
        
        var ed: enum_descriptor = td.as_a(enum_descriptor);
        if (ed == NULL) {
            return result;
        };
        
        result = ed.enum_names.items.name;
        
    };
};
    
'>


