<'

//------------------------------
// eb_gui   /////////////////////
//------------------------------
struct sn_ebuilder_gui like sn_struct {
    
    //refresh() is undefined;
    //select_node(node:eb_node , open:bool) is undefined; 
    find_next_empty(node:eb_node) : eb_node is undefined;
    get_full_tree(): sn_ebuilder_node_data is undefined;
    
};
    
    
//------------------------------
// eb_manager /////////////////////
//------------------------------
struct eb_manager like sn_struct {
    
    //--------------------
    // Data members
    //--------------------
    p_main_node : eb_node; 
    
    p_selected_node : eb_node;  
    p_hash_eb_nodes: list (key: p_s_id) of eb_node;
    
    p_eb_node_counter: int;
    
    last_generated: eb_node;  -- Last generated eb_node

    ebi_register_eb_node(node: eb_node) is empty;
};

'>


<'

//----------------------------------
///////// eb_node  /////////////////
//----------------------------------

extend eb_node {

    //////////////////
    // Data members
    //////////////////
    !eb_form : eb_form; // the form that represent the node     

    title : string;

    //
    !p_node_parent: eb_node;
    !p_s_id: string;
    !p_status: int;
    
    ////////////////////
    // Methods
    ///////////////////
    
    init() is also {
        p_ebuilder.eb_manager.ebi_register_eb_node(me);
    };
    
    reset() is {
        // BAD!!!  Should be under ebi_reset()
        me.p_status = EB_STATUS_EMPTY;
    };    
};
'>



<'

//------------------------
/////// eb_form //////////
//------------------------

struct eb_form like any_struct{
    
    ///////////////////////
    // data members
    ///////////////////////
    
    title  : string; //window title
    options : list of eb_form_option; 

    !node : eb_node; // back_pointer;
    
    !original_values : eb_node; 
    // save the original values, before the form was modified by the user

    curr_group : string; // name of group to which all new optinos are added

    //////////////
    // methods
    //////////////
    init() is also {
        original_values = new eb_node;
    };
    
    ebi_add_field(owner_struct :eb_node, field ,label:string, tool_tip:string,
        initialy_enabled: bool, notify_changes: bool): eb_form_option is {
          
        var form_option := create_general_form_option(
            owner_struct, field ,label,tool_tip,
            initialy_enabled, notify_changes);
        
        form_option.set_default_widget();
        
        me.options.add(form_option);
        
        result = form_option;
    };
    
    // specify list of valid values (as strings)
    ebi_add_field_with_list(owner_struct:eb_node, field ,label:string, 
        tool_tip:string, 
        initialy_enabled: bool, notify_changes: bool,
        valid_values : list of string) :eb_form_option is {
        
        result = ebi_add_field(owner_struct,field,label,tool_tip,
            initialy_enabled, notify_changes);
        
        result.set_valid_values(valid_values); 
        
        // call to set_default_widget AFTER setting the valid values since
        // the widget is determined according to valid_Values parameter !!
        result.set_default_widget();
        
    };
        
    // specify valid regular exp. 
    ebi_add_field_with_re(owner_struct:eb_node, field ,label:string, 
        tool_tip:string, 
        initialy_enabled: bool, notify_changes: bool,
        re:string) : 
        eb_form_option is {
        
        result = me.ebi_add_field(owner_struct,field,label,tool_tip,
            initialy_enabled, notify_changes);

        result.set_valid_re(re);
        
    };
    
    // specify valid range for scalars
    ebi_add_field_with_range(
        owner_struct:eb_node , field , label:string, tool_tip:string,
        initialy_enabled: bool, notify_changes: bool,
        min:string, max:string) : eb_form_option is {
                
        result = me.ebi_add_field(
            owner_struct,field, label, tool_tip,
            initialy_enabled, notify_changes);
        
        result.set_valid_range(min,max);
        
    };
    --------------------------------------------------------------------
    -- private : creates a config option with the basic information
    --------------------------------------------------------------------
    create_general_form_option( s:eb_node ,f:field , 
        label:string, tool_tip:string,
        initialy_enabled: bool, notify_changes: bool) :eb_form_option is {
        
        var form_option : eb_form_option;
        form_option = new eb_form_option(wo) with {
            wo.eb_form = me;
            wo.owner_struct = s;
            wo.field = f;
            wo.label = label;
            wo.tool_tip = tool_tip;
            wo.initialy_enabled = initialy_enabled;
            wo.notify_changes = notify_changes;
            wo.prev_option_name = "";
            wo.group = me.curr_group;
            wo.min = "NA";
            wo.max = "NA";
            wo.re = ".*";
            wo.valid_values.clear();
            wo.kind = GENERIC;
            wo.name = "";
            
            result = wo;
        };

        result.set_default_widget();
        
        // YOAV  - REPLACE RANGE DEF !!!!!!
        // if type is numeric - set its maximum valid range.
        // if the user specified its own range - the user range will
        // overwrite this definition range.
        //var value_short_type : short_type = result.get_value_short_type();
        //if (value_short_type  == INT_TYPE ) then {
        //    result.min = MIN_INT;
        //    result.max = MAX_INT;
        //} else if ( value_short_type == UINT_TYPE ) {
        //    result.min = 0;
        //    result.max = MAX_UINT;
        //};        
        
        result = form_option;
    }; 
    
    
    show() is empty;   

};
'>

<'

//------------------------------------
/////// eb_form_option ///////////////
//------------------------------------

struct eb_form_option like sn_struct{

    !eb_form : eb_form ; // back pointer
    
    // field attributes
    owner_struct : base_struct;
    field; // the field that the widget display. 
           // NULL means - no field : for text / buttotns etc.
    
    // gui attributes
    label       : string;
    tool_tip    : string;
    initialy_enabled: bool;
    notify_changes: bool;
    prev_option_name : string; // for ordering between items
    group       : string; 
    widget      : ui_type;
    kind        : eb_option_kind;
    
    // validation params
    min : string;
    max : string;
    re  : string;    
    valid_values : list of string;
    
    // related fields (fields to disable for each value)
    lst_related_fields: list of sn_jform_pair_enabler;
    
    
    // internal use
    name: string; // used for buttons  
        
    get_value_as_string() :string is {
        
        var val_str : string;
              
        var field_value : untyped = 
            sn_get_field_by_no(me.owner_struct, me.field.field_no).unsafe();
        val_str = symtab.any_to_string_with_radix(
            field_value, field.base_type.d_index, DEC);

        result = val_str;

    };
    
    
    --------------------------------------------------------------------
    -- sets widget according to the type of the filed value 
    -- choose the default widget :  
    -- int or string -> entry , bool -> check box , enum -> drop_down
    --------------------------------------------------------------------
    set_default_widget() is {
        widget = get_default_widget();
    };
    
    ---------------------------------------------
    -- returns the default widget for a type
    ---------------------------------------------
    get_default_widget() : ui_type is {
        
        // if owner_struct is NULL - there is no actual field that should be 
        // edited ---> static text.
        if ( me.owner_struct == NULL) then {
            return static_text;
        } else if ( me.field == NULL ) then {
            return button;
        };
        
        var value_short_type : short_type;
        
        value_short_type = get_value_short_type();
        
        if ( me.valid_values.is_empty() == FALSE  and
             value_short_type != BOOL_TYPE ) then {
            
            // dropdown for a specified list of values unless the type is bool
            result = drop_down;    
        } 
        else if ( value_short_type == BOOL_TYPE ) then {
            result = check_box;
        } 
        else if ( value_short_type == STRING_TYPE || 
            symtab.is_numeric_type(value_short_type) ) then {
            result = entry;
        }
        else if ( value_short_type == ENUM_TYPE ) then {
            result = drop_down;
        } else {
            result = entry;
        };
    };
    
    -------------------------------------------
    -- returns the type of the value
    -------------------------------------------
    get_value_short_type() : short_type is {
        
        if ( field!= NULL ) then {
            result = field.base_type.short_type;
            
            if ( !p_ebuilder.is_valid_eb_form_type(result)) then {
                sn_err(INVALID_TYPE_FOR_CONFIG , me.field.name); 
            };
        };
    };
    
    
    // empty methods that are overwriten in the interface file
    set_valid_re(re:string) is empty;
    set_valid_range(min:string, max:string) is empty;
    set_valid_values(valid_values:list of string) is empty;
};
'>

<'
extend sn_e_builder {
    
    eb_manager;
    p_ebuilder_gui : sn_ebuilder_gui; // init later
        
    
    init() is also {
        me.eb_manager = new;
    };
    
    
};

'>



