<'

import ../when_patch;
import ebuilder_edl;
import gencode/top_ebuilder;


extend global {
    
    init() is also {
        p_ebuilder.p_ebuilder_gui = NEW sn_ebuilder_gui.ctor();
    };
    
};

extend sn_ebuilder_gui {
    
    p_ebuilder_deli: sn_ebuilder_deli;
    p_ebuilder_service: sn_ebuilder_service;
    p_dirty: bool;
    p_eb_node_sd: struct_descriptor;
    p_f_eservice_registered: bool;
        
    ctor() is {
        p_ebuilder_deli = NEW sn_ebuilder_deli.ctor();
        p_ebuilder_service = NEW sn_ebuilder_service.ctor();
        p_eb_node_sd = type_called("eb_node").as_a(struct_descriptor);
        
    };
    
    register_service() is {
        if (! p_f_eservice_registered) {
            orb register service p_ebuilder_service 
                sni_ebuilder_service 
                EBUILDER_SERVICE_NAME;
            
            p_f_eservice_registered = TRUE;
        };
        
    };

    raise_dirty_flag() is {
        p_dirty = TRUE;
    };
    
    refresh_if_dirty() is {
        if (p_dirty) {
            p_dirty = FALSE;
            if (p_ebuilder_deli != NULL) {
                p_ebuilder_deli.refresh();            
            };
        };
    };
    
    refresh() is {
        raise_dirty_flag();
        refresh_if_dirty();
    };
    
    //select_node(node: eb_node, f_callback: bool) is {
    //    if (p_ebuilder_deli != NULL) {
    //        p_ebuilder_deli.select_node(node, f_callback);
    //    };
    //};
    

    get_full_tree(): sn_ebuilder_node_data is {
        result = NEW sn_ebuilder_node_data.ctor_root();
    };
    
    print_full_tree() is {
        var root: sn_ebuilder_node_data = get_full_tree();
        root.pprint();
    };

    find_first_empty(): eb_node is {
        result = find_next_empty(NULL);
    };
        
    find_next_empty(node: eb_node): eb_node is {
        
        var all_nodes: list of sn_ebuilder_node_data = 
            get_all_nodes().all(! it.is_list());
        
        var node_data: sn_ebuilder_node_data;

        var n_start_ind: int = -1;
        if (node != NULL) {
            n_start_ind = all_nodes.first_index(it.p_s_id == node.p_s_id);
        };
        
        node_data = 
            all_nodes.first((index >= n_start_ind) and (it.p_n_status == EB_STATUS_EMPTY));
        
        if (node_data != NULL) {
            result = p_ebuilder.eb_manager.find_eb_node(node_data.p_s_id);
        } else {
            // can't find empty node AFTER current - search BEFORE it
            node_data = all_nodes.first((index <= n_start_ind) and (it.p_n_status == EB_STATUS_EMPTY));
            if (node_data != NULL) {
                result = p_ebuilder.eb_manager.find_eb_node(node_data.p_s_id);
            };
        };
        
    };
        
    get_all_empty_nodes(): list of sn_ebuilder_node_data is {
        result = recursive_get_all_empty_nodes(get_full_tree());
    };

    recursive_get_all_empty_nodes(node_parent: sn_ebuilder_node_data): list of sn_ebuilder_node_data is {
        if (node_parent.p_n_status == EB_STATUS_EMPTY) {
            result.add(node_parent);
        };
        
        for each (node_child) in node_parent.p_children {

            result.add(p_ebuilder.p_ebuilder_gui.recursive_get_all_empty_nodes(node_child));
        };
        
    };
        
    get_all_nodes(): list of sn_ebuilder_node_data is {
        result = recursive_get_all_nodes(get_full_tree());
    };

    recursive_get_all_nodes(node_parent: sn_ebuilder_node_data): list of sn_ebuilder_node_data is {
        result.add(node_parent);
        
        for each (node_child) in node_parent.p_children {

            result.add(p_ebuilder.p_ebuilder_gui.recursive_get_all_nodes(node_child));
        };
        
    };
        
//    node_selected(node: eb_node) is {
//        if (node == NULL) {
//            p_ebuilder.eb_mngr.close_curr_form();
//        } else {
//            node.show_form();
//        };
//        
//    };
//    
//
//    node_id_selected(s_id: string) is {
//        if (s_id == "") {
//            p_ebuilder.p_ebuilder_gui.node_selected(NULL);
//        } else {
//            var node: eb_node = p_ebuilder.eb_mngr.find_eb_node(s_id);
//        
//            ASSERT(node != NULL);
//            p_ebuilder.p_ebuilder_gui.node_selected(node);
//        };
//        
//        
//    };
    
};

struct sn_ebuilder_service like sni_ebuilder_service {
    
    ctor() is {
        ;        
    };

    move_to_node(s_id: string, 
        user_input :sn_jform_page_input): sn_ebuilder_new_state is {
        
        dbg_out(debug.ebuilder, "From GUI move_to_node  id:" , s_id);
        
        ASSERT(s_id != "");

        var node: eb_node = p_ebuilder.eb_manager.find_eb_node(s_id);
        ASSERT(node != NULL);
        
        result = p_ebuilder.eb_manager.ask_move_to_node(node, user_input);
    };
    
    move_to_next(user_input :sn_jform_page_input): sn_ebuilder_new_state is {

        dbg_out(debug.ebuilder, "From GUI move_to_next");
        
        result = p_ebuilder.eb_manager.ask_move_to_next(user_input);
    };
    
    reset(): sn_ebuilder_new_state is {
        dbg_out(debug.ebuilder, "From GUI reset");
        
        result = p_ebuilder.eb_manager.ask_reset();
    };
    
    apply(user_input :sn_jform_page_input): sn_ebuilder_new_state is {
        dbg_out(debug.ebuilder, "From GUI apply");
        
        //print "call ask_apply";
        result = p_ebuilder.eb_manager.ask_apply(user_input);
    };

    
    
    get_root(): sn_ebuilder_node_data is {
        dbg_out(debug.ebuilder, "From GUI get_root()");
        result = p_ebuilder.p_ebuilder_gui.get_full_tree();
    };

    get_jform_page(s_id: string): sn_jform_page_props is {
        ASSERT(s_id != "");

        var node: eb_node = p_ebuilder.eb_manager.find_eb_node(s_id);
        ASSERT(node != NULL);
        
        result = node.get_jform_page();
    };
    
    
    build() is {
        dbg_out(debug.ebuilder, "From GUI build");
        p_ebuilder.eb_manager.build();
    };
    
    fill_defaults(user_input :sn_jform_page_input): sn_ebuilder_new_state is {
        
        dbg_out(debug.ebuilder, "From GUI fill_defaults");
        result = p_ebuilder.eb_manager.ask_fill_defaults(user_input);
        
    };

    ebuilder_closed() is {
        dbg_out(debug.ebuilder, "From GUI ebuilder_closed");
        p_ebuilder.eb_manager.ebuilder_closed();
    };
    
    
    item_value_changed(name: string, value: string): string is {
        var node: eb_node = p_ebuilder.eb_manager.get_selected_node();
        ASSERT (node != NULL);
        
        result = node.item_value_changed(name, value);
    };
};

extend global {
    register_jb_services() is also {
        p_ebuilder.p_ebuilder_gui.register_service();
    };
};

struct sn_ebuilder_deli {
    p_jebuilder_service: sni_jebuilder_service;
        
    ctor() is {
        p_jebuilder_service = NULL;
    };
    
    is_service_active(): bool is {
        result = (p_jebuilder_service != NULL);
    };
    
    p_get_service(): sni_jebuilder_service is {
        
        if (p_jebuilder_service == NULL) {
            
            var s_err: string = 
                jspecview_deli.start_japp_class(
                "com.verisity.ebuilder.JEBuilderService");
            
            if (s_err != "") { 
                error("Failed starting ebuilder : ", s_err); 
            } else {
                // out("Started J-EBuilder Service");
            };
            
            p_jebuilder_service =
                orb lookup service sni_jebuilder_service 
                JEBUILDER_SERVICE_NAME;
            
            ASSERT(p_jebuilder_service != NULL);
                
        };
        
        result = p_jebuilder_service;
    };
    
    //open_ebuilder() is {
    //    
    //    dbg_out(debug.ebuilder, "To GUI open_ebuilder");
    //    
    //    var node_sel: eb_node = p_ebuilder.p_ebuilder_gui.find_first_empty();
    //    if (node_sel == NULL) {
    //        node_sel = p_ebuilder.eb_manager.get_root();
    //    };
    //    p_get_service().open_ebuilder_window(
    //        p_ebuilder.p_ebuilder_gui.get_full_tree(),
    //        node_sel.p_s_id);
    //    
    //};
    
    refresh() is {
        dbg_out(debug.ebuilder, "To GUI refresh");
        
        if (is_service_active()) {
            
            //p_get_service().refresh_ebuilder_window(p_ebuilder.p_ebuilder_gui.get_full_tree());

        };
    };
    
    //select_node(node: eb_node, f_callback: bool) is {
    //    
    //    dbg_out(debug.ebuilder, "To GUI select_node  id=", node.p_s_id, " callback=" , f_callback);
    //    if (is_service_active()) {
    //        
    //        if (node == NULL) {
    //            p_get_service().select_node("", f_callback);
    //        } else {
    //            p_get_service().select_node(node.p_s_id, f_callback);
    //        };
    //
    //    };
    //        
    //  };
    
};
    

extend sn_ebuilder_node_data {
    
    ctor_root() is {
        var root: eb_node = p_ebuilder.eb_manager.get_root();
        //out("ctor_root: ", root.get_desc());
        p_ctor(root, -1)
    };
        
    ctor_child(node: eb_node, n_list_index: int) is {
            
        //out("ctor_child: ", node.get_desc());
        p_ctor(node, n_list_index);
    };

    ctor_child_list(node_list: list of eb_node) is {

        //out("ctor_child_list: size=", node_list.size());
        ASSERT(node_list.size() > 0);
        
        var node_sample: eb_node = node_list[0];
        
        p_s_inst_name = node_list.to_string();
        p_s_id = p_ebuilder.eb_manager.get_unique_id();
        //print "LIST", p_s_id;
        
        p_children = get_node_list_children(node_list);
        p_s_name = appendf("List of (%s) %s", 
            str_dec(p_children.size()),
            node_sample.get_role());

        var n_count_empty: int = node_list.all(it.p_status == EB_STATUS_EMPTY).size();
        if (n_count_empty == node_list.size()) {
            // all empty
            p_n_status = EB_STATUS_EMPTY;
            
        } else if (n_count_empty > 0) {
            // some empty some full
            p_n_status = EB_STATUS_PARTIAL;
            
        } else {
            // all full
            p_n_status = EB_STATUS_FULL;
        };
        
        p_f_list = TRUE;

    };

    p_ctor(node: eb_node, n_list_index: int) is {

        ASSERT(node != NULL);
        
        p_s_inst_name = node.to_string();
        p_s_id = node.p_s_id;
        p_s_name = node.get_name();
        
        if (n_list_index >= 0) {
            p_s_name = appendf("[%s] %s", str_dec(n_list_index), p_s_name);
        };
        
        p_n_status = node.p_status;
        p_f_list = FALSE; // @@@
        p_children = get_node_children(node);
        //p_jform_page = node.get_jform_page(); ==> will be done on demand
        //print node.p_s_id, p_jform_page.sTitle;
        p_s_explain_page = node.ebi_get_explain_file_name();
        
    }; 

    is_list(): bool is {
        result = p_f_list;
    };
    
    get_node_list_children(node_list: list of eb_node): list of sn_ebuilder_node_data is {
        for each (node_child) in node_list {
            result.add(NEW sn_ebuilder_node_data.ctor_child(node_child, index));
        };
    };
    
    get_node_children(node: eb_node): list of sn_ebuilder_node_data is {
        
        // find all fields which are:
        // o active (i.e. under the appopriate when etc.)
        // o like eb_node
        var lst_valid_fields: list of field = p_reflection_manager.get_active_visible_fields(node);
        
        var lst_fields: list of field = lst_valid_fields.all(
            (it.name !~ "/^p_/") and
            (type_is_a_child_of(it.base_type.elem_type(), p_ebuilder.p_ebuilder_gui.p_eb_node_sd)));
            

        // prepare children - do not use NULL nodes
        for each (F) in lst_fields {
            if (F.base_type.is_a_list()) {
                // we have a list of eb_nodes
                var node_child_list: list of eb_node = 
                    sn_get_field_by_no(node,F.field_no).unsafe();
                
                if (node_child_list.size() > 0) {
                    result.add(NEW sn_ebuilder_node_data.ctor_child_list(node_child_list));
                };
                
            } else {
                // normal eb_node
                
                var node_child: eb_node = sn_get_field_by_no(node,F.field_no).unsafe();
                if (node_child != NULL) {
                    result.add(NEW sn_ebuilder_node_data.ctor_child(node_child, -1));
                };
            };
        };
            
    };
    
    pprint() is {
        out("Node id:", p_s_id, " stat:", p_n_status, " - '", p_s_name, "'");
        for each (child) in p_children {
            child.pprint();
        };
    };
};



//display user menu separator;
//display user menu "Open EBuilder" "show ebuilder";
//display user menu separator;
//display user menu "Load Generated Files" "shell ./demo_cb_target.sh";
display user menu separator;

//define <open_ebuilder'command> "sh[o[w]] eb[uilder]" as {
//    
//    p_ebuilder.p_ebuilder_gui.p_ebuilder_deli.open_ebuilder();
//
//    //var node : eb_node = p_ebuilder.p_ebuilder_gui.find_first_empty();
//    //if (node != NULL) {
//    //    p_ebuilder.p_ebuilder_gui.select_node(node, TRUE);
//    //};
//
//};

// by orit :
// LEVEL 1 - open eb for specified node
//
define <start_builder'command> "eb[uilder] <node'name>" as {
    
    p_ebuilder.start_ebuilder("<node'name>");
    
};


extend sn_e_builder {
    
    get_jservice(): sni_jebuilder_service is {
        if ((p_ebuilder_gui != NULL) and (p_ebuilder_gui.p_ebuilder_deli != NULL)) {
            result = p_ebuilder_gui.p_ebuilder_deli.p_get_service();
        } else {
            result = NULL;
        };
    };
    
    start_ebuilder(node_name : string) is {
    
        // check the node name was defined in content files
        if (all_types.first(.name== node_name) == NULL ) then {
            sn_error(append("Can't find eBuilder component called '", node_name, "'"));
            return;
        };
        
        
        if ( me.is_open == TRUE ) then {
            sn_error(append("eBuilder is already opened. Cannot start another one."));
        } else {
            
            me.is_open = TRUE;
            
            eb_manager.start_ebuilder(node_name);
        
    
            //var node : eb_node = p_ebuilder.p_ebuilder_gui.find_first_empty();
            //if (node != NULL) {
            //    p_ebuilder.p_ebuilder_gui.select_node(node, TRUE);
            //};
        };
    };
};
extend eb_manager {
    
    start_ebuilder(node_name:string) is empty;
       
};


'>


<'
// implemented here by orit !
// can not be in eb_mngr.e sincce it uses the type sn_ebuilder_node_data;
extend eb_manager {
    
    build() is {
        
        var all_nodes_data: list of sn_ebuilder_node_data = 
            p_ebuilder.p_ebuilder_gui.get_all_nodes().all(! it.is_list());
        var nodes : list of eb_node;
        
        var status : bool = TRUE;
        
        // validation check - the status of all nodes should be EB_STATUS_FULL
        // while validating - build a list of eb_nodes for the real build
        for i from 0 to all_nodes_data.size()-1 do {
            
            var node_data : sn_ebuilder_node_data = all_nodes_data[i];
            var node : eb_node = 
                p_ebuilder.eb_manager.find_eb_node(node_data.p_s_id);
            
            if ( node.p_status != EB_STATUS_FULL ) then {
                tk("bell");
                display.show_info_dialog(
                    "Cannot build - please fill the forms of all componenets");
                status = FALSE;
                break;
            };
            
            nodes.add0(node);    
        };
        
        
        if ( status == TRUE ) then {
            
            for each(node) in nodes do {
                node.body_wrapper();
            };
        };
    };
};
'>
