<'
// file: ebuilder/ebuilder_edl.e

import $SN_JBROWSERS_HOME/e/jform/jform_edl.e;
import $SN_JBROWSERS_HOME/e/jform/gencode/top_jform;

    
define JEBUILDER_SERVICE_NAME "JEBUILDER";
define EBUILDER_SERVICE_NAME "EBUILDER";

define EB_STATUS_ERROR 1;
define EB_STATUS_OK 2;
define EB_STATUS_COMPLETED 3;


// the Java ebuilder service
orb interface sni_jebuilder_service 
    using package=com.verisity.ebuilder.model.gencode {
    
    open_ebuilder_window(data_model: sn_ebuilder_node_data,
       s_sel_node_id: string ) is sync;
    
    //refresh_ebuilder_window(data_model: sn_ebuilder_node_data) is sync;

    //select_node(s_id: string, f_callback: bool) is async;
    
    //validate(): bool is sync;
    
    //get_all_values(): list of sn_key_val is sync;

    //get_value(s_option_name: string): string is sync;
    
    is_modified(): bool is sync;
    
    set_items_properties(items_properties: 
        list of sn_item_properties) is sync;

    get_items_properties(items_names: list of string): 
        list of sn_item_properties is sync;

    
    //reset() is sync;
    
};

// the e ebuilder service
orb interface sni_ebuilder_service 
    using package=com.verisity.ebuilder.model.gencode {
    
    //get_root(): sn_ebuilder_node_data is sync;
    
    move_to_node(s_id: string, 
        user_input :sn_jform_page_input):sn_ebuilder_new_state is sync;
    
    move_to_next(user_input :sn_jform_page_input): sn_ebuilder_new_state is sync;
    
    reset(): sn_ebuilder_new_state is sync;
    
    apply(user_input :sn_jform_page_input): sn_ebuilder_new_state is sync;

    build() is async;
    
    fill_defaults(user_input :sn_jform_page_input): sn_ebuilder_new_state is sync;

    ebuilder_closed() is async;
    
    get_jform_page(s_id: string): sn_jform_page_props is sync;
    
    // returns error msg
    item_value_changed(name: string, value: string): string is sync;
    
};


'>


<>  Data Contents

<'

struct sn_ebuilder_node_data {
    p_children: list of sn_ebuilder_node_data;
    p_s_id: string;
    p_s_inst_name: string;
    p_s_name: string;
    p_n_status: int;
    p_f_list: bool;
    p_jform_page: sn_jform_page_props;
    p_s_explain_page: string;
};

orb data sn_ebuilder_node_data 
    using package=com.verisity.ebuilder.model.gencode ;


struct sn_ebuilder_new_state {
    n_status: int;
    s_err: string;
    new_root_node: sn_ebuilder_node_data;
    s_new_selected_id: string;
    
    ctor() is {
        n_status = EB_STATUS_OK;
    };
    
    ctor_status(any_n_status: int) is {
        n_status = any_n_status;
    };
    
    ctor_err(any_s_err: string) is {
        ctor();
        n_status = EB_STATUS_ERROR;
        s_err = any_s_err;
    };
    
    ctor_model_sel(any_new_root_node: sn_ebuilder_node_data,
        any_s_new_selected_id: string) is {
        
        ctor();
        new_root_node = any_new_root_node;
        s_new_selected_id = any_s_new_selected_id;
    };
    
    ctor_model_sel_err(any_new_root_node: sn_ebuilder_node_data,
        any_s_new_selected_id: string,
        any_s_err: string) is {
        
        ctor_err(any_s_err);
        new_root_node = any_new_root_node;
        s_new_selected_id = any_s_new_selected_id;
    };
    
    ctor_sel(any_s_new_selected_id: string) is {
        ctor();
        s_new_selected_id = any_s_new_selected_id;
    };
    
    ctor_model(any_new_root_node: sn_ebuilder_node_data) is {

        ctor();
        new_root_node = any_new_root_node;
    };
    
    is_approved(): bool is {
        result = (n_status != EB_STATUS_ERROR);
    };
};

orb data sn_ebuilder_new_state 
    using package=com.verisity.ebuilder.model.gencode ;

'>



