<'

import japplet_service_edl.e;
import gencode/top_japplet.e;
import sni_japplet_command.e;

extend debug {
    applet: bool;
};

extend display {
    
    //    p_japplet: sni_japplet_service = null;
    
    p_applet_started : bool ;
    
    p_applet_data :sn_japplet_data;
    
    html_execute(s:string ) is {
        specman(s);
    };
     
    init() is also{
        p_applet_started = FALSE; 
    };
    
    get_applet_tmpl_dir(): string is {
        result = append(get_applet_home(), "/tmpl");
       
    };

    get_applet_home(): string is {
        result = get_symbol("SN_JBROWSERS_HOME");
    };
    
    get_applet_class_dir():string is {
        result = append(get_applet_home(), "/class");
    };
    
    get_applet_tmpl_in_header_file_name():string is {
        result = append(get_applet_tmpl_dir(), "/", "sn_applet_in_header_tmpl.txt"); 
    };
    
    get_applet_tmpl_post_header_file_name():string is {
        result = append(get_applet_tmpl_dir(), "/", "sn_applet_post_header_tmpl.txt"); 
    };
    
    get_applet_in_header(): string is {
            
        var s_file_tmpl: string = get_applet_tmpl_in_header_file_name();
        if (! files.file_exists(s_file_tmpl)) {
            sn_error(append("Cannot find applet template file: ", s_file_tmpl));
        };
        result =   files.get_file_text(s_file_tmpl);
        
    };
    
    get_applet_post_header(n_port: int,s_codebase:string): string is {
        
        var s_file_tmpl: string = get_applet_tmpl_post_header_file_name();
        if (! files.file_exists(s_file_tmpl)) {
            sn_error(append("Cannot find applet template file: ", s_file_tmpl));
        };
        var s_template  :  string = files.get_file_text(s_file_tmpl);
        var s_template1 :  string = str_replace( s_template,"<<CODEBASE>>",s_codebase);
        result = str_replace(s_template1, "<<PORT>>", str_dec(n_port));            
    }; 
    
    internal_start_applet_connection(port_num :int): sn_japplet_data is {
        
        if (! p_applet_started) {
            out("Starting AppletConnection...");
            var s_err: string = jspecview_deli.start_japp_class(
                "com.verisity.jspecview.JAppletService");
            
            if (s_err != "") { 
                error("Failed starting : ", s_err); 
            } else {
                out("Started AppletConnection ")
            };
                
            p_applet_started = TRUE; 
        };
        
        
        var p_japplet: sni_japplet_service  = 
            orb lookup service  sni_japplet_service SN_APPLET_SERVICE_NAME ;
        
        ASSERT(p_japplet !=NULL); 
        
        if (debug.applet) {
            p_japplet.debug(TRUE);
        };
       
        //start the server
        p_applet_data = p_japplet.runServer(port_num);        
        
        // register the applet_command service:
       var p_applet_command : sni_japplet_command_impl = 
            sys.create_new_japplet_command_service_impl();         
            
//            NEW sni_japplet_command_impl.ctor();
        
        orb register service  p_applet_command  sni_japplet_command SN_APPLET_COMMAND;
        result = p_applet_data ;
        
    };
    
    start_applet_connection(port_num:int): int is {
        p_applet_data = internal_start_applet_connection(port_num);
        if (p_applet_data == NULL) {
            result = UNDEF;
        } else {
            result = p_applet_data.p_n_port;
        };
    };
    
    restart_applet_connection(port_num:int) is{
       p_applet_data = internal_start_applet_connection(port_num);  
    };
    
    print_applet_info() is {
        
        p_applet_data = internal_start_applet_connection(UNDEF);
        if ( p_applet_data == NULL) {
            out("<<< Failed running Applet Connection >>>");
        } else {
            out("Applet Server Info: ");
            out("  Port: ", p_applet_data.p_n_port);
            out("  Host Name: ", p_applet_data.p_s_host_name);
            out("  Host Address: ", p_applet_data.p_s_host_address);
        };
    };
    
    get_port_num():int is{
        return p_applet_data.p_n_port;        
    };
    
    get_host_name():string is{
        return p_applet_data.p_s_host_name;        
    };
    
    quote_for_javascript(s:string):string is{
        result = str_replace(s,"#","##");
        result = str_replace(result,"'" ,"#0");
        result = str_replace(result,"\"","#1");
        result = str_replace(result,"\\","#2");
        result = str_replace(result,"&" ,"#3");
    };
};


    

extend files {
    
    get_file_text(s_file: string): string is {

        try {
            
            for each line (L) in file s_file {
                if (index > 0) {
                    result = append(result, "\n");
                };
                result = append(result, L);
            };
        };
    };
    
};


// EXAMPLE 
extend global {
    go(s_file_html: string) is {
        create_applet_example(s_file_html);
    };
    
  
    
    create_applet_example(s_file_html: string) is {
        var n_port: int = display.start_applet_connection(UNDEF);
        var s_codebase:string = display.get_applet_class_dir();
        if (n_port < 0) {
            sn_error("Cannot start applet connection server");
        };
        
        var s_cmd: string = "print 123";
        var lst_html: list of string = {
        
            "<HTML>";
            "";
            "<HEAD>";
            display.get_applet_in_header();
            "</HEAD>";
            display.get_applet_post_header(n_port,s_codebase);
            "";
            "<FORM NAME=\"widgets1\">";
            appendf("    <INPUT TYPE=\"button\" NAME=\"%s\"  VALUE=\"%s\" onClick=\"specmanCommand('%s')\">",
                s_cmd, s_cmd, s_cmd);
            "</FORM>";
            "";    
            "</HTML>"};
        
        files.write_string_list(s_file_html, lst_html);
        
        out("Created HTML file:\n    ", s_file_html);
        
    };
    
};

extend  sn_jspecview_deli{
    get_japplet_port_file_name(): string is {
        
        result = append(
            files.get_temp_dir(), 
            "/_japplet_portfile",dec(getpid()), ".dat" );
    }; 
};

extend global{ 
    
     post_restore_actions(string) is also {
        
        -- fog GC only
        if (string == NULL) then
             {return;};         
        reconnect_japplet_server(); 
     };
     
     reconnect_japplet_server() is {
         var s_japplet_port_file_name: string = jspecview_deli.get_japplet_port_file_name();
         if (files.file_exists(s_japplet_port_file_name)){
             var file_text : string = files.get_file_text(s_japplet_port_file_name);
             if (file_text ~ "/\d/"){
                 var port_num: int = files.get_file_text(s_japplet_port_file_name).as_a(int);  
                 out("reconnecting japplet server on port  " , port_num );
                 display.restart_applet_connection( port_num );         
             };
         };      
     };
     
     pre_restore_actions(string) is also {
         
         -- fog GC only
         if (string == NULL) then
             {return;};
         
         if(jspecview_deli != NULL){            
             if(display.p_applet_data != NULL){                
                 var s_japplet_port_file_name: string = jspecview_deli.get_japplet_port_file_name();
                 
                 // remove port file
                 if (files.file_exists(s_japplet_port_file_name)){
                     files.file_delete(s_japplet_port_file_name);                    
                     ASSERT(! files.file_exists(s_japplet_port_file_name));
                 };
                 var s_port : string = display.get_port_num().as_a(string);
                 var s_list :list of string = {s_port};                 
                 files.write_string_list(s_japplet_port_file_name,s_list);
                 
             };
         };
         
         
         
     };
     
};



extend sys{
    create_new_japplet_command_service_impl() : sni_japplet_command_impl is {
        result = NEW sni_japplet_command_impl.ctor();
    };
};

    
'>

<'

define <show_japplet_info'command> "SNJAPP" as {
    display.print_applet_info()
};
    
'>
