<'

import jbrowsers_edl;
import gencode/top_jbrowsers;
import jbrowsers_config;
import ../when_patch.e;
import ../doc_engine.e;
import ../params.e;
    
define KIND_UNDEF 0;
define KIND_UNIT_INSTANCE 1;
define KIND_UNIT_REF 2;
define KIND_STRUCT 3;
define KIND_SCALAR 4;


define MEMBER_KIND_NONE 0;
define MEMBER_KIND_METHOD 1;
define MEMBER_KIND_TCM 2;
define MEMBER_KIND_FIELD 3;
define MEMBER_KIND_EVENT 4;
define MEMBER_KIND_COVER_GROUP 5;
define MEMBER_KIND_COVER_ITEM 6;
define MEMBER_KIND_CONSTRAINT 7;
//define KIND_UNIT 5;







extend global {
    
    p_jbrowsers: sn_jbrowsers;
    
    init() is also {
        p_jbrowsers = NEW sn_jbrowsers.ctor();
    };
};



struct sn_ebrowsers_service like sni_ebrowsers_service {
    
    ctor() is {
      
    };
      
    
    edit_source(n_source_ref: int) is {
        var si: source_item = new source_item with {
            .source_ref = n_source_ref;
        };
        
        p_edit_source(si);
        
    };
    
    p_edit_source(si: source_item) is {
        var mdl: module = si.source_module();
        if (mdl != NULL) {

            if ((session.get_developer_mode() == none) and
                (mdl.module_num <= symtab.last_sn_module)) {
                // user mode with Specman file - can't edit file
                out("+--------------------------------------------");
                out("|  Source is not available: at Specman's private modules");
                out("+--------------------------------------------");
                
            } else {
                
                try {
                    var n_line: int = si.source_line();
                    var s_file: string = mdl.file_name;
                    
                    var s_cmd: string = appendf("edit %s %d", s_file, n_line);
                    var s_err: string = safe_specman_command(s_cmd, FALSE);
                };
            };
        };
    };
        
    show_source(n_source_ref: int) is {
        var si: source_item = new source_item with {
            .source_ref = n_source_ref;
        };
            
        p_show_source(si);
    };
            
    get_source(n_source_ref: int): list of string is {
        
        var n_width: int = get_config(jbrowsers, source_width);
        
        var si: source_item = new source_item with {
            .source_ref = n_source_ref;
        };

        var mdl: module = si.source_module();
        
        if ((session.get_developer_mode() == none) and
            (mdl.module_num <= symtab.last_sn_module)) {
            // user mode with Specman file - return general text
            result.add("At Specman's private modules");
            result.add("2");
            result.add("");
            result.add("  Source file is not available");

        } else {
            if (mdl != NULL) {
                var n_line: int = si.source_line();
                var s_file: string = mdl.file_name;
                
                var lst_lines : list of string = 
                    get_source_lines(s_file, n_line, n_width, NULL).all(it !~ "/^[\+]/");
                
                var n_center_line: int = 0;
                for each (s_line) in lst_lines {
                    if (s_line ~ "/^[\|](.)(.*)$/") {
                        
                        lst_lines[index] = $2;
                        if ($1 == "*") {
                            n_center_line = index;
                        };
                    };
                };
                
                result.add(s_file);
                result.add(str_dec(n_center_line));
                result.add(lst_lines);
            };
        };
        
    };
        
    p_show_source(si: source_item) is {
        try {
            
            if (display.on) {
                display.show_source(si);
                set_specview_busy_mode( "not_busy" );               
            } else {
                show_source_item(si);
                out("");
            };
                
        };
    };
    
    
    set_config_bool(s_category: string, s_option: string, f_val: bool) is {
        try {
            var cmd: string = appendf("set_config(%s, %s, %s)",
                s_category, s_option, f_val);

            var s_err: string = safe_specman_command(cmd, FALSE);
            
            p_jbrowsers.raise_dirty_flag();

        };
       
        // patch
        p_jbrowsers.refresh_if_dirty();
    };

      

};        

extend global {
    register_jb_services() is also {
        p_jbrowsers.register_service();
    };
};


struct sn_jbrowsers {
    p_ebrowsers_service: sn_ebrowsers_service;
    p_jbrowsers_deli: sn_jbrowsers_deli;
    p_lst_backpointer_wildcards: list of string;
    p_lst_filter_fields_wildcards: list of string;
    p_lst_filter_subclasses_wildcards: list of string;
    p_s_filter_type_field: string;
    p_s_browsers_menu_key: string;
    p_s_html_help_file: string;

    ctor() is {
        p_ebrowsers_service = NEW sn_ebrowsers_service.ctor();
        p_jbrowsers_deli = NEW sn_jbrowsers_deli.ctor();
        p_s_browsers_menu_key = "browsers";
        p_s_html_help_file = append(
            get_symbol("SPECMAN_GUI_EXTRAS"), "/jb/resources/com.verisity.utils.ui/browsers_help.html");
        
    };

    register_service() is {
        orb register service p_ebrowsers_service sni_ebrowsers_service EBROWSERS_SERVICE_NAME;
    };

    set_backpointer_wildcards(lst_wildcards: list of string) is {
        p_lst_backpointer_wildcards = lst_wildcards;
    };
    
    set_filter_fields_wildcards(lst_wildcards: list of string) is {
        p_lst_filter_fields_wildcards = lst_wildcards;
    };

    set_filter_subclasses_wildcards(lst_wildcards: list of string) is {
        p_lst_filter_subclasses_wildcards = lst_wildcards;
    };

    is_filter_wildcard_field(F: field): bool is {
        
        result = p_field_has_matching_wildcard(p_lst_filter_fields_wildcards , F);
    };
    
    is_filter_wildcard_subclass(sd: struct_descriptor): bool is {
        
        result = p_struct_has_matching_wildcard(p_lst_filter_subclasses_wildcards , sd);
    };
    
    is_filter_type_field(F: field): bool is {
        
        result = FALSE;

        var td: type_descriptor = 
           F.base_type.is_a_list() ? F.base_type.elem_type() : F.base_type;
        
        if (td.is_a_struct()) {
            var s_field_sd: struct_descriptor = td.as_a(struct_descriptor);
            try {
                var s_filter_sd: struct_descriptor = 
                    type_called(p_s_filter_type_field).as_a(struct_descriptor);
                result = type_is_a_child_of(s_field_sd, s_filter_sd);
            };
        };

    };
    
    is_backpointer_field(F: field): bool is {
        result = p_field_has_matching_wildcard(p_lst_backpointer_wildcards, F);
    };

    p_field_has_matching_wildcard(lst_wildcards: list of string, F: field): bool is {
        if (lst_wildcards.is_empty()) {
            return FALSE;
        };
        
        var s_name: string = F.name;
        var sd_parent: struct_descriptor = F.Context_struct; 
        var s_td_name: string = sd_parent.elem_type().name;
        var s_full_name: string = append(s_td_name, ".", s_name);
        
        result = p_has_matching_wildcard(lst_wildcards, s_full_name);
    };

    p_struct_has_matching_wildcard(lst_wildcards: list of string, 
        sd: struct_descriptor): bool is {
        if (lst_wildcards.is_empty()) {
            return FALSE;
        };
        
        var s_name: string = sd.name;
        
        result = p_has_matching_wildcard(lst_wildcards, s_name);
    };

    p_has_matching_wildcard(lst_wildcards: list of string, str: string): bool is {
        
        if (lst_wildcards.is_empty()) {
            return FALSE;
        };

        // check if matches wildcards
        for each (s_wildcard) in lst_wildcards {
            if (str ~ s_wildcard) {
                return TRUE;
            };
        };
        
        return FALSE;
    };

    break_str_list_to_list(s_value: string, s_seperator: string): list of string  is {

        var s_lst_strs: string = str_trim(s_value);
        if (s_lst_strs != "") {
            var lst_strs: list of string = str_split(str_trim(s_lst_strs), s_seperator);
            for each (s_str) in lst_strs {
                var s_final_str: string = str_trim(s_str);
                if (s_final_str != "") {
                    result.add(str_trim(s_final_str));
                };
            };
        };
        
    };
    
    
    raise_dirty_flag() is empty;
    
    refresh_if_dirty() is empty;
    
    create_browsers_menu() is {
        if (! display.on) {
            return;
        };
        
        if (! display.is_custom_menu_exists(p_s_browsers_menu_key)) {
            
            // add top menu browserss
            display.add_custom_menu(p_s_browsers_menu_key, "Browsers", 0);
            
            display.add_custom_menu_item(p_s_browsers_menu_key, 
                "classbrowser_sys", "Class Browser", "", 0);
            
            display.add_custom_menu_separator(p_s_browsers_menu_key);
            
            display.add_custom_menu_item(p_s_browsers_menu_key, 
                "databrowser_sys", "Data Browser", "", 0);
            
            display.add_custom_menu_separator(p_s_browsers_menu_key);
            
            display.add_custom_menu_item(p_s_browsers_menu_key, 
                "help_jbrowsers", "Help on JBrowsers", "", 0);
        };
            
    };
};

extend display {
    
    custom_menu_clicked(s_menu_key: string, s_menu_item_key: string, 
        s_menu_item_label: string, s_optional_param: string) is also {
        
        if (p_jbrowsers != NULL) {
            
            if (s_menu_key == p_jbrowsers.p_s_browsers_menu_key) {
                
                if (s_menu_item_key == "classbrowser_sys") {
                    compute safe_specman_command("show class sys", FALSE);
                    
                } else if (s_menu_item_key == "databrowser_sys") {
                    compute safe_specman_command("show data sys", FALSE);
                    
                } else if (s_menu_item_key == "help_jbrowsers") {
                    display.open_web_location1(p_jbrowsers.p_s_html_help_file);
                    
                };
            };
        };
    };
};

struct sn_jbrowsers_deli {
    p_jbrowsers_service: sni_jbrowsers_service;
        
    ctor() is {
        p_jbrowsers_service = NULL;
    };
    
    is_service_active(): bool is {
        result = (p_jbrowsers_service != NULL);
    };
    
    p_get_service(): sni_jbrowsers_service is {
        
        if (p_jbrowsers_service == NULL) {
            
            var s_err: string = 
                jspecview_deli.start_japp_class(
                "com.verisity.jbrowsers.JBrowsersService");
            
            if (s_err != "") { 
                error("Failed starting jbrowsers : ", s_err); 
            } else {
                // out("Started JBrowsers");
            };
            
            p_jbrowsers_service =
                orb lookup service sni_jbrowsers_service 
                JBROWSERS_SERVICE_NAME;
            
            ASSERT(p_jbrowsers_service != NULL);
                
        };
        
        result = p_jbrowsers_service;
    };
    
};
    


extend jbrowsers config_options {

    
    pre_store_to_system(option : string, value : string)  is also {

        if (option == "back_pointer_wildcard") {
            p_jbrowsers.set_backpointer_wildcards(
                p_jbrowsers.break_str_list_to_list(value, ";"));
        };


        if (option == "filter_fields_wildcard") {
            p_jbrowsers.set_filter_fields_wildcards(
                p_jbrowsers.break_str_list_to_list(value, ";"));
        };

        if (option == "filter_subclasses_wildcard") {
            p_jbrowsers.set_filter_subclasses_wildcards(
                p_jbrowsers.break_str_list_to_list(value, ";"));
        };

        if (option == "filter_fields_by_type") {
            p_jbrowsers.p_s_filter_type_field = value;
        };

        
    };	 
};



'>

<> User menu

<'

extend global {
    
    init() is also {
        if (p_jbrowsers != NULL) {
            p_jbrowsers.create_browsers_menu();
        };
    };
    
     post_restore_actions(string) is also {
        
        -- fog GC only
        if (string == NULL) then
             {return;};         
         
        if (p_jbrowsers != NULL) {
            p_jbrowsers.create_browsers_menu();
        };
     };
    
    
};

//display user menu separator;
//display user menu "show class sys" "show class sys";
//display user menu "show data sys" "show data sys";

'>
