<'

import jform_edl;

extend global {
    
    p_jform: sn_jform;
    
    init() is also {
        p_jform = NEW sn_jform.ctor();
    };
    
};

struct sn_jform {
    
    p_jform_deli: sn_jform_deli;

    ctor() is {
        p_jform_deli = NEW sn_jform_deli.ctor();
    };
    
    create_jform_window(props: sn_jform_page_props,
        n_columns: int) is {
        
        p_jform_deli.create_jform_window(props, n_columns);
    };
    
    demo(): sn_jform_page_props is {
        var page: sn_jform_page_props = 
            p_jform_deli.create_page_from_file("jform_demo.dat");
        
        page.pprint();

        return page;
    };
    
    demo_win() is {
        var page: sn_jform_page_props = demo();
        p_jform.create_jform_window(page, 1);
    };

    
    
};

struct sn_jform_deli {
    p_jform_service: sni_jform_service;
        
    ctor() is {
        p_jform_service = NULL;
    };
    
    is_service_active(): bool is {
        result = (p_jform_service != NULL);
    };
    
    p_get_service(): sni_jform_service is {
        
        if (p_jform_service == NULL) {
            
            var s_err: string = 
                jspecview_deli.start_japp_class(
                "com.verisity.utils.jform.JFormService");
            
            if (s_err != "") { 
                error("Failed starting JForm : ", s_err); 
            } else {
                // out("Started Jform");
            };
            
            p_jform_service =
                orb lookup service sni_jform_service 
                JFORM_SERVICE_NAME;
            
            ASSERT(p_jform_service != NULL);
                
        };
        
        result = p_jform_service;
    };
    
    create_jform_window(props: sn_jform_page_props,
        n_columns: int) is {
        
        p_get_service().create_jform_window(props, n_columns);
    };
    
    
    create_page_from_file(s_file: string): sn_jform_page_props is {
'>

        result = new sn_jform_page_props;
        var hash_groups: list (key: sName) of sn_jform_group_props;
        
        if (! files.file_exists(s_file)) {
            sn_error(append("Can't find file: ", s_file));
        };
        
        for each line (L) in file s_file {
            // option
            if (L ~ "/^OPTION(.*)$/") {
                var s_option_line : string = $1;
                
                var s_blank: string = "[ \t]*";
                var s_str_re: string = "\"([^\"]*)\"";
                var s_name_re: string = "([^ \t]+)";
                var s_num_re: string = "([-]?[0-9]+)";
                
                var s_option_re: string = append("/^",
                    s_blank, s_name_re, // name: last_name
                    s_blank, s_name_re, // group-name: personal
                    s_blank, s_str_re, // label:    "Last Name"
                    s_blank, s_str_re, // initial-text:  "Peri Glass"
                    s_blank, s_num_re, // num-chars:  13
                    s_blank, s_str_re, // int-limits: "" (also: "1;120")
                    s_blank, s_str_re, // tooltip: "Your last name"
                    s_blank, s_str_re, // regexp: "" (ignore)
                    s_blank, s_name_re, // kind: STRING|INT|ENUM|BOOL
                    s_blank, s_name_re, // undefable: TRUE|FALSE
                    s_blank, s_str_re, // values: "" (also: "spider;language;temporals")
                    s_blank, s_str_re, // enable-pairs: "" (ignore)
                    s_blank, "$/");
                
                if (s_option_line !~ s_option_re) {
                    sn_error("no match");
                };
                
                if (s_option_line ~ s_option_re) {

                    var arrOfValues: list of string;
                    var arrOfPairEnablers: list of sn_jform_pair_enabler;

                    var option_name:= $1;
                    var s_group_name:= $2;
                    var group: sn_jform_group_props = hash_groups.key(s_group_name);
                    if (group == NULL) {
                        group = new sn_jform_group_props;
                        group.sName = s_group_name;
                        hash_groups.add(group);
                    };

                    var title:= $3;
                    var init_str:= $4;
                    var num_chars: int = $5.as_a(int);
                        
                    var int_limits: sn_pair_int_props;
                    if ($6 != "") {
                        var int_limts_str: list of string = str_split(str_trim($6), "/[ \t]*;[ \t]*/");
                        if ((int_limts_str.size() > 0) and  (int_limts_str.size() != 2)) {
                            sn_error("Bad: int-limits");
                        };
                        int_limits = new sn_pair_int_props with {
                            .n1 = int_limts_str[0].as_a(int);
                            .n2 = int_limts_str[1].as_a(int);
                        };
                    };
                    
                    var tooltip:= $7;
                    var regexp:= $8;
                    var kind:= $9.as_a(sn_jform_kind).as_a(int);
                    var undefable: bool = ($10 == "TRUE");
                        
                    if ($11 != "") {
                        arrOfValues = str_split(str_trim($11), "/[ \t]*;[ \t]*/");
                        print arrOfValues;
                    };
                    
                    //if ($12 != "") {
                        //var arrOfPairStr: list of string = str_split(str_trim($12), "/[ \t]*;[ \t]*/");
                        //print arrOfPairStr;
                        //for each (pair_str) in arrOfPairStr {
                        //    var lst_pair: list of string = str_split(str_trim($12), "/[ \t]*,[ \t]*/");
                        //    var pair: sn_jform_pair_enabler = 
                        //        NEW sn_jform_pair_enabler.sn_ctor_sn_jform_pair_enabler(
                        //        lst_pair[0], (lst_pair[0] == "TRUE"));
                        //    
                        //    print pair;
                        //    arrOfPairEnablers.add(pair);
                        //};
                    //};
                    
                    
                    var option: sn_jform_item_props = 
                            NEW sn_jform_item_props.sn_ctor_sn_jform_item_props(
                            option_name,
                            title,
                            init_str,
                            num_chars,
                            int_limits,
                            tooltip,
                            regexp,
                            kind,
                            undefable,
                            arrOfValues,
                            arrOfPairEnablers);
                    group.arrOfFormItemProps.add(option);
                   
                };
                
            // group
            } else if (L ~ "/^GROUP(.*)$/") {
                var s_group_line : string = $1;
                if (s_group_line ~ "/^[ \t]*([^ \t]+)[ \t]*\"([^\"]*)\"[ \t]*$/") {
                    var s_name: string = $1;
                    var s_title: string = $2;
                    var group: sn_jform_group_props = hash_groups.key(s_name);
                    if (group == NULL) {
                        group = new sn_jform_group_props;
                        group.sName = s_name;
                        hash_groups.add(group);
                    };
                    
                    group.sTitle = s_title;
                    //out("GROUP ", $1, " ", $2);
                };
                
            // page
            } else if (L ~ "/^PAGE(.*)$/") {
                var s_page_line : string = $1;
                if (s_page_line ~ "/^[ \t]*\"([^\"]*)\"[ \t]*$/") {
                    //out("PAGE ", $1);
                    result.sTitle = $1;
                };
            };
            
        };
        
        result.arrOfFormGroupProps = hash_groups.all(TRUE);

<'        
    };
    
};
    
'>


<'

extend sn_jform_page_props {
    pprint() is {
        
        out("Page: ", sTitle);
        out("======================");
        for each (group) in arrOfFormGroupProps {
            out("Group ", group.sName, ": ", group.sTitle);
            for each (item) in group.arrOfFormItemProps {
                var sValues: string = "";
                for each (sVal) in item.arrOfValues {
                    if (index > 0) {
                        sValues = append(sValues, ", ");
                    };
                    sValues = append(sValues, sVal);
                };

                var s_pairs: string = "";
                for each (pair) in item.arrOfPairEnablers {
                    if (index > 0) {
                        s_pairs = append(s_pairs, ", ");
                    };
                    var sPair: string = append(pair.sUponValue, ":", pair.sArrDisabledItems);
                    s_pairs = append(s_pairs, sPair);
                };

                
                out("  Item ", item.sOptionName, ":");
                out("      title: ", item.sLabel);
                out("      initial: ", item.sInitialText);
                out("      chars:   ", item.nCharsWidth);
                out("      int limits:   ", item.intLimits == NULL ? 
                    "NULL" : append(item.intLimits.n1, ", ", item.intLimits.n2));
                out("      tooltip: ", item.sToolTip);
                out("      regexp:    ", item.sRegExp);
                out("      kind:    ", item.nType);
                out("      undefable:  ", item.fUndefable);
                out("      values:  ", sValues);
                out("      pairs:   ", s_pairs);
                
                
                
            };
        };
        
    };
};
'>



    
