<'

// Define the JForm service interface
define JFORM_SERVICE_NAME "JFORM";

define JFORM_BOOLEAN 1;
define JFORM_INT 2;
define JFORM_STRING 3;
define JFORM_ENUM 4;


type sn_jform_kind: [BOOL=1, INT=2, STRING=3, ENUM=4];

// the Java databrowser service
orb interface sni_jform_service 
    using package=com.verisity.utils.jform.model.gencode {
    
    create_jform_window(props: sn_jform_page_props,
        n_columns: int) is sync;
    
};

// Define pair of: item name + enabled flag
struct sn_jform_pair_enabler {

    sUponValue: string;
    sArrDisabledItems: list of string;
    
    ctor(sAnyUponValue: string, sAnyArrDisabledItems: list of string) is {
        
        sUponValue = sAnyUponValue;
        sArrDisabledItems = sAnyArrDisabledItems;
    };
};

orb data sn_jform_pair_enabler 
    using package=com.verisity.utils.jform.model.gencode;



// Define pair of name + string-value
struct sn_key_val {
    s_option_name: string;
    s_value: string;
    
    ctor(any_s_option_name: string, any_s_value: string) is {
        s_option_name = any_s_option_name;
        s_value = any_s_value;
    };
};

orb data sn_key_val 
    using package=com.verisity.utils.jform.model.gencode;


struct sn_item_properties {
    name: string;
    value: string;
    enabled: bool;
    
    ctor(any_name: string, any_value: string, 
        any_enabled: bool) is {
        name = any_name;
        value = any_value;
        enabled = any_enabled;
    };
};

orb data sn_item_properties 
    using package=com.verisity.utils.jform.model.gencode;



// Define a pair of numbers
struct sn_pair_int_props {
    n1: int;
    n2: int;
    
    ctor(any_n1: int, any_n2: int) is {
        n1 = any_n1;
        n2 = any_n2;
    };
};

orb data sn_pair_int_props 
    using package=com.verisity.utils.jform.model.gencode;


// Define item data properties
struct sn_jform_item_props {

  sOptionName: string;
  sLabel: string;
  sInitialText: string;
  fInitialyEnabled: bool;
  nCharsWidth: int;
  intLimits: sn_pair_int_props;
  sToolTip: string;
  sRegExp: string;
  nType: int;
  fUndefable: bool;  
  fNotifyChanges: bool;
  arrOfValues: list of string;
  arrOfPairEnablers: list of sn_jform_pair_enabler;

};


orb data sn_jform_item_props 
    using package=com.verisity.utils.jform.model.gencode;


// Define group data properties
struct sn_jform_group_props {

  sTitle: string;
  sName: string;
  arrOfFormItemProps: list of sn_jform_item_props;
};


orb data sn_jform_group_props 
    using package=com.verisity.utils.jform.model.gencode;



// Define page data properties
struct sn_jform_page_props {

  sTitle: string;
  arrOfFormGroupProps: list of sn_jform_group_props;
};


orb data sn_jform_page_props 
    using package=com.verisity.utils.jform.model.gencode;

struct sn_jform_page_input {
    props: list of sn_item_properties;
};

orb data sn_jform_page_input 
    using package=com.verisity.utils.jform.model.gencode;



'>

