<'
////////////////////////////////////////////////////////////////////////
    
extend global {
     post_restore_actions(string) is also {
        
        -- fog GC only
        if (string == NULL) then
             {return;};         
         
        display.create_evm_bookmarks_menu();
     };
    
};
    
'>

IMPORTANT:  
If you change the location of menu items, pay attention to the method 
'update_custom_menu_item' - it has a parameter 'n_menu_item_index'
that should relate to the menu item index.


<'



    
    
extend display {
    p_s_evm_menu_key: string;
    p_s_evm_add_bookmark_key: string;
    p_s_evm_label_for_add: string;
    p_s_evm_last_evm_key: string;
    p_s_evm_label_for_last: string;
        
    init() is also {
        p_s_evm_menu_key = "evm_bookmarks";
        p_s_evm_add_bookmark_key = "add_bookmark";
        p_s_evm_label_for_add = "Add Bookmark:";
        p_s_evm_last_evm_key = "last_evm";
        p_s_evm_label_for_last = "Last eVM:";
        
        display.create_evm_bookmarks_menu();
        
    };
    
    get_evm_bookmarks_file_name(): string is {
        result = appendf("%s/.sn_evm_bookmarks", get_symbol("HOME"));
    };
       
    
    get_evm_label_for_add(s_suffix: string): string is {
        result = append(p_s_evm_label_for_add, " ", s_suffix);
    };
        
    get_evm_label_for_last(s_suffix: string): string is {
        result = append(p_s_evm_label_for_last, " ", s_suffix);
    };
        
    create_evm_bookmarks_menu() is {
        #ifdef EBUILDER {
            actual_create_evm_bookmarks_menu();
        };
        
    };

    actual_create_evm_bookmarks_menu() is {
        if (! display.on) {
            return;
        };
        
        if (! is_custom_menu_exists(p_s_evm_menu_key)) {
            
            var s_add_bookmark_line: string;
            var s_last_evm_line: string;
            var lst_bookmark_lines: list of string;
            var s_evm_name: string;
            var s_evm_title: string;
            
            compute read_evm_bookmarks_file(
                s_add_bookmark_line, s_last_evm_line, lst_bookmark_lines);

            // add top menu eVMs
            add_custom_menu(p_s_evm_menu_key, "eVMs", 2);

            
            // add items: Categories and List
            add_custom_menu_item(p_s_evm_menu_key, "evm_categories", "eVM Table of Contents", "", 4);
            //add_custom_menu_item(p_s_evm_menu_key, "evm_list", "All eVMs", "", 1);
            
            // seperator
            add_custom_menu_separator(p_s_evm_menu_key);
            

            // add menu item:  Last eVM
            if (s_last_evm_line == "") {
                add_custom_menu_item(p_s_evm_menu_key, p_s_evm_last_evm_key, 
                    get_evm_label_for_last("<None>"), "", 0);
            } else {
                if (get_evm_name_and_title(s_last_evm_line, s_evm_name, s_evm_title)) {
                
                    add_custom_menu_item(p_s_evm_menu_key, p_s_evm_last_evm_key, 
                        get_evm_label_for_last(s_evm_title), 
                        append(s_evm_name, " ", s_evm_title), 0);
                };
                    
            };

            // seperator
            add_custom_menu_separator(p_s_evm_menu_key);
            
            // add menu item:  Add Bookmark
            if (s_add_bookmark_line == "") {
                add_custom_menu_item(p_s_evm_menu_key, p_s_evm_add_bookmark_key, 
                    get_evm_label_for_add("<None>"), "", 0);
            } else {
                if (get_evm_name_and_title(s_add_bookmark_line, s_evm_name, s_evm_title)) {
                    
                    add_custom_menu_item(p_s_evm_menu_key, p_s_evm_add_bookmark_key, 
                        get_evm_label_for_add(s_evm_title), 
                        append(s_evm_name, " ", s_evm_title), 0);
                };
                    
            };

            // seperator
            add_custom_menu_separator(p_s_evm_menu_key);

            // read bookmarks from file
            for each (s_line) in lst_bookmark_lines {
                if (get_evm_name_and_title(s_line, s_evm_name, s_evm_title)) {
                    add_evm_bookmark_menuitem(index, s_evm_name, s_evm_title);
                };
            };
        };
        
    };
    
    add_evm_bookmark(s_evm_name: string, s_evm_title: string) is {
        if (is_evm_bookmark_exists(s_evm_name)) {
            return;
        };
        
        // add to file
        var s_add_bookmark_line: string;
        var s_last_evm_line: string;
        var lst_bookmark_lines: list of string;
            
        compute read_evm_bookmarks_file(
            s_add_bookmark_line, s_last_evm_line, lst_bookmark_lines);
        
        var s_line: string = appendf("%s %s", s_evm_name, s_evm_title);
        lst_bookmark_lines.add(s_line);

        write_evm_bookmarks_file("", s_last_evm_line, lst_bookmark_lines);
            
        // add to menu
        add_evm_bookmark_menuitem(lst_bookmark_lines.size() - 1, s_evm_name, s_evm_title);
    };

    add_evm_bookmark_menuitem(n_index: int, s_evm_name: string, s_evm_title: string) is {
        // add to menu
        var s_title: string = appendf("%2s. %s", str_dec(n_index + 1), s_evm_title);
        add_custom_menu_item(p_s_evm_menu_key, s_evm_name, s_title, "", -1);
        
    };
    
    
    set_evm_bookmark_candidate(s_evm_name: string, s_evm_title: string) is {
        if (is_evm_bookmark_exists(s_evm_name)) {
            return;
        };

        // add to file
        var s_add_bookmark_line: string;
        var s_last_evm_line: string;
        var lst_bookmark_lines: list of string;
            
        compute read_evm_bookmarks_file(
            s_add_bookmark_line, s_last_evm_line, lst_bookmark_lines);

        s_add_bookmark_line = appendf("%s %s", s_evm_name, s_evm_title);
        write_evm_bookmarks_file(s_add_bookmark_line, s_last_evm_line, lst_bookmark_lines);
        

        // update menu
        display.update_custom_menu_item(
            display.p_s_evm_menu_key, 4, display.p_s_evm_add_bookmark_key, 
            get_evm_label_for_add(s_evm_title), append(s_evm_name, " ", s_evm_title));
        
    };
    
    update_last_evm(s_evm_name: string, s_evm_title: string) is {

        // add to file
        var s_add_bookmark_line: string;
        var s_last_evm_line: string;
        var lst_bookmark_lines: list of string;
            
        compute read_evm_bookmarks_file(
            s_add_bookmark_line, s_last_evm_line, lst_bookmark_lines);

        s_last_evm_line = appendf("%s %s", s_evm_name, s_evm_title);
        write_evm_bookmarks_file(s_add_bookmark_line, s_last_evm_line, lst_bookmark_lines);

        // update menu
        display.update_custom_menu_item(
            display.p_s_evm_menu_key, 2, display.p_s_evm_last_evm_key, 
            get_evm_label_for_last(s_evm_title), append(s_evm_name, " ", s_evm_title));
        
    };
    
    
    get_evm_name_and_title(s_line: string, s_evm_name: *string, s_evm_title: *string): bool is {
        if (s_line ~ "/^([^ ]+)[ ]+(.*)$/") {
            result = TRUE;
            
            s_evm_name = $1;
            s_evm_title = $2;
            
        } else {
            result = FALSE;
            
            s_evm_name = "";
            s_evm_title = "";
        };
    };
        
    
    read_evm_bookmarks_file(s_add_bookmark_line: *string, s_last_evm_line: *string,
        lst_bookmark_lines: list of string): bool is {
        
        // read bookmarks from file
        var s_evm_bm_file: string = get_evm_bookmarks_file_name();
        if (files.file_exists(s_evm_bm_file)) {
            result = TRUE;
            
            for each line (s_line) in file s_evm_bm_file {
                if (s_line ~ "/^ADD (.*)$/") {
                    s_add_bookmark_line = $1;
                } else if (s_line ~ "/^LAST (.*)$/") {
                    s_last_evm_line = $1;
                } else if (s_line ~ "/^BOOKMARK (.*)$/") {
                    lst_bookmark_lines.add($1);
                };
            };
        } else {
            result = FALSE;
            
            s_add_bookmark_line = "";
            s_last_evm_line = "";
            lst_bookmark_lines.clear();
        };
    };
    
    write_evm_bookmarks_file(s_add_bookmark_line: string, s_last_evm_line: string,
        lst_bookmark_lines: list of string) is {

        var sl: list of string;
        
        sl.add(append("ADD ", s_add_bookmark_line));
        sl.add(append("LAST ", s_last_evm_line));
        for each (s_bookmark) in lst_bookmark_lines {
            sl.add(append("BOOKMARK ", s_bookmark));
        };
        
        var s_evm_bm_file: string = get_evm_bookmarks_file_name();
        files.write_string_list(s_evm_bm_file, sl);
    };
        
        
    is_evm_bookmark_exists(s_wanted_evm_name: string): bool is {
        var s_add_bookmark_line: string;
        var s_last_evm_line: string;
        var lst_bookmark_lines: list of string;
            
        compute read_evm_bookmarks_file(
            s_add_bookmark_line, s_last_evm_line, lst_bookmark_lines);

        var s_evm_name: string;
        var s_evm_title: string;
        for each (s_line) in lst_bookmark_lines {
            if (get_evm_name_and_title(s_line, s_evm_name, s_evm_title)) {
                if (s_evm_name == s_wanted_evm_name) {
                    return TRUE;
                };
            };
        };
            
        return FALSE;
        
    };
    
    evm_shown(name: string, title: string) is also {
        set_evm_bookmark_candidate(name, title);
        update_last_evm(name, title);
    };
    
};

'>


<> Handle callbacks
<'

extend display {
    
    custom_menu_clicked(s_menu_key: string, s_menu_item_key: string, 
        s_menu_item_label: string, s_optional_param: string) is also {
        
        if (s_menu_key == display.p_s_evm_menu_key) {

            // check for Add Bookmark
            if (s_menu_item_key == display.p_s_evm_add_bookmark_key) {
                if (s_optional_param != "") {
                    // get name and title out of s_optional_param, and add new bookmark
                    if (s_optional_param ~ "/^([^ ]+)[ ]+(.*)$/") {
                        var s_evm_name: string = $1;
                        var s_evm_title: string = $2;

                        display.add_evm_bookmark(s_evm_name, s_evm_title);
                        display.update_custom_menu_item(
                            display.p_s_evm_menu_key, 4, display.p_s_evm_add_bookmark_key, 
                            display.get_evm_label_for_add("<None>"), "");
                        
                    };
                };
                
            // 
                
            // check for Last eVM
            } else if (s_menu_item_key == display.p_s_evm_last_evm_key) {
                if (s_optional_param != "") {
                    // get name and title out of s_optional_param, and add new bookmark
                    if (s_optional_param ~ "/^([^ ]+)[ ]+(.*)$/") {
                        var s_evm_name: string = $1;
                        var s_evm_title: string = $2;

                        vt.show_evm(s_evm_name);
                        
                    };
                };

                
            } else if (s_menu_item_key == "evm_categories") {
                vt.evm_categories("");
                
            } else if (s_menu_item_key == "evm_list") {
                vt.evm_list("");
            } else if (s_menu_item_key != "") {
                // a bookmark
                vt.show_evm(s_menu_item_key);
                
            };
                
        };
    };
    
};
'>

o Adding bookmarks from HTML:

<'
extend sn_vt {
    -- A misc routine added just to avoid handling the title in HTML,
    -- and also because display.add_evm_bookmark() is defined later
    add_evm_bookmark(name: string) is {
	var e:= get_evm(name);
	display.add_evm_bookmark(e.name, e.title);
    };
};
'>

