
<'

extend global {
    p_reflection_manager: reflection_handler;

    init() is also {
        p_reflection_manager = new;
    };
    
    register_jb_services() is empty;
};

struct reflection_handler like sn_struct {
    sd_any_struct: struct_descriptor;

    init() is also {
        sd_any_struct = type_called("any_struct").as_a(struct_descriptor);
    };
    
        get_active_fields(instance: base_struct): list of field is {
                _accumulate_active_fields(result,instance,TRUE);
        };

        get_active_visible_fields(instance: base_struct): list of field is {
                _accumulate_active_fields(result,instance,FALSE);
        };

        _accumulate_active_fields(result: list of field, instance: base_struct, collect_non_visible: bool) is {
                var sd: struct_descriptor = instance.type().as_a(struct_descriptor);
                for each (field) in sd.fields do {
                        if field.Context_struct.is_instance_of_me(instance) &&
                           (collect_non_visible || !field.is_private()) {
                                result.add(field);
                        };
                };
                
                result = result.sort(it.source_ref);
        };
        
        is_subtype_child_of(subt: subtype_descriptor, sd: struct_descriptor): bool is {
            
            result = is_str_sub_list(sd.name, subt.name);
            
        };
        
        is_str_sub_list(str1: string, str2: string): bool is {
            var lst1: list of string = str_split(str_trim(str1), " ");
            var lst2: list of string = str_split(str_trim(str2), " ");
            
            for each (sub_str) in lst1 {
                if (! (sub_str in lst2)) {
                    return FALSE;
                };
            };
            
            return TRUE;
        };
    
        get_active_struct_fields(sd: struct_descriptor): list of field is {
            if (sd.is_subtype()) {
                var parent_sd: struct_descriptor = sd.subtype_parent();
                result = sd.fields.all(
                    (it != NULL) and 
                    (! name_is_private(.name)) and
                    (is_subtype_child_of(sd.as_a(subtype_descriptor), it.Context_struct)) and 
                    //(type_is_a_child_of(sd, it.Context_struct)) and 
                    (type_is_a_child_of(it.Context_struct, parent_sd))
                    );
            } else {
                // a simple struct
                result = sd.fields.all(
                    (it != NULL) and 
                    (! name_is_private(.name)) and
                    (.Context_struct == sd));
            };
            
            result = result.sort(it.source_ref);
        };
        
        
        get_active_struct_covergroups(
            sd: struct_descriptor): list of sn_cover_group_descriptor is {
            if (sd.is_subtype()) {
                var parent_sd: struct_descriptor = sd.subtype_parent();
                result = global.covers.all_groups.all(
                    (it != NULL) and 
                    (type_is_a_child_of(sd, it.parent_type)) and 
                    (type_is_a_child_of(it.parent_type, parent_sd))
                    );
            } else {
                // a simple struct
                result = global.covers.all_groups.all(
                    (it != NULL) and 
                    (it.parent_type == sd));
            };

            result = filter_user_src_items(result.as_a(
                list of source_item)).as_a(list of sn_cover_group_descriptor);

            result = result.sort(it.source_ref);
        };
        
        
        get_active_struct_events(
            sd: struct_descriptor): list of event_type is {
            if (sd.is_subtype()) {
                var parent_sd: struct_descriptor = sd.subtype_parent();
                result = global.scheduler.event_map.all(
                    (it != NULL) and 
                    (type_is_a_child_of(sd, it.parent_type)) and 
                    (type_is_a_child_of(it.parent_type, parent_sd))
                    );
            } else {
                // a simple struct
                result = global.scheduler.event_map.all(
                    (it != NULL) and 
                    (it.parent_type == sd));
            };

            result = filter_user_src_items(result.as_a(
                list of source_item)).as_a(list of event_type);

            result = result.sort(it.source_ref);
        };
        
        
        
        get_active_struct_methods(sd: struct_descriptor): list of method is {
            if (sd.is_subtype()) {
                var parent_sd: struct_descriptor = sd.subtype_parent();
                result = symtab.all_methods.all(
                    (it != NULL) and 
                    (! name_is_private(.name)) and
                    (type_is_a_child_of(sd, it.Context_struct)) and 
                    (type_is_a_child_of(it.Context_struct, parent_sd))
                    );
            } else {
                // a simple struct
                result = symtab.all_methods.all(
                    (it != NULL) and 
                    (! name_is_private(.name)) and
                    (.Context_struct == sd));
            };

            result = filter_user_src_items(result.as_a(
                list of source_item)).as_a(list of method);

            result = result.sort(it.source_ref).reverse();
            result = result.sort(it.name).unique(it.name);
            result = result.sort(it.source_ref);
        };
        
        
        get_active_struct_constraints(sd: struct_descriptor): list of gen_constraint is {
            if (sd.is_subtype()) {
                var parent_sd: struct_descriptor = sd.subtype_parent();
                result = sd.sgi.gcs.all(
                    (type_is_a_child_of(sd, it.Context_struct)) and 
                    (type_is_a_child_of(it.Context_struct, parent_sd))
                    );
            } else {
                // a simple struct
                result = sd.sgi.gcs.all(
                    (.Context_struct == sd));
            };

            result = filter_user_src_items(result.as_a(
                list of source_item)).as_a(list of gen_constraint);
            
            result = result.sort(it.source_ref).unique(it.source_ref);
        };
        
        get_method_extentions(m: method, sd_parent: struct_descriptor): list of method is {
            
            var curr_method: method = m;
            while (curr_method != NULL) {
                var sd: struct_descriptor = curr_method.Context_struct;
                
                if (type_is_a_child_of(sd_parent, sd)) {
 
                    result.add(curr_method);
                };
                curr_method = curr_method.previous_method;
                
            };
            
            result = filter_user_src_items(result.as_a(
                list of source_item)).as_a(list of method);
            result = result.sort(it.source_ref);
            
            
        };
        
        get_struct_method(m: method, sd: struct_descriptor): method is {
            var curr_method: method = m;
            while (curr_method != NULL) {
                var curr_sd: struct_descriptor = curr_method.Context_struct;
                if (curr_sd == sd) {
                    return curr_method;
                };
                curr_method = curr_method.previous_method;
                
            };
            
            result = NULL;
            
            
        };
        
             
        filter_user_src_items(lst_src_items: list of source_item): list of source_item is {
            if (session.get_developer_mode() == none) {
                // in user mode ==> take only user's source items
                for each (src_item) in lst_src_items {
                    if (is_user_source_item(src_item)) {
                        result.add(src_item);
                    };
                };
            } else {
                // in developer mode ==> no filtering
                result = lst_src_items;
            };
        };
        
        is_user_source_item(src_item: source_item): bool is {
            result = (src_item.source_module().module_num > symtab.last_sn_module);
        };
        
};

'>


<'

extend global{
    edit(viewer: string, file_name: string, line_no: int) is only {
	var type_wanted:= (viewer ~ "/^(ty|mo).*/");
	var editor:= (type_wanted ? 
		get_symbol("SPECMAN_PAGER") : get_symbol("SPECMAN_EDITOR"));

	if (editor != "") then {	-- SPECMAN_EDITOR/PAGER is defined
	     editor = str_replace(editor,"/\$f/",file_name);	-- filename
	     editor = str_replace(editor,"/\$l/",str_dec(line_no));-- line number
	} else {			-- No SPECMAN_* environment variable
	     editor = (type_wanted ?
		get_symbol("PAGER") : get_symbol("EDITOR"));

	    case{
                -- EDITOR/PAGER ~ more/less/vi
		(editor ~ "/^[ ]*(more|less|vi).*/") &&
					 (specman_config.os == unix){
		    editor = append(editor," +", str_dec(line_no), " ", file_name);
		};

                -- EDITOR/PAGER ~ emacs
		(editor ~ "/emacs/") {
		    editor = append(editor," +", str_dec(line_no), " ", file_name);
                                     };
                                     
                -- No EDITOR/PAGER defined & UNIX
		(editor == "") &&  (specman_config.os == unix) {
		    if type_wanted then{
			editor = append("more +", str_dec(line_no), " ", file_name);
		    } else{
			editor = append("vi +", str_dec(line_no), " ", file_name);
		    };

		};
				-- No EDITOR/PAGER defined & VMS
		(editor == "") &&  (specman_config.os == vms) {
		    if type_wanted then{
			editor = append("type/page=save ", file_name);
		    } else{
			editor = append("edit/tpu/start=", str_dec(line_no), " ",file_name);
		    };
		};
				-- EDITOR/PAGER is defined, but not a common 
				--one, so we don't know how to add line number
		editor != "" {
		    editor = append(editor," ",file_name);
		};
	     };		-- Of case
	};			-- Of no SPECMAN_* env variables
				-- If display is on, open xterm
        
        
	var term: string = get_symbol("SN_TERM");
        if (term == "") {
            term = get_symbol("COLORTERM");
        };
        if (term == "") {
            term = "xterm";
        };
        
        var cmd: string;
        if ((display.on) && (specman_config.os == unix)) then{ 
            cmd = appendf("%s -e %s &", term, editor);
        } else {
            cmd = editor;
        };
        
        out("# Running: ", cmd);
        spawn(cmd);
    };
};

'>


<'
extend display {

    get_input(str: *string): bool is {
        var tcl_cmd := appendf("[get_input %s {%s} {%s} 40 {%s} ]",
            ".main0", "Input Window", "Are you ok?", "");
        var s_answer := display.get_tcl_exp_value(tcl_cmd);
        
        if (s_answer == "__@CANCEL@__") then {
            result = FALSE;
        } else {
            str = s_answer;
            result = TRUE;
        };
    };
    
    
    open_web_location1(location: string) is {
        if not display.on {return};

        var s:= appendf("netscape -remote 'openUrl(%s)' 1>/dev/null 2>&1", location);
        var status:= system(s);
        if status != 0 then {
            out("Starting netscape ...");
            status = system(append("netscape ", location, " 1>/dev/null 2>&1 &"));
        };

        if status == 0 then {
            return;
        } else {
            error("Unable to open netscape");
        };
    };
    
};

'>


<'

extend sn_specview_service {
    show_config_window(config_group: string) is only {
        
        if (config_group == NULL) {
            config_group = "";
        };

        var s_category: string = session.config.get_category_internal_name(config_group);
        if (! session.config.category_exist(s_category)) {
            s_category = "print";
        };

        if (display.on) { 
            
            out(" \n");
            display.show_config(s_category);
            out(" \n");
        } else {
            var cmd: string = appendf("show config %s", s_category);
            var s_err: string = safe_specman_command(cmd, FALSE);
                
        };
    };
};

'>


<'

extend sn_jspecview_deli {
    
    
    // launches JSpecview with the name of port file. From now, 
    // JSpecview waits for that file to be created,
    // which will happen only when someone will ask to actually
    // communicate with JSpecview
    launch_jspecview() is only {
        
        // if already launched or connected - do nothing
        if (is_connected() or is_launched()) {
            
            return;
            
        };
        
        // set comm is busy 
        if (debug.interrupt) {
            out("COMM BUSY: started launch_jspecview");
        };
        sn_communication.started_comm_operation();
        
        // debug
        if (debug.snorb2) {
            
            out("Launching JSpecview ...");
            
        };
        
        //if (session.get_developer_mode() != none) {
        //    out("Launching Java GUI deamon ... (Internal Message)");
        //};
        
        // get port file name
        var s_port_file_name: string = get_port_file_name();
        
        // remove port file
        if (files.file_exists(s_port_file_name)) {
            
            files.file_delete(s_port_file_name);
            
            ASSERT(! files.file_exists(s_port_file_name));
        };
                
        // launch java
        var s_prop_file : string = display.create_properties_file(FALSE);
        var prop_file_arg: string = (s_prop_file == "") ? "" : append("-prop_file ", s_prop_file);
        var user_classpath_arg: string = ((p_s_user_classpath == "") ? 
            "" : append("-user_classpath ", p_s_user_classpath));
            
        var cmd := appendf(
            "sn_jspecview.sh -portfile %s -temp_dir %s -internal_use %s %s -parent_pid %d %s %s", 
            s_port_file_name, files.get_temp_dir(),
            prop_file_arg,
            display.on ? "" : "-minimal",
            getpid(), 
            user_classpath_arg,
            get_symbol("JSPECVIEW_EXTRA"));
         
        if (debug.snorb2) {
          
            cmd = append(cmd, " -v");
            out("CMD: ", cmd);
            
        };
        
        var status : int = system(cmd);
        
        if (status != 0) {
            // failed
            
            // un-set comm is busy 
            if (debug.interrupt) {
                out("COMM BUSY: finished launch_jspecview - failed");
            };
            sn_communication.finished_comm_operation();
        
            set_jspecview_comm_status(none);
            sn_err(CANT_LAUNCH_JSPECVIEW_JAVA);
        };
            
        set_jspecview_comm_status(launched);
        
        // un-set comm is busy 
        if (debug.interrupt) {
            out("COMM BUSY: finished launch_jspecview successfuly");
        };
        sn_communication.finished_comm_operation();
        
    };

    
    
    // actually establish the connection with JSpecview.
    // If JSpecview was not launched yet, it launches it first.
    // Then, it start running, which creates the portfile.
    // JSpecview will sense it and connect to the port.
    establish_communication() is only {
        
        // if already connected - do nothing
        if (is_connected()) {
            
            return;
            
        };
            
        // set comm is busy 
        if (debug.interrupt) {
            out("COMM BUSY: started establish_communication");
        };
        sn_communication.started_comm_operation();
        
        // If java was not launched yet - do it now
        if (!is_launched()) {
            
            launch_jspecview();
            
        };
        
        ASSERT (is_launched());
        
        // debug
        if (debug.snorb2) {
            
            out("Establishing JSpecview Communication ...");
            
        };
        
        
        ASSERT (sn_communication != NULL);
        ASSERT (sn_communication.connection_manager != NULL);

        
        // for safty, remove name from appl manager
        compute pub_services.remote_appl_manager.remove(JSPECVIEW_APPL_NAME);
        
        ASSERT (! pub_services.remote_appl_manager.exists(JSPECVIEW_APPL_NAME));

        // start supplying communication services immediately after restore
        var s_port_file_name: string = get_port_file_name();
        
        //if (session.get_developer_mode() != none) {
        //    out("Connecting to Java GUI deamon ... (Internal Message)");
        //};
        
        sn_communication.comm_config.set_registration_file(s_port_file_name);
        
        if (get_symbol("JSPECVIEW_JAVA_EXE") == "DISABLED") {
            debug.server = TRUE;
        };
            
        sn_communication.connection_manager.start_specman_server();        
        
        ASSERT(files.file_exists(s_port_file_name));
        
        // wait for JSpecview to register
        while (! pub_services.remote_appl_manager.exists(JSPECVIEW_APPL_NAME)) {
            
            sn_communication.idle_server_handle_in_message();
            
        };
        
        // WE HAVE CONNECTION !!!
        set_jspecview_comm_status(connected);
        
        
        // get jspecview service 
        p_jspecview_service =
            orb lookup service sni_jspecview_service JSPECVIEW_SERVICE_NAME;
        
        ASSERT(p_jspecview_service != NULL);
        
        p_socket = sn_communication.connection_manager.data_socket;
        

        // remove (the unrequired) port file
        files.file_delete(s_port_file_name);
            
        ASSERT(! files.file_exists(s_port_file_name));
        
        // ARRANGE sn_communication
        sn_communication.error_on_disconnect = TRUE;
        
        // un-set comm is busy 
        if (debug.interrupt) {
            out("COMM BUSY: finished establish_communication");
        };
        sn_communication.finished_comm_operation();
    };
      


      

    // Terminate communication to JSpecview, by calling
    // its exit() remote method
    terminate_communication() is only {

        if (is_connected()) {
            
            if (debug.snorb2) {
                out("Terminating JSpecview Communication");
            };
            
            // set comm is busy 
            if (debug.interrupt) {
                out("COMM BUSY: started terminate_communication");
            };
            
            // close the Specview<->JSpecview direct socket
            if (display.on) {
                
                // wait until socket is closed
                if (debug.snorb2) {
                    out("Closing socket Specview <--> JSpecview");
                };
                var res: string = display.get_tcl_exp_value("[sn_close_jspecview_socket]");  
                
            };
            
            sn_communication.started_comm_operation();
            
            sn_communication.quit_on_disconnect = FALSE;
            sn_communication.error_on_disconnect = FALSE;
            
            
            sn_communication.connection_manager.set_is_active_server(FALSE);
            
            /// IMPORTANT!!!  MUST BE A NOTIFICATION
            ASSERT(p_jspecview_service != NULL);
            
            p_jspecview_service.exit();
            
            compute pub_services.remote_appl_manager.remove(JSPECVIEW_APPL_NAME);
            
            p_jspecview_service = NULL;
            p_socket = NULL;
        
            // close communication
            sn_communication.close();
        
            set_jspecview_comm_status(none);
            
            // un-set comm is busy 
            if (debug.interrupt) {
                out("COMM BUSY: finished terminate_communication");
            };
            sn_communication.finished_comm_operation();
        };
        
    };

};
'>

