<'
//import gen_file_header.edlt;

// Template for generation EDL code for 'e' and Java

<EDL_TEMPLATE>
    
// enter method header with parameters here    
<NAME> 
    gen_interface_descriptor(I: EDLInterface)  
</onlyNAME>

    
// enter your e code generation here    
<E> { 

    var sName : string = I.getName();
    
    CODECR("");
    CODECR("<'");
    CODECR("");
    CODECR("-- The interface descriptor for ", sName , " ");
    CODECR("");
    CODECR("");
    CODECR("extend ", sName , "_descriptor  {");
    CODECR("");
    CODECR("  is_instance(o: any_struct): bool  is {");
    CODECR("    return (p_to_instance(o) != NULL);");
    CODECR("  };");
    CODECR("");
    CODECR("  p_create_stub(oid: snorb_object_id): any_struct is {");
    CODECR("    result = NEW ", sName , "_stub.ctor(oid);");
    CODECR("    result.set_unit(sys);");
    CODECR("  };");
    CODECR("");
    CODECR("  p_is_stub(o: any_struct): bool is  {");
    CODECR("    return (p_to_stub_instance(o) != NULL);");
    CODECR("  };");
    CODECR("");
    CODECR("  p_get_stub_object_id( o: any_struct): snorb_object_id is {");
    CODECR("    if (p_is_stub(o)) {");
    CODECR("        result = p_to_stub_instance(o).p_get_object_id();");
    CODECR("    };");
    CODECR("  };");
    CODECR("");
    CODECR("  p_create_impl_adapter( o: any_struct ): snorb_i_impl is {");
    CODECR("    if (is_instance(o)) {");
    CODECR("        result = NEW ", sName , "_impl_adapter.ctor(p_to_instance(o));");
    CODECR("    };");
    CODECR("  };");
    CODECR("");
    CODECR("  p_to_instance( o: any_struct ): ", sName , " is {");
    CODECR("    result = o.as_a(", sName , ");");
    CODECR("  };");
    CODECR("");
    CODECR("  p_to_stub_instance(o: any_struct): ", sName , "_stub is {");
    CODECR("    result = o.as_a(", sName , "_stub);");
    CODECR("  };");
    CODECR("};");
    CODECR("");
    CODECR("");
    CODECR("-- Add generated struct in run time");
    CODECR("");
    CODECR("");
    CODECR("  extend global {");
    CODECR("      init() is also {");
    CODECR("          sn_edl_parser.add_loaded_gen_struct(", quote(sName) , ");");
    CODECR("      };");
    CODECR("  };");
    CODECR("");
    CODECR("'>");
    CODECR("");
    
    
} </E>

// enter your java code generation here
<JAVA> { 
    
    var sPackage : string = I.getPackage().getFullName();
    var sIName : string = gen_IName(I);
    var sName : string = I.getName();
    var sClass : string = append(I.getName() , "Descriptor");
    var sFileName : string = sClass;
    
    CODE(gen_file_header(I, sFileName, sPackage, ""));
    CODECR("");
    CODECR("class ", sName , "Descriptor");
    CODECR("                      extends OrbInterfaceDescriptor {");
    CODECR("");
    CODECR("  public boolean isInstance(IOrbObject o) {");
    CODECR("    return (toInstance(o) != null);");
    CODECR("  }");
    CODECR("");
    CODECR("  protected IOrbObject createStub(ObjectID oid) {");
    CODECR("    return new ", sName , "Stub(oid);");
    CODECR("  }");
    CODECR("");
    CODECR("  protected boolean isStub(IOrbObject o) {");
    CODECR("    return (toStubInstance(o) != null);");
    CODECR("  }");
    CODECR("");
    CODECR("  protected ObjectID getStubObjectID(IOrbObject o) {");
    CODECR("    if (!isStub(o)) return null;");
    CODECR("    return toStubInstance(o).getObjectID();");
    CODECR("  }");
    CODECR("");
    CODECR("  protected IOrbImpl createImplAdapter(IOrbObject o) {");
    CODECR("    if (!isInstance(o)) return null;");
    CODECR("    return new ", sName , "ImplAdapter(toInstance(o));");
    CODECR("  }");
    CODECR("");
    CODECR("  protected IOrbObject[] createArray(int nLen) {");
    CODECR("    return new ", sName, "[nLen];");
    CODECR("  }");
    CODECR("");
    CODECR("  private ", sName , " toInstance(IOrbObject o) {");
    CODECR("    try  { return (", sName , ") o; }");
    CODECR("    catch(ClassCastException e) { return null; }");
    CODECR("  }");
    CODECR("  private ", sName , "Stub toStubInstance(IOrbObject o) {");
    CODECR("    try  { return (", sName , "Stub) o; }");
    CODECR("    catch(ClassCastException e) { return null; }");
    CODECR("  }");
    CODECR("}");
    CODECR("");
    
    WRITE(I.getPackage().getFullDir(), "/", sClass);

    
    
} </JAVA>
    
    
</EDL_TEMPLATE>
    
'>



