<'

// Template for generation EDL code for 'e' and Java

<EDL_TEMPLATE>
    
// enter method header with parameters here    
<NAME> 
    gen_pack_datamember(DM: EDLDataMember, sPackage: string)  
</onlyNAME>

// enter your e code generation here    
<E> { 

    
    CODE("    result += ");
    
    var T : EDLAbsType = DM.getType();
    var sListSuffix : string = (DM.isList() ? "_list" : "");
    var sName : string = DM.getName();
    var sRealName: = append("p_data.", sName);
    var sUTName : string;
    if (T.isUserType()) {
        sUTName = gen_just_type(T, "");
    };

    var sCast : string;
    
    case T.getKind() {
            
        edl_bool {
            CODE("out.write_bool", sListSuffix, "(", sRealName, ")");
        };
        
        edl_int {
            CODE("out.write_int", sListSuffix, "(", sRealName, ")");
        };
        
        edl_string {
            CODE("out.write_string", sListSuffix, "(", sRealName, ")");
        };
        
        edl_interface {
            if (DM.isList()) {
                sCast = ".as_a(list of any_struct)";
            };
            CODE("snorb.obj_helper.write_orb_object", sListSuffix, 
                "(\n        out, ", sRealName, sCast, 
                ", snorb.descriptor.", sUTName, ")");
        };
        
        edl_data {
            if (DM.isList()) {
                sCast = ".as_a(list of any_struct)";
            };
            CODE("snorb.data_helper.write_data", sListSuffix, 
                "(\n        out, ", sRealName, sCast, 
                ", snorb.descriptor.", sUTName, ")");
        };
        
        edl_enum {
            if (DM.isList()) {
                CODE("out.write_int_list",
                    "(\n        snorb.descriptor.", sUTName, ".enum_list_2_int_list(", sRealName, "))");
            } else {
                CODE("out.write_int(", sRealName, ".as_a(int))");
            };
            
        };
            
        default {
            error("Unknown Type: ", T.getKind());
        };
    };
    
} </E>

// enter your java code generation here
<JAVA> { 
    
    
    
    CODE("    ");
    
    var T : EDLAbsType = DM.getType();
    var sName : string = DM.getName();
    var sRealName: = append("_data.", sName);
    var sListSuffix : string = (DM.isList() ? "List" : "");
    var sArrayPrefix : string = (DM.isList() ? "ArrOf" : "");
    
    var sUTName : string;
    if (T.isUserType()) {
        
        var UT : EDLAbsUserType = T.as_a(EDLAbsUserType);
        sUTName = gen_just_type(T, sPackage);
    };
    
    
    case T.getKind() {
            
        edl_bool {
            CODE("out.snWrite", sArrayPrefix, "Boolean(", sRealName, ")");
        };
        
        edl_int {
            CODE("out.snWrite", sArrayPrefix, "Int(", sRealName, ")");
        };
        
        edl_string {
            CODE("out.snWrite", sArrayPrefix, "String(", sRealName, ")");
        };
        
        edl_interface {
            CODE("OrbObjectHelper.writeOrbObject", sListSuffix, 
                "(out, ", sRealName, ", ", 
                sUTName, ".DESCRIPTOR)");
        };
        
        edl_data {
            CODE("DataHelper.writeData", sListSuffix, 
                "(out, ", sRealName, ", ", 
                sUTName, ".DESCRIPTOR)");
        };
        
        edl_enum {
            CODE("EnumHelper.writeEnum", sListSuffix, 
                "(out, ", sRealName, ", ", 
                sUTName, ".DESCRIPTOR)");
        };
            
        default {
            error("Unknown Type: ", T.getKind());
        };
    };
    
} </JAVA>
    
    
</EDL_TEMPLATE>
'>



    
