import javax.swing.BoxLayout;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.net.*;
import java.io.*;
import java.applet.*;


public class SpecviewConnectionApplet  extends Applet {
  

  static  final int CONNECTING   = 0;
  static  final int CONNECTED    = 1;
  static  final int DISCONNECTED = 2;

  static  final String MSG_CONNECTING = "Connecting...";
  static  final String MSG_CONNECTED = "connected";
  static  final String MSG_NOT_CONNECTED = "disconnected";
  static  final String SPECMAN_NAME      = "Specman  ";
  static  final String SOME_SPACE        = "      ";

  static final private String IN_MESSAGE_PREFIX = "J!!";
  static final private String OUT_MESSAGE_PREFIX = "APPLET!!";
  static final private String OUT_MESSAGE_SUFFIX = "@@@";
  static final private int IN_MESSAGE_PREFIX_LEN = IN_MESSAGE_PREFIX.length();
  static final private int OUT_MESSAGE_SUFFIX_LEN = OUT_MESSAGE_SUFFIX.length();
  static final String COMMON_REPLY               = "ok";

  // indicates whether we use a panel to show connection status , or a simple label only.
  
  private boolean _useAppletGui    = false ;
  private boolean _appletUsesPanel = false ;
  

  
  private Panel _panel;
  private TextField _textFieldPort;
  private TextField _textFieldHost;
  private TextField _textStatus;
  private Label _label;
  private Button _btnConnect;
  private Font _fontPlain = new Font("Arial", Font.PLAIN, 12);
  private Font _fontBold= new Font("Arial", Font.BOLD, 12);

  private String _sHost;
  private int _nPort;


  // if there is an applet instance that uses the specman socket,__isSocketBusy=true
  // and no other applet instance tries to reconnect.
  static private boolean __isSocketBusy = false;
  private boolean _amIConnected = false;
 

  private Socket _socket = null;
  private DataOutputStream _out = null;
  private BufferedReader    _in = null;

  private int _appletStatus = DISCONNECTED;

  public void init() {
  }

  public void start() {
    // if socket is busy - fail
    System.out.println("start");

	// decied whether to use label/panel/non of the above.
	String param = getParameter("APPLET_GUI");
	_useAppletGui     = (param.equals("NONE") ? false : true );
	_appletUsesPanel  =	(param.equals("PANEL")? true : false );
    
    initControls();
    connect();
  }
   
  private void initControls() { 
    
	if ( _useAppletGui ){

	  if(! _appletUsesPanel){
		if( _label == null){
		  _label = new Label(SOME_SPACE + MSG_CONNECTING+ SOME_SPACE); 
		  add(_label);	  
		}
		else
		  _label.setText(SOME_SPACE + MSG_CONNECTING );	      
	  }	
	  
	  else {
		Label labelStatus = new Label("Status:", Label.RIGHT);
		_textStatus = new TextField("",12);
		Label labelHeader = new Label("Specman Connection", Label.RIGHT);
		Label labelHost = new Label("Host:", Label.RIGHT);
		_textFieldHost = new TextField("",20);
		Label labelPort = new Label("Port:", Label.RIGHT);
		_textFieldPort = new TextField("",6);
		
		// Connect button
		_btnConnect = new Button("Reconnect");
		_btnConnect.addActionListener(new ActionListener() {
		  public void actionPerformed(ActionEvent e) {
			connect();
		  }
		});
		
		
		_panel = new Panel();
		_panel.setBackground(Color.lightGray);
		_panel.add(labelHeader);
		_panel.add(_btnConnect);
		_panel.add(labelStatus);
		_panel.add(_textStatus);
		_panel.add(labelPort);
		_panel.add(_textFieldPort);
		_panel.add(labelHost);
		_panel.add(_textFieldHost);
		for (int i = 0; i < _panel.getComponentCount(); i++ ) {
		  Component component = _panel.getComponent(i);
		  
		  component.setFont(_fontPlain);
		  component.setForeground(Color.black);
		  component.setVisible(true);
		  
		  if (component instanceof Label) {
			component.setBackground(Color.lightGray);
			
		  } else if (component instanceof TextField) {
			component.setBackground(Color.white);
		  }
		}
		
		// special properties
		labelHeader.setFont(_fontBold);
		_textStatus.setEditable(false);
		_textStatus.setBackground(Color.yellow);
		
		// add panel to applet
		add(_panel);
	  }
	}
  }

  public boolean  reconnect(){
	System.out.println("Trying to reconnect...");
	return connect();
  }

  private boolean  connect() {
    // if another applet (not me) is currently connected 
	//try 3 times to connect - if fail  return false .
	
	int i = 0;
	while (__isSocketBusy && !_amIConnected) {
	  try{
		Thread.sleep(200);
	  	System.out.println("sleep..." + i);
	  }catch(Exception e){
		return false;
	  }   
	  i++;
	  if(i > 3 && __isSocketBusy && !_amIConnected ){
		System.out.println("Cannot connect - Another applet is currently connected " + 
						   "__isSocketBusy= " +__isSocketBusy +
						   " _amIConnected  = "  +_amIConnected );
		return false;  
	  }	  		
	}
	

	/*    if(__isSocketBusy && !_amIConnected) {	  
      System.out.println("Cannot connect - Another applet is currently connected " + 
         "__isSocketBusy= " +__isSocketBusy +"	_amIConnected  = "  +_amIConnected );
      return false;
	  }*/

    
    // reset all 
    reset();
    _appletStatus = CONNECTING;
    repaint();

    if(!_appletUsesPanel){
      _nPort = Integer.valueOf(getParameter("port")).intValue();  
      _sHost = getCodeBase().getHost(); 

    

  }  else{
    
      // GET PORT
      String sPort = _textFieldPort.getText();
      
      // if no port in field - take from parameter
      if ((sPort == null) || (sPort.equals(""))) {
        // port is not in field yet
	sPort = getParameter("port");
      }
      
      // if no port in parameter - use 10001
      if ((sPort == null) || (sPort.equals(""))) {
	sPort = "10001";
      }
      _nPort = Integer.valueOf(sPort).intValue();
      _textFieldPort.setText("" + _nPort);
      
      // GET HOST
      String sHost = _textFieldHost.getText();
      
      // if no host in field - take from parameter
      if ((sHost == null) || (sHost.equals(""))) {
        // host is not in field yet
	sHost = getParameter("host");
      }
      
      // if no host in parameter - take codeBase
      if ((sHost == null) || (sHost.equals(""))) {
	sHost = getCodeBase().getHost();
      }
      _sHost = sHost;
      _textFieldHost.setText(_sHost);
    }


    Runnable run = new Runnable() { public void run() {
      establish_communication (_sHost, _nPort);
    }};

    (new Thread(run)).start();
	return true;
  }

  public void stop(){

    System.out.println("stop");
    // peacefull death ...
    reset();
    repaint();   
  }

  private void reset() {

    _appletStatus = DISCONNECTED;
    closeConnection();
  }

  // paint - write the appropriate message: Connecting...
  public void paint(Graphics g){
	if(_useAppletGui){
	  prepareToPaint();
	  
	  if(_appletUsesPanel){  
      // bg  
		g.setColor(Color.lightGray);
		g.fillRect(0, 0, getSize().width, getSize().height);
		
		// border
		g.setColor(Color.black);
		g.drawRect(0, 0, getSize().width - 1, getSize().height - 1);
	  }
	}

  }
   
  private void prepareToPaint() {
    switch (_appletStatus) {
      case CONNECTING: {
		if(_appletUsesPanel){
		  _textStatus.setBackground(Color.blue);
		  _textStatus.setForeground(Color.white);
		  _textStatus.setText(MSG_CONNECTING);
		}
		else{
		  _label.setText(SOME_SPACE + SPECMAN_NAME + MSG_CONNECTING);
		}
		break;
		
      }

      case CONNECTED: {
		if(_appletUsesPanel){
		  _textStatus.setBackground(Color.green);
		  _textStatus.setForeground(Color.black);
		  _textStatus.setText(MSG_CONNECTED);
		}
		else{
		  _label.setText(SOME_SPACE + SPECMAN_NAME + MSG_CONNECTED);
		}
        break;
      }

      case DISCONNECTED: {
		if(_appletUsesPanel){
		  _textStatus.setBackground(Color.red);
		  _textStatus.setForeground(Color.white);
		  _textStatus.setText(MSG_NOT_CONNECTED);
		}
		else{ 
		  _label.setText(SOME_SPACE + SPECMAN_NAME + MSG_NOT_CONNECTED);
		}
        break;
      }

      default: {
		if(_appletUsesPanel){
		  _textStatus.setBackground(Color.red);
		  _textStatus.setForeground(Color.white);
		  _textStatus.setText(MSG_NOT_CONNECTED);
		}
		else{
		  _label.setText(SOME_SPACE + SPECMAN_NAME + MSG_CONNECTING);
		}
        break;
      }
    }
  }

  // open the actual socket
  private boolean openSocket(String sHost, int  nPort){
    try {
      _socket = new Socket(sHost,  nPort);
      _out = new DataOutputStream(_socket.getOutputStream());
      _in = new BufferedReader(new InputStreamReader(_socket.getInputStream()));

      return true;

    } catch(IOException e) {
      return false;
    }
  }


  // establish the connection to JSpecview
  public void establish_communication(String sHost, int  nPort){

    // Trying few times to open the socket in nPort on sHost
    int counter = 0;
    boolean fConnected = false;
    repaint();
    while (! fConnected) {
      System.out.println("Connecting port: "+  nPort + " host: " + sHost);
      repaint();

      if (counter > 3) {
        System.out.println("Failed Connecting  - passed time out");
        reset();
        return;
      }

      try {

        fConnected = openSocket( sHost, nPort);
      } catch (Exception e) {
        System.err.println("Exception: Failed openSocket");
        fConnected = false;
      }

      if (! fConnected) {
        counter++;

        try {
          Thread.sleep(500);
        } catch (Exception  e) {
          System.out.println("Exception: Failed sleeping");
          reset();
	  repaint();
          return;
        }       
      }    

    }

    __isSocketBusy = true;
    _amIConnected = true ;
    System.out.println("Connected! Socket = " + _socket);
    _appletStatus = CONNECTED;
    repaint();
  }
  
  
  // close the connection to JSpecview
  public void closeConnection() {

    System.out.println("Closing Connection");
	
	_amIConnected = false;
	__isSocketBusy = false;
	
    try {

      if (_socket != null){
        _socket.close();
        _socket = null;
      }

      if (_out != null){
        _out.close();
        _out = null;
      }

      if (_in != null){
        _in.close();
        _in = null;
      }
	   

    } catch (IOException e) {
      System.err.println("closeConnection -failed");

    }
  }


  // read a reply
  private String readMessage() throws IOException {

    String sMessage = null;

    try {

      if (_in != null){

        String sFullLine = _in.readLine();
        if (sFullLine == null)
        return null;


        if (sFullLine.startsWith(IN_MESSAGE_PREFIX))
            sMessage = sFullLine.substring(IN_MESSAGE_PREFIX_LEN);
     }

    } catch (EOFException e) {
	    throw new IOException(e.getMessage());

    } catch (IOException e) {
      throw new IOException(e.getMessage());
    }

    sMessage = sMessage.substring(0,sMessage.length()-OUT_MESSAGE_SUFFIX_LEN);
    return sMessage;
  }


  private void writeMessage(String sMessage)throws IOException{
     try {
      String sFullLine = OUT_MESSAGE_PREFIX +  parseString(sMessage) + OUT_MESSAGE_SUFFIX + "\n";
      System.out.println("writing into socket "+ sFullLine);
      _out.writeBytes(sFullLine);
      _out.flush();   

    } catch (IOException e) { 
        
	reconnect();
	throw new IOException ();
    }    
  }

  // write a message and wait for answer
  public String  writeRead(String sMessage) throws IOException {
     writeMessage(sMessage);
  	System.out.println("Message  : " + sMessage );
    String reply = readMessage();
  	return reply;
  }


  /*  // replace
  // #  ==> "
  // $#  => #
  // %%  => '
  // $%% => %%
  // --  => /
  // $-- => --

  private String parseString(String s){

    String tmp = replace(s,"#","\"");  // # -> "
    tmp = replace(tmp,"$\"", "#");
    tmp = replace(tmp,"%%","'");
    tmp = replace (tmp,"$'","%%");    
    tmp = replace (tmp,"--","\\");
    return replace(tmp,"$--","--");
    
    }*/

 private String parseString(String s){
   
   String tmp = replace(s,"#0","'");
   tmp = replace(tmp,"#1","\"");
   tmp = replace(tmp,"#2","\\");
   tmp = replace(tmp,"#3","&");
   return  replace(tmp,"##","#");
 }

 private String replace(String _string,String string1,String string2){

    StringBuffer buff = new StringBuffer(_string.length());
	int len1 = string1.length();
	int i=0;
	while(i< _string.length()){	
	  //for(int i=0; i < _string.length(); i++){

      if (_string.substring(i).startsWith(string1)){
        buff.append(string2);
		i+= len1;
	  }
      else{
        buff.append(_string.charAt(i));
		i++;
	  }
    }
    return buff.toString();
 }


  /*  private String parseString(String s){

    int len = s.length();
    StringBuffer buff = new StringBuffer(len);

    int i = 0;
    while (i<len-1){
      if((s.charAt(i)== '$')&&(s.charAt(i+1) == '#')) {
      	buff.append('#');
      	i++;
      } else if (s.charAt(i)== '#') {
    	  buff.append('"');
      } else {
      	buff.append(s.charAt(i));
      }

      i++;
    }

    // handel last char:
    if(s.charAt(i) == '#')
      buff.append('"');
    else 
      buff.append(s.charAt(i));

    return buff.toString();   
				
    }*/


  //*******************************************
  //
  // Functions to be used by the java Script:
  //
  //*******************************************  

  public boolean isConnected(){
    if(_appletStatus == CONNECTED){
      System.out.println("Applet is connected - you can click");
      return true;
    }
    return false;
  }

  public boolean isDisconnected(){
	return !isConnected();
  }
  
  public  String  specmanCommand(String command){
     return specmanCommand(command, true);
  }

  public  String  specmanCommand(String command, boolean tryAgain){

    String reply = null;
    try{
      reply = writeRead(command );
      System.out.println(" got reply: " + reply);
    } catch (IOException e) {
      
      if(tryAgain)
	specmanCommand(command, false);
    }
  	return  reply;
  }

}


