--------------------------
<'
import ahb_top;                             // loads the environment sources
import ahb_setup;                           // loads the environment setup

extend ahb_evc_name: [AHB_0];                   // 1. Add eVC instance name

extend my_router_env {
    AHB_0 has_monitor             has_masters             has_slaves 
            has_arbiter has_decoder ahb_env is instance;
}
        
extend AHB_0 ahb_config {       // 3. Update default topology 
                keep soft num_of_evc_masters == 1;
                keep soft num_of_dut_masters == 1;;
                keep soft num_of_evc_slaves == 1;
                keep soft num_of_dut_slaves == 1;;
};
            
extend AHB_0 ahb_env {          // 4. Set the hdl path
    keep hdl_path()     ==  ~/ahb_evc_top;
};

extend AHB_0 ahb_signal_map {           // 5. Update signal names
    keep AHB_HCLK       ==  specman_hclk; // clock        
    keep AHB_HRESET     ==  hresetn; // reset (active low)
    keep AHB_HPROT      ==  hprot; // 4-bit protection
    keep AHB_HWDATA     ==  hwdata; // 32-bit write data
    keep AHB_HRDATA     ==  hrdata; // 32-bit read data
    keep AHB_HADDR      ==  haddr; // address
    keep AHB_HWRITE     ==  hwrite; // transfer direction
    keep AHB_HSIZE      ==  hsize; // 3-bit transfer size
    keep AHB_HBURST     ==  hburst; // 3-bit burst type
    keep AHB_HTRANS     ==  htrans; // transfer kind
    keep AHB_HREADY     ==  hready; // transfer done
    keep AHB_HRESP      ==  hresp; // transfer response
    keep AHB_HMASTER    ==  hmaster; // master number
    keep AHB_HMASTLOCK  ==  hmastlock; // locked sequence
    keep AHB_HSPLIT     ==  hsplit; // 16-bit 
};
        
extend AHB_0 ahb_master_signal_map {
    keep AHB_HBUSREQ    ==  appendf("%s%d",hbusreq,id);
    keep AHB_HGRANT     ==  appendf("%s%d",hgrant,id);
    keep AHB_HLOCK      ==  appendf("%s%d",hlock,id);
    
    keep AHB_HTRANS_out ==  htrans;
    keep AHB_HADDR_out  ==  haddr;
    keep AHB_HWRITE_out ==  hwrite;
    keep AHB_HSIZE_out  ==  hsize;
    keep AHB_HBURST_out ==  hburst;
    keep AHB_HPROT_out  ==  hprot;
    keep AHB_HWDATA_out ==  hwdata;
};

extend AHB_0 ahb_slave_signal_map {
    keep AHB_HSEL       ==  appendf("%s%d",hsel,id);
    keep AHB_HREADY_out ==  hready;
    keep AHB_HRESP_out  ==  hresp;
    keep AHB_HRDATA_out ==  hrdata;
    keep AHB_HSPLIT_out ==  hsplit;
};

'>
-----------------------------------------
