-------------------------
<'

type cell_type: [ good, bad_hec, bad_address, bad_length ];
type ATM_payload_type: [ unstructured ];
            
extend packing {
    atm: pack_options;

    init() is also {
        atm = high.copy();
        atm.final_reorder = {8; UNDEF};
    };
};

struct ATM_cell {
    %header: ATM_header;
    %payload: ATM_payload;

    type: cell_type;
        keep header.hec_valid == !(type == bad_hec) ;
        keep header.address_valid == !(type == bad_address) ;
    !port_overflow: bool;
};

// The ATM header definition.  This encompasses UNI and NNI.
type pti_type: [    
            user_nc_sdu0,   user_nc_sdu1,   user_c_sdu0,    user_c_sdu1,
            seg_oamf5,      end_oamf5,      rm,             reserved
    ] (bits:3);

struct ATM_header {
    interface: [NNI,UNI];

    when NNI ATM_header {
        %vpi: uint(bits:12);
    };
    when UNI ATM_header {
        %gfc: uint(bits:4);
        %vpi: uint(bits:8);
    };
    %vci: uint(bits:16);
    %pti: pti_type;
    %clp: uint(bits:1);
    %hec: uint(bits:8);
    
    hec_valid: bool;
    address_valid: bool;

    calc_hec(): byte is {
        result = pack(packing.atm,me).crc_8(0,4)[7:0] ^ 8'x55 ;
    };

    good_hec : byte ;
    keep good_hec == calc_hec();
    keep gen (hec_valid) before (hec);
    keep hec_valid => hec == good_hec ;
    keep !hec_valid => hec != good_hec ;
};

struct ATM_payload {
    type: ATM_payload_type;
    %data[48]: list of byte;
};

'>
----------------------------------
