<'
---------------------------------

unit my_router_env {
    //control_port: ... is instance -- writen in ahb_evc_config.
    config: my_router_config is instance;
    
    ports: list of my_router_port is instance;
    keep ports.size() == config.num_of_ports;
    keep for each (port) in ports {
        port.id == index;
        port.p_env == me;
    };
    
    smp: my_router_signal_map is instance;
    
    event clk is change('(smp.CLK)') @sim;   // Main DUT clock
    event clk_r is {@hclk_r; [2]} @clk;          // Rising-edge clock
    
    stop_the_test()@clk_r is {
        wait [config.test_time] * cycle;
        stop_run();
    };
    
    run() is also {
        emit clk_r;
        start stop_the_test();
    };
};

unit my_router_signal_map {
    CLK: string;
    // ... to be extended;
};

unit my_router_config {
    num_of_ports: uint;
    test_time: uint;
    keep soft test_time == 500;
};

------------------------------
'>

