------------------------------

<'

extend my_router_env {
    scbd_my_router_env_scbd: my_router_env_scbd;
};

extend   {
    scbd_my_router_env_scbd:  my_router_env_scbd;			   
    keep scbd_my_router_env_scbd == 
        get_enclosing_unit(my_router_env).scbd_my_router_env_scbd;
    
    get_compared_data():list of byte is empty;
    get_key():int is empty;		      
					      
    event add_to_scbd;			      
    event match_from_scbd;		      
					      
    on add_to_scbd {
        scbd.add(me);
    };
    on match_from_scbd {
        scbd.match(me);
    };
    !key: int; // NOT to be touched !!! 
};

struct my_router_env_scbd {
    !in_data  : list(key: key) of  ;
    !out_data :  ;
    
    add(item:   ) is {
        if in_data.key_exists(item.get_key()) {
            error("SCBD ERROR: can't add same item twice (same key)");
        };
        var copy_item: scoreboard_item = item.deep_copy();
        copy_item.key = copy_item.get_key();
        in_data.add(copy_item);
    };
    
    match(item: scoreboard_item) is {
        var matched_item: scoreboard_item;
        matched_item = in_data.key(item.key);
        if matched_item == NULL {
            error("SCBD ERROR: no matching item found");
        };
        if matched_item.get_compared_data() != item.get_compared_data() {
            error("SCBD ERROR: no matching item found");
        };
    };
};

'>

-------------------------------------------
