--------------------------------
<'

type direction: [RX, TX];
        
unit my_router_port {
    id: int;
    
    injector: my_router_stub_port is instance;
    collector: my_router_stub_port is instance;

    keep injector.p_port == me;
    keep injector.direction == TX;
    keep injector.id == id;

    keep collector.p_port == me;
    keep collector.direction == RX;
    keep collector.id == id;
    
    p_env: my_router_env;
    
};

unit my_router_stub_port {
    direction: direction;
    p_port: my_router_port;
    id: uint;
    
    !cur_packet:  ATM_cell;

    next_packet() is {
        gen cut_packet;
    };
    
    main()@p_port.p_env.clk_r is empty;
    
    run() is also {
        start main();
    };
    
    when TX my_router_stub_port {
        main()@p_port.p_env.clk_r is only {
            while TRUE {
                next_packet();
                inject();
                wait cycle;
            };
        };
        
        inject()@p_port.p_env.clk_r is {
            // ... to be extended
        };
    };
    
    when RX my_router_stub_port {
        main()@p_port.p_env.clk_r is only {
            while TRUE {
                cur_packet = collect();
                wait cycle;
            };
        };
        
        collect():ATM_cell @p_port.p_env.clk_r is {
             // ... to be extended
        };
    };
};

---------------------------------
'>

