global  debug_reset
set debug_reset 0

#-------------------------------------------------------------------------
# This proc is called from specman after all categories were added to the
# tab control but the pages are still empty .... ( bofore adding the widgets)
#-------------------------------------------------------------------------
proc show_message {title txt wname } {

    global sn_text_font

    set dlg_name $wname.msg_dlg
    set x [expr ([winfo rootx $wname] + 100)]
    set y [max 250 [expr ([winfo rooty $wname] - 50)]]

    toplevel $dlg_name
    wm title $dlg_name $title
    wm geometry $dlg_name +$x+$y
    create_window_icon $dlg_name

    frame $dlg_name.frame 
    button $dlg_name.frame.b -text "OK" -command "destroy $dlg_name"

    label $dlg_name.frame.txt -text "$txt" -font $sn_text_font -bg snow2 \
	-relief sunken -pady 5 -padx 10 -borderwidth 1 -justify left -anchor w 


    pack $dlg_name.frame.txt -padx 20 -pady 5 -side top
    pack $dlg_name.frame.b -padx 20 -pady 10 -side top
    sn_bind_balloon $dlg_name.frame.b "Perform search and close this window" 

    #set width [winfo width $dlg_name.frame.txt]
    
    set txt_width1 [font measure  $sn_text_font -displayof $dlg_name.frame.txt "H"]
    set txt_width [expr ($txt_width1 * 40)]
    $dlg_name.frame.txt config -wraplength $txt_width

    pack $dlg_name.frame -padx 5 -pady 10

    focus $dlg_name.frame.b
    grab $dlg_name
    tkwait window $dlg_name
    grab release $dlg_name
}


proc handle_newline { str_val } {
    
    regsub -all $newline $str_val {\n} str_val
    return $str_val
}

proc sn_finish_build_dummy_page { wname dummy_f_name} {

    global building_dialog
    global config_book_name
    global the_global_config_categories
    global GenericGroupIdx
    global dummy_field_name
    
    set dummy_field_name $dummy_f_name

    if { $building_dialog == 0 } {
	return
    }


    #-- pack book
    pack $config_book_name -expand 1 -fill both -side top

    #-- Build the global buttons
    sn_build_wizard_buttons $wname

    set GenericGroupIdx 1

    #-- overwrite config win 
    wm protocol $wname WM_DELETE_WINDOW "sn_button_clicked $wname close 1 0"

    return
}

proc sn_is_form_modified {} {
    
    global is_config_modified

    collect_form_values
    return $is_config_modified 
}


proc sn_close_form {} {
    
    global config_wname
    global the_global_config_categories

    unset the_global_config_categories

    destroy $config_wname
}

proc confirm_result {dlg_name confirm} {

    global confirm_close

    set confirm_close $confirm

    destroy $dlg_name

    return
}

proc sn_confirm_close {} {

    global config_wname
    global confirm_close

    set dlg_name $config_wname.confirm_next

    toplevel $dlg_name
    wm title $dlg_name "Confirmation"
    wm geometry $dlg_name +600+100  

    button $dlg_name.ok -text "OK" -command "confirm_result $dlg_name 1"
    button $dlg_name.cancel -text "Cancel" -command "confirm_result $dlg_name 0"

    message $dlg_name.msg -text "The form was modified. Changing to other form will cause those changes to be lost.If you want to save changes choose 'cancel' and return to the current form" -aspect 1000
    pack $dlg_name.msg -padx 20 -pady 5 -side top
    pack $dlg_name.ok  -padx 20 -pady 10 -side left 
    pack $dlg_name.cancel -padx 20 -pady 10 -side right
   
    bind $dlg_name <ButtonPress-1> {
	raise %W
    }

    focus $dlg_name.ok
    grab $dlg_name
    tkwait window $dlg_name
    grab release $dlg_name

    return $confirm_close

}

#---------------------------------------------------------------------------
#-- Build buttons
#------------------------------------------------------------------------------
proc sn_build_wizard_buttons {wname} {

    tixButtonBox $wname.buttons -orientation horizontal

    #$wname.buttons add ok -text "OK" -command "sn_button_clicked $wname ok 1 1" -width 6

    $wname.buttons add next -text "Next>" \
	-command "sn_button_clicked $wname next 1 1" -width 6  

    $wname.buttons add reset -text "Reset" \
	-command "sn_button_clicked $wname reset 1 0" -width 6  

    $wname.buttons add close -text "Cancel" \
	-command "sn_button_clicked $wname close 1 0" -width 6

    $wname.buttons add explain -text "Explain" \
	-command "sn_button_clicked $wname explain 1 0" -width 6 

    pack $wname.buttons -expand 0 -fill both -side top

    #sn_bind_balloon [$wname.buttons subwidget ok] "Close this window, and set the new values" $wname

    sn_bind_balloon [$wname.buttons subwidget next] \
    "Continue to next stage after applying" $wname

    sn_bind_balloon [$wname.buttons subwidget reset] \
    "reset current form" $wname

    sn_bind_balloon [$wname.buttons subwidget close] \
    "Exit from form without save" $wname

    sn_bind_balloon [$wname.buttons subwidget explain] \
    "Detailed explaination about this form" $wname

    
}

proc sn_get_form_params {} {

    set valid_state [validate_form]
    if {$valid_state == 0 } {
	return
    }

    set form_params [collect_form_values]
    return $form_params
}


proc sn_button_clicked {wname button_name from_button should_collect} {

    set params ""

    if { $should_collect == 1 } {
	set valid_state [validate_form]
	if {$valid_state == 0 } {
	    return
	}

	set params [collect_form_values]
	
    }

    set command_result [sn_command "p_ebuilder.eb_manager.p_selected_node.ebi_button_clicked(\"$wname\" , \"$button_name\", \"$params\")" specman 0 $from_button $from_button] 

    
    return
}

proc validate_form {} {

    global curr_page

    set status [perform_validation]
    if { $status == 0 } {
	# can not apply - some field is invalid    
	return $status
    }

    set status [validate_page $curr_page ] 
    if { $status == 0 } {
	# can not apply - the current page is invalid    
	return $status
    }

    set status [validate_tab]
    if { $status == 0 } {
	# can not apply - the current page is invalid    
	return $status
    }
    
}
proc collect_form_values {} {

    global the_global_config_categories
    global curr_page
    global legal_input
    global category_visited_idx
    global is_config_modified

    set result ""
    set legal_input 1
    set is_config_modified 0

    set status [validate_form]
    if { $status == 0 } {
	# can not apply - some field is invalid    
	set is_config_modified 1
	return $result
    }

    for {set i 0} { $i < [ llength $the_global_config_categories] } {incr i} {
	set category_info [lindex $the_global_config_categories $i]
	set is_visited [lindex $category_info $category_visited_idx]
	if { $is_visited == 1 } {
	    set category_params [collect_form_category_values $category_info]
	    if { $i > 0 } {
		append result "@@" 
	    }
	    append result $category_params
	}
    }

    return $result

}

proc collect_form_category_values { category_info} {

    global category_options_list_idx
    global option_orig_val_idx
    global category_name_idx
    global option_type_idx
    global option_tcl_var_idx
    global option_e_var_name_idx
    global is_config_modified
    global dummy_field_name

    set is_modified 0
    set first_param_appended 0

    set category_name [lindex $category_info $category_name_idx]
    set result ""

    set options_list [lindex $category_info $category_options_list_idx]

    for { set i 0 } { $i< [llength $options_list] } {incr i} {
	set option_info [lindex $options_list $i]
	set option_name [lindex $option_info $option_e_var_name_idx ]
	set option_type [lindex $option_info $option_type_idx]

	set new_val_name [lindex $option_info $option_tcl_var_idx]	 
	global $new_val_name

	set re "^(.)*"
	append re $dummy_field_name "\$"

	# options with dummyfield should not be validate
	if { [regexp $re $new_val_name] == 0 } {
	    set new_val [set $new_val_name]
	   
	    set original_val [lindex $option_info $option_orig_val_idx]
	
	    set tmp_val ""

	    if { $new_val != $original_val } {
		set is_modified 1 
	    }
	    
	    if { [string match QUATED $option_type] } {
		regsub -all {\"} $new_val {\\"} new_val
	    }

	    if { $first_param_appended == 1 } {
		append result "@@" 
	    }	
		
	    if { $new_val == "" } {
		set new_val " "
	    }
	    append result $new_val
            set first_param_appended 1
	}
    }

    
    if {  $is_modified == 1 } {
	
	if { $is_config_modified == 0 } {
	    set is_config_modified 1
	}
    }

    return $result
}



 