Creator:  Ronen Zlochenko
		Verisity LTD.

<'

C code #:
static l__source_ref sources = NULL;
static l__int sizes = NULL;
end #;

extend no_save {
	unknow_alloc: int;
	alloc_no_test: int;
};

extend global {

	setup_test() is also C code #:
		if(!sources) {
			MAKE_NEW_LIST_MALLOC(sources,d__l__source_ref);
		}
		if(!sizes) {
			MAKE_NEW_LIST_MALLOC(sizes,d__l__int);
		}
		GLOB_NS->unknow_alloc = 0;
		GLOB_NS->alloc_no_test = 0;
	end #;

	pre_alloc(func: string, size: int) is also C code #:
		if(load_in_progress || 
		   sn_gc_in_progress ||
#if 1
		   GLOB_SESS->test_phase == test_phase__before_setup ||
		   GLOB_SESS->test_phase == test_phase__before_generate) {
#else 
		   GLOB_SESS->test_phase == test_phase__before_setup) {
#endif
			return;
		}

		if(!GLOB_NS->ntv_done_now) {
			GLOB_NS->unknow_alloc += size;
			return;
		}

		LIST_ADD_MALLOC(sources,GLOB_NS->ntv_done_now->source_ref);
		LIST_ADD_MALLOC(sizes,size);
	end #;

	sources(): list of source_ref is C code #:
		result = sources;
	end #;

	sizes(): list of source_ref is C code #:
                result = sizes;
        end #;


};

extend symtab {
	ntv_for_field: ntv;
	temp_ntv: ntv;

	init() is also {
		ntv_for_field = new;
	};
};

extend field_node {
	eval_field(pre: bool) is first {
		symtab.temp_ntv = no_save.ntv_done_now;
		symtab.ntv_for_field.source_ref = me.field.source_ref;
		no_save.ntv_done_now = symtab.ntv_for_field;
	};
	
	eval_field(pre: bool) is also {
                no_save.ntv_done_now = symtab.temp_ntv;
        };

};

'>
extend entry_instance {
	prepare_leads(x: bool) is first {
		if x  && entry != NULL then {
			no_save.ntv_done_now = symtab.ntv_for_field;
			no_save.ntv_done_now.source_ref = entry.source_ref;
		};
	};
};
			
<'

struct source_size {
	source_ref;
	size: int;
};

struct file_size {
	name: string;
	module: module;
	sizes: list of int;
	lines: list of int;
};

extend global {

	setup_test() is also {
		debug.alloc = TRUE;
//		set_config(memory,gc_threshold,100M);
	};

	finalize_test() is also {
		alloc_stat();
	};

	get_files(l: list of source_size): list of file_size is {
		var si: source_item = new;
		for each (source_size) in l do {
			si.source_ref = source_size.source_ref;
			var m: module = si.source_module();
			var curr: file_size;
			for each (file_size) in result {
				if m == file_size.module then {
					curr = file_size;
					break;
				};
			};
			if curr == NULL then {
				curr = new;
				curr.module = m;
				curr.name = append("/tmp/",m.name);
				result.add(curr);
			};
			curr.sizes.add(source_size.size);
			curr.lines.add(si.source_line());
		};
	};

	create_files(lf: list of file_size) is {
		var ls: list of string;
		for each (f) in lf do {
			ls.clear();
			ls.add("size in bytes |                         source");
			ls.add("--------------+------------------------------------------------------------------");
			var curr_ind: int;
			var end: bool;
			for each line (ll) in file f.module.file_name do {
				var curr_size: int;
				if not end then {
					if index + 1 == f.lines[curr_ind] then {
						curr_size = f.sizes[curr_ind];
						curr_ind += 1;
						if curr_ind >= f.sizes.size() then {
							end = TRUE;
						};
					};
				};
				if curr_size == 0 then {
					ls.add(appendf("%13s | %s","",ll));
				}
				else {
					ls.add(appendf("%13d | %s",curr_size,ll));
				};
			};
			files.write_string_list(f.name,ls);
		};
	};

	show_files(lf: list of file_size) is {
		out("");
		out("");
		out("          Profiling analysis");
		out("          ------------------");
		for each (f) in lf do {
			outf("          line 1 in %s\n",f.name);
			//display.show_file(f.name,1);
			
		};
		out("");
		out("         Unknown allocation during test: ",no_save.unknow_alloc);
		out("         Allocation not during test: ",no_save.alloc_no_test);
		out("");
		out("");
	};

	alloc_stat() is {
		debug.alloc = FALSE;
		var sources:= sources().copy();
		var sizes := sizes().copy();

		var count: list (key: source_ref) of source_size;
		
		for each in sources do {
			var s: source_size = count.key(it);
			if s == NULL then {
				s = new;
				s.source_ref = it;
				count.add(s);
			};
			s.size += sizes[index];
		};

		var count1: list of source_size;
		for each in count do {	count1.add(it);};
		count1 = count1.sort(it.source_ref);
		
		var files:= get_files(count1);
		create_files(files);

		var ccc:= get_config(print,items);

                set_config(print,items,2000);

		count1 = count1.sort(it.size);

                report count1, {
                        "  size in bytes                      source";
                        "  -------------                      ------";
                        "%10d           %s"
                }, .size, .source_ref;

                set_config(print,items,ccc);

		show_files(files);


	};
};

define <show_mem_prof'command> "show mem prof[ile]" as {
	global.alloc_stat();
};

'>
		
