
This patch enforces a strict order of thread evaluation in e, 
regardless to the order of simulator callbacks.

virsion 2: add support for computed model names

<'
extend waiting_thread {
    from_event_id: int;
    sig_entry: int;
};

extend scheduler {

    main_loop() is only {    
        var ev  :sn_event_struct;
        var evq_last: int = 0;

        var wt	:waiting_thread;
        
        for phase from 0 to 2 do {      // 3 relaxation phases
            repeat {
                
                // Handle TEs
                if sched_ext.trace_main_loop then {
                    sched_trace(eval_te);
                };
                    
                if phase == 0 then { // <<<SORT_SIMULATOR_EVENTS
                    var lw: list of waiting_thread;
                    var w1: waiting_thread;
                    w1 = thread_que.pop0().unsafe();
                    while w1 != NULL and w1.from_event_id != 0 do {
                        lw.add(w1);
                        w1 = thread_que.pop0().unsafe();
                    };
                    wt = w1;
                    if lw.size() > 0 then {                            
                        lw = lw.sort(.sig_entry);
                        lw = lw.sort(.from_event_id);
                        for each (w) in lw do {
                            current_te_id = w.temporal_exp_id;
                            current_ar = w.context;
                            eval_waiting_thread(w);
                            w.queued = FALSE;
                            w.from_event_id = 0;
                        };
                        lw.clear();
                    };
                } else {
                    wt = thread_que.pop0().unsafe();
                };
                while (wt != NULL) {
                    current_te_id = wt.temporal_exp_id; // for profiler
                    current_ar = wt.context;		// for profiler
                    eval_waiting_thread(wt);
                    wt.queued = FALSE;
                    wt.from_event_id = 0;
                    wt = thread_que.pop0().unsafe();
                };
	        current_te_id = UNDEF;			// for profiler
	        current_ar = NULL;			// for profiler
                
                while evq_last < event_que.size() {
                    ev = event_que[evq_last];
                    assert not ev.evaluated;
                    eval_consume(ev);
                    ev.evaluated = TRUE;
                    evq_last += 1;
                };
                
                if sched_ext.trace_main_loop then {
                    sched_trace(eval_tcm);
                };

                tcm_gen += 1;
                var cur_tcm : sn_tcm_thread = tcm_queue_first;
                tcm_queue_retained_last = tcm_queue_last;
                tcm_queue_first = NULL;
                tcm_queue_last = NULL;
                while (cur_tcm != NULL) {
                    #filter {
                        assert cur_tcm == threads.get_thread_by_handle(cur_tcm.handle);
                    };
                    
                    current_thread = cur_tcm;
                    tcm_swap_in(cur_tcm);
                    current_thread = NULL;
                    
                    var next_tcm : sn_tcm_thread = cur_tcm.next_in_tcm_queue;
                    
                    // a thread can be re-scheduled at the end of a queue only.
                    cur_tcm.next_in_tcm_queue = NULL;
                    cur_tcm = next_tcm;
                };
                tcm_queue_retained_last = NULL;
            }
            until (evq_last >= event_que.size() and 
                   thread_que.size() == 0 and tcm_queue_first == NULL);
            
            // processed all events in event queue
            event_que.clear();
            evq_last = 0;
            
            case phase {
                0: {neg_event_type.emit_event(me) };-- emit NEG 
                // TODO:
                // new_time_event_type is in fact 'tick_end'. Change its name.
                1: { new_time_event_type.emit_event(sys); session.new_time_started = FALSE; };
            };
            
        };   
        
        if sched_ext.trace_on then { sched_trace(end_of_tick); };
        
        disable_done_callbacks();
    };
    
    wake_waiting2(e :sn_event_struct) is {
        var w           :wait_entry;
        var i           :int;
        var wt          :waiting_thread;
        var et		:event_type;

        et = e.event;
        if ((not neg_like_in_4_1_1) and et == neg_event_type) {
            wake_waiting_neg(e);
            return;
        };
        if (et.trace_emit) then {  add_traced_instances(et);};
        e.swap_waiting.clear();

        var w_list      :list of wait_entry = e.waiting;
        var w_list_size :int = w_list.size() - 1;

        for i from 0 to w_list_size  do {
            w = w_list[i];
            w_list[i] = NULL;
            wt = w.thread;

            if ( // waking request validity check
              
                (w.stop_eval_tick >= tick_counter) and            // not out of time  
                (! wt.queued) and    // the rqs is needed
                (
                    (w.thread_generation == wt.cur_generation)        // the rqs was made by wt
                    or
                    (
                        (w.thread_generation == wt.prev_generation) 
                        and 
                        (wt.the_te_mem.last_evaluation == tick_counter)
                     )
                 )
                )
                then {
                // not in queue, wait_entry matches waiting_thread             
                
                assert ((w.sig_entry == UNDEF) == (et.callback_info == NULL));
                if  (( w.sig_entry == UNDEF or 
                    et.callback_info.cb_list[w.sig_entry].occurrence_time_counter
                    ==  scheduler.time_counter) 
		    // actually this should be <=, but in favor of max_tick == UNDEF
                    and (w.start_eval_tick != tick_counter+1)) then {
                    // add thread to the priority queue of threads waiting for evaluation
                    wt.queued = TRUE;
                        
                    // <<<SORT_SIMULATOR_EVENTS
                    if et.parent_type == type(simulator) {
                        wt.from_event_id = et.event_id;
                        wt.sig_entry = w.sig_entry;
                    } else {
                        wt.from_event_id= 0;
                    };
                    
                    thread_que.add(wt.tier, wt);
                    // remove wait entry from waiting list for re-use later.
                    wait_entry_bank.add(w);
                } else {
                // not the right instance, continue waiting
                    e.swap_waiting.add(w);
                };

            } else {
                wait_entry_bank.add(w);  // remove, not valid already
            };
        }; // for

        e.waiting =e.swap_waiting;
        e.swap_waiting=w_list;  //this is needed both to save space and to prevent double pointing
        e.swap_waiting.clear();
    };
};

extend event_type {
    
    emit_event_helper2(inst :any_struct, is_on_method_compiled : bool) is {

        var mult :bool;
        
        if inst == NULL then {
            sn_err(ERR_TE_EMITNULLSTRUCT);
        };
        if  session.test_phase.as_a(int) ==  test_phase'before_setup.as_a(int) then {
            if parent_type != type(session) then {
                sn_err(ERR_TE_EVENTBEFORETEST,inst.to_string(),event_name);
            };
        };
        if trace_emit then {
            traced_instances.add(inst.unsafe());   
        };
        
        mult =  scheduler.tick_counter == inst.unsafe_get_field (occurrence_field_l) ;
        
        if not mult {
            inst.unsafe_put_field(occurrence_field_l,scheduler.tick_counter);
            scheduler.emit_gen += 1;
        };
        case on_status {
            on_empty    :{};
            on_extended :{ 
                call_on_method(inst,is_on_method_compiled);
            };
            on_unknown  :{  -- done once at first call
                
                if (kind != hdl and 
                    ((parent_type.methods[on_method_ind].kind != empty) or 
                    (parent_type.get_descendants().has(it.methods[on_method_ind].kind != empty)))) then {
                    on_status = on_extended;
                        call_on_method(inst,is_on_method_compiled);
                    } else {
                    on_status = on_empty;
                };
            };
        };
        
        count += 1;
        if (log_needed) {
            scheduler.handle_event(me.event_id,inst);
        }; -- 'fast' return if no logging needed
        
        if mult then {
            return;    -- prevent multiples  
        };

        var tmp:sn_event_struct=inst.unsafe_get_field(event_struct_field);
        
            
        if tmp == NULL {
            // warning("emit event: event struct cannot be NULL, event_id: ",dec(event));
            tmp = new; 
            inst.unsafe_put_field(event_struct_field,tmp);
            tmp.inst = inst.unsafe();            
            // tmp.event_id=me.event_id;
            tmp.event=me;
        };
        if not (kind == consumed) {
            scheduler.wake_waiting2(tmp);
        }
        else {
            tmp.evaluated = FALSE;     -- since something changed
            scheduler.event_que.add(tmp);
        };
    };

    emit_event(inst :any_struct) is only {
        emit_event_helper2(inst,FALSE);
    };
    
    emit_event_compiled(inst :any_struct) is only {
        emit_event_helper2(inst,TRUE);
    };        
};
'>