#!/bin/sh -fe

if [ "`dirname $0`" != "`pwd`" ]; then
    cd "`dirname $0`"
fi

if [ "$1" = "-q" ]; then
    quantify=1
    shift
else
    quantify=0
fi

rm -f ./.specman

if [ "$quantify" != 1 ]; then

set -x

# build the examples without Quantify:
sn_compile.sh twiddledee
sn_compile.sh twiddledum

# CPU-profile the examples
run_prof.sh -report=twiddledee-cpu ./twiddledee -c test
run_prof.sh -report=twiddledum-cpu ./twiddledum -c test

# make diff
../prof_diff.sh quant.twiddledee-cpu quant.twiddledum-cpu

# memory-profile the examples
run_prof.sh -mem -report=twiddledee-mem ./twiddledee -c test
run_prof.sh -mem -report=twiddledum-mem ./twiddledum -c test

# make diff
../prof_diff.sh quant.twiddledee-mem quant.twiddledum-mem

else

set -x

# build the examples with Quantify:
../sn_compile.q.sh twiddledee
../sn_compile.q.sh twiddledum

# profile the examples with Quantify
run_prof.sh -q -report=twiddledee-quantify ./twiddledee -c test
run_prof.sh -q -report=twiddledum-quantify ./twiddledum -c test

# make diff
../prof_diff.sh quant.twiddledee-quantify quant.twiddledum-quantify

fi
