#!/bin/sh -f

if [ "$SPECMAN_HOME" = '' ]; then
   echo the SPECMAN_HOME environment variable is not set.  I can\'t work.
   exit 2
fi

usage() {
    echo usage: prof_diff.sh '<dir A>' '<dir B>'
}

if [ "$1" = "-h" ]; then
    usage
    exit 0
fi

if [ "$1" = "" ]; then
    echo *** error: no args
    usage
    exit 1
fi

if [ "$#" -lt 2 ]; then
    echo *** error: wrong number of args
    usage
    exit 1
fi

dir_a=$1; shift
dir_b=$1; shift
name_a=`basename $dir_a`
name_b=`basename $dir_b`

if [ "$SPECMAN_PROFILER_SRC" = '' ]; then
    SPECMAN_PROFILER_SRC="$SPECMAN_HOME/src"
fi

result="`pwd`/qdiff-${name_a}-${name_b}.html"

specman -p "loa \"$SPECMAN_PROFILER_SRC/prof.e\"; $SPECMAN_PROFILER_POST_LOAD; sys.q_exclude=5; sys.q_diff=TRUE; sys.q_fname=\"${dir_a}/func_data.mqx\"; sys.q_fname2=\"${dir_b}/func_data.mqx\"; sys.q_tname=\"${dir_a}/func_map.tbl\"; sys.q_info=\"${dir_a}/info.txt\"; sys.q_tname2=\"${dir_b}/func_map.tbl\"; sys.q_info2=\"${dir_b}/info.txt\"; sys.q_rname=\"${dir_a}/report.html\"; sys.q_rname2=\"${dir_b}/report.html\"; sys.q_output=\"$result\";" -c test

echo to view, type
echo netscape file://${result}
