
PRE_COMMANDS should be 

<'
import  sn_cmp_types;

define CMP_LOG		"cmp.elog";
define EFILES_LOG	"efiles.elog";
define CFG_LOG		"config.elog";
define START_LOG_STRING "##EE  START_CMP_LOG";


#ifdef CMPNOTEST  then {
define <test2'command> "tes[t]" as {
    out("Test is disabled during compare session ");
};
};


extend sn_compare {  
    
    run_dir :string;
    

    cmp_dir_1 :string;
    cmp_dir_2 :string;

    cmp_run:file;
    
    fl_cmp1:file;
    fl_cmp2:file;
    
    full_path (s:string):string is  {
        result = append (run_dir,"/",s);
    };
    
    full_path1 (s:string):string  is  {
        result = append (cmp_dir_1 ,"/",s);
    };
    full_path2 (s:string):string  is  {
        result = append (cmp_dir_2,"/",s);
    };
    init() is also { 
        specman ("config print -line_size=10000");
    };
    log_init(dir:string) is {
        run_dir = dir;
        var cmp_path:=append(run_dir,"/",CMP_LOG);
        
        var cmp_file_exists:bool = not system(append("test -f","cmp_path")).as_a(bool);
        write_config("/tmp/sn_config_tmp"); 

        set_config (run,exit_on,error);
        if cmp_file_exists then {
            out("file ",cmp_path ," exists ,so directory is overriden");
            compute system(append("/bin/rm -rf ",run_dir)); 
        };
        
        if system(append("/bin/mkdir ",run_dir)) != 0 then {
            error (" could not create dir ",run_dir);
        }; 
        
        specman(append("set log ",run_dir,"/",CMP_LOG));
        out(START_LOG_STRING);
        out(specman_config.specman_version);

        compute system  ("echo $SPECMAN_PRE_COMMANDS");
        compute system  ("echo $SPECMAN_COMMANDS");
        
        
        cmp_run = files.open(full_path("cmp_run.ecom"),"w","Text file");

        read_config("/tmp/sn_config_tmp"); 
        
    };
  

    next_time_to_read :int;
    compare(dir_1:string ,dir_2:string ) is {
        cmp_dir_1 = dir_1;
        cmp_dir_2 = dir_2;
                        
        if compare_sources then { compare_sources();};
        --compare_config();

        fl_cmp1 = files.open(full_path1(CMP_LOG) ,"r" , "Text file");
        fl_cmp2 = files.open(full_path2(CMP_LOG) ,"r" , "Text file");


        var pre_test1:list of string= get_block (fl_cmp1  ,START_LOG_STRING  ,"##START TEST");
        var pre_test2:list of string= get_block (fl_cmp2  ,START_LOG_STRING  ,"##START TEST");
        
        
        var diff:=my_diff (pre_test1 , pre_test2);
        out("*** Checking before Run phase:");
        if diff.size() > 0 {
            report(diff);
        };
        compare_sys_dump(0); 
    };
    
    cmp_next_time() is {

        var l1 := get_block (fl_cmp1  ,"##EE TIME UNIT " , "##EE TIME ENDED" );
        var l2 := get_block (fl_cmp2  ,"##EE TIME UNIT " , "##EE TIME ENDED" );
        
        var ctime:int = str_sub(l1[0],str_len("##EE TIME UNIT "),10).as_a(int);
        
        if compare_run_logs then {
            if compare_time_sorted  {
                l1=l1.sort(it);
                l2=l2.sort(it);
            };
            if filter_shtrudel  {
                l1=l1.apply(str_replace(it, "/-@[0-9]*/", "-@<filtered>"));
                l2=l2.apply(str_replace(it, "/-@[0-9]*/", "-@<filtered>"));
            };
            if normalize_path  {
		for each in l1 {
		    if (it ~ "/sim_read/" or it ~ "/sim_write/") {  
			l1[index] = str_replace(it, "/(\//", "("); // takeoff each leading /
			l1[index] = str_replace(it, "/\//", ".");  // replace other / with .
		    };
		};
		for each in l2 {
		    if (it ~ "/sim_read/" or it ~ "/sim_write/") {
			l1[index] = str_replace(it, "/(\//", "(");
			l1[index] = str_replace(it, "/\//", ".");
		    };
		};
            };
            var diff:=my_diff (l1  , l2);
            if diff.size() > 0 {
                out("*** Checking at time ", compare_time_sorted? "(sorted)": "", ": ",ctime);
                report(diff);
            };
        };
     
        compare_sys_dump(ctime);
    };
    
    get_time (fl :file  ,start_KW_Fix:string  ,end :string   ) :list of string is {
        while TRUE {
        var l  := get_block (fl  ,start_KW_Fix , end   );
        var time:int = str_sub(l[0],str_len("##EE TIME UNIT "),10).as_a(int);
        if time >=   next_time_to_read then {
            next_time_to_read = time;
            return (l);
        };
        };
    };

    my_diff( l1 :list of string , l2 :list of string ) :list of string is {
        files.write_string_list("/tmp/sn_cmp1.txt",  l1);
        files.write_string_list("/tmp/sn_cmp2.txt",  l2);
        
        var diff := output_from  ("/usr/bin/diff -w  /tmp/sn_cmp1.txt /tmp/sn_cmp2.txt" );
        
        --remove all lines starting without "<" or ">"  ( position lines );
        diff=diff.all(str_chop(it,1) == "<" or  str_chop(it,1) == ">");
        
        result = diff;
    };
    
    
    sync_to( fl:file , str:string  )  : string is {
        var tmp:string;
        
        str=append("/.*",str,".*/");
        
        while files.read(fl,tmp) {
            if tmp ~ str then {break;};
        };
        
        assert tmp ~ str ;
        return tmp;
    };
    

    // To overcome 4.0 dissimilarity with 3.3 take off the when determant
    // off the string
    when_field_off( s: string):string is {
	result = s;
	while str_match( result, "/(\S*)'(\w*)(.*)/" ) {
            result = append( $1, $3);
	};
    };
    
    get_block( fl :file , start_str :string, end_str :string ):list of string is {
        
        var tmp:string;
        end_str  = append("/.*",end_str,".*/");

        tmp =sync_to(fl ,start_str);
        result.add(tmp);
        
        while files.read(fl,tmp) {
            if tmp ~ end_str  then {
                result.add(tmp);
                break;
            };
	    tmp = when_field_off(tmp);
            result.add(tmp);
        };
        
    };
    
    read_list_file(n:string ) :list of string is {
        var fl:file = files.open( n, "r", "Text File");
        var tmp:string;
        
        while files.read(fl,tmp) {
            result.add(tmp);
        };

    };
    

    compare_sources () is {
--        var fns1 :=   get_block(cmp_path_1,"$$$file names");
--        var fns2 :=get_block(cmp_path_2,"$$$file names");

        var fns1 := read_list_file (full_path1(EFILES_LOG));
        var fns2 := read_list_file (full_path2(EFILES_LOG));
        var fn1 :string;
        var fn2_idx: int;
        
        var diff:list of string;

        
        out("*** Checking source files:");
        
        for each (fn_full_1) in fns1 {
            fn1 = files.get_file_name(fn_full_1);
	    if not str_match(fn1, "/(.*)sn_compare(.*)/") and
	       not str_match(fn1, "/(.*)sn_cmp_types(.*)/") {
           
                fn2_idx = fns2.first_index(files.get_file_name(it) == fn1 );
                if fn2_idx == UNDEF then {
                    report({append("Found no matching file for ",fn_full_1,"\n")});
                } else {
                    diff = output_from  (append ( "/usr/bin/diff -w ",fn_full_1," ",fns2[fn2_idx]) );
            	    if diff.size() > max_lines_per_error then {
                        diff = diff[0..max_lines_per_error-1];
            	    };

            	    if diff.size() > 0 then {
                        diff.add0({append(fn_full_1," .vs. ",fns2[fn2_idx]);"\n"});
                        report(diff);
            	    };
            	    fns2.fast_delete(fn2_idx);
            	};
	    };
        };
        
        if not fns2.is_empty() then {
            for each in fns2 {
	        if not str_match(it, "/(.*)sn_compare(.*)/") and
	           not str_match(it, "/(.*)sn_cmp_types(.*)/") {
                    report({append("Found no matching file for ",it,"\n")});
	        };
            };
        };
        
    };
    !last_sys_sampled:int;
    handle_sys_dump () is {
        
        var d:int = sys.time - sn_compare.dump_sys_start_time;
        if ( (d>=0) and ( (sys.time -sn_compare.last_sys_sampled ) >=sn_compare.dump_sys_frequency) ) or 
            ( sys.time == 0 )
            then {
            sn_compare.last_sys_sampled = sys.time;
            if files.type().methods.apply(it.get_name()).has(it ~ "/write_binary_struct_user/" ) {
             specman ("files.write_binary_struct_user(sn_compare.full_path(append(sys.time,\".esv\")), sys);");
            } else {
             files.write_binary_struct(sn_compare.full_path(append(sys.time,".esv")), sys);
            };
        };
    };


    sys_cmp_failed : bool; // defect 4424
    compare_sys_dump(ctime:int) is {
       	var d:int = ctime - sn_compare.dump_sys_start_time;
	try {
       	    if (not sys_cmp_failed and (d>=0) and 
            	( (ctime - sn_compare.last_sys_sampled) >=sn_compare.dump_sys_frequency ))
            	or ctime ==0 then {
            	sn_compare.last_sys_sampled = ctime;
            	var s1:sys=  files.read_binary_struct(full_path1(append(dec(ctime),".esv")),"sys",
				FALSE).as_a(sys);
        	var s2:sys=  files.read_binary_struct(full_path2(append(dec(ctime),".esv")),"sys",
				FALSE).as_a(sys);
            
                var dc:=deep_compare(s1,s2,max_lines_per_error);
                --remove_private_fiels
                dc = dc.all(!name_is_private(it));
           
                out("*** Checking SYS at time :" , ctime);
                if  dc.size() >= 1  {
                    report(dc.all(index >= 1));
                };
            };
	} else {
	    if not sys_cmp_failed {
		out("===========>   Failed to compare sys! (defect 4424)");
		out("               Will still compare logs");
	    	sys_cmp_failed = FALSE;
	    };
        };
    };
    
    
    
    
    report(l :list of string) is {
        var removed :bool;
        
        for each (line_KW_Fix) using index (l_index) in l  {
            for each in filter_REs {
                if line_KW_Fix ~ it then {
                    removed =TRUE;
                    l[l_index]  ="##REMOVED";
                };
            };
            
            for each in changed_REs {
                if line_KW_Fix ~ it then {
                     l[l_index] = str_replace( l[l_index] , it , changed_to[index]);;
                };
            };
        };
        
        if removed then { l=l.all(it!= "##REMOVED")};
            
            
        if  l.size() >  max_lines_per_error then {
            l = l[0..max_lines_per_error-1];
            l.add("...");
        };
       
        if l.size() > 0 {
            for each in l {
            out("       ", it);
            };
        };
        
    };

  
    
};
extend global {
    sn_compare;
    init() is also { 
        sn_compare = new;

    };
    start_test() is first {
        sn_compare.start_KW_Fix();
    };
    setup_test() is also {
	set_config(print, line_size, 9999);
    };
    internal_setup_test() is also {
    

        var l :list of string ;
        for each in symtab.modules {
            if index > symtab.last_sn_module then {
                l.add(global.files.get_full_file_name(it.file_name));
            };
        };
        files.write_string_list(sn_compare.full_path(EFILES_LOG), l );
     
        --specman (append ("set log ",sn_compare.full_path(CFG_LOG)," { show config}" )); 
        
        
    };
    run_test() is first {
       sn_compare.handle_sys_dump ();
 
       out(append("##START TEST")); 
       out(append("##EE TIME UNIT ",0  )); 

    };
  
  
    pre_quit() is also {
       -- put here pre quit stuff i.e. dump sys ...
    };
    

};

extend sys {
  --  !sn_last_lime :time ; -- for two new times in the same time unit (ask vitaly).
    init() is also {
	symtab.deep_copy_info.all_normal_compare = TRUE;
    };
    on new_time  {

        out(append("##EE TIME ENDED" ));
        out(append("##EE TIME UNIT ",sys.time  ));
            
        files.write(sn_compare.cmp_run,"sn_compare.cmp_next_time();");
        files.flush(sn_compare.cmp_run);
        sn_compare.handle_sys_dump();
    };
};

    
'>


    config_filter :list of string;
    init() is also {
        config_filter = {
"-hole_color";
"-illegal_bucket_color";
"-chart_colors";
"-gc_threshold";
 -- wave stuff
"configuration options for: wave";
"-viewer";
"-working_mode";
"-event_data";
"-list_items";
"-thread_code_line";
"-wave_radix";
"-auto_refresh";
"-stub_output";
"-stub_output_len";
"-stub_errors";
"-stub_error_len";
"-stub_events";
"-stub_integers";
"-stub_strings";
"-stub_strings_len";
"-stub_booleans";
"-wave_port";
"-show_sub_holes";
"-dump_file"
        };
    -- 
    };
    in_filter(str:string ,config_filter :list of string):bool  is {
        for each in config_filter {
            if str ~ append("/.*",it,".*/") then {
                return TRUE;
                
            };
        };
        return FALSE;
    };
        
    compare_config() is {

        var fns1 := read_list_file (full_path1(CFG_LOG));
        var fns2 := read_list_file (full_path2(CFG_LOG));
        
        var diff:list of string;

        files.write_string_list("/tmp/sn_cmp_cgf1.txt",fns1 );
        files.write_string_list("/tmp/sn_cmp_cgf2.txt",fns2 );
        
        out("*** Checking configuration:");
        diff = output_from  ("/usr/bin/diff -w  /tmp/sn_cmp_cgf1.txt /tmp/sn_cmp_cgf2.txt " );

        diff=diff.all(str_chop(it,1) == "<" or  str_chop(it,1) == ">");
        var tmp:list of string;
        for each in diff {
            if not in_filter(it,config_filter ) then {
                tmp.add(it);
            };
        };
        diff =tmp;

         if diff.size() > 0 {
            out(diff);
        };
    };
    
    
