all the commands marked with -- are sent to the application via socket.




<'
import sockets/sft_server;

'>
   HEADERS
<'


struct flow_step_template {
   !parent_flow: flow_template;
   client_name: string;
   vars: any_struct;
   // TRUE iff this step has been visited
   last_exec_result: list of string;
   my_returned_result: list of string;
   // this is the 'step' performed on the controlled tool,
   // using CVL.
   // maybe 2 methods are needed:
   // 1) a user defined 'step()' with specman / GT commands
   // 2) a predefined 'execute()' which wrap 'step' in CVL
   execute():list of string is undefined;
   execute_line():int is {result = 0;};//undefined;
   new_step: bool;

   // this recursive call moves one atomic step forward in this step.
   // returns TRUE iff this step is done.
   next_step(param : list of string):bool is undefined;

      
   // this method walk the step tree in a pre-order walk,
   // and returns the next ATOMIC step.
   get_current_atomic_step():atomic_step_template is undefined;
   init() is also {
      new_step = TRUE;
   };
   gui_command(command:string) is {
   };
   send_command(command:string) is {
      sft_server.send_command(command,client_name);  
      /// change later!!!  
   };
   get_exp_value(exp:string):string is {
      result = sft_server.get_exp_value(exp,EXP,client_name);
   };
   get_int_value(exp:string):int is {
      result = sft_server.get_exp_value(exp,NUM,client_name).as_a(int);
   };
   
};

type execution_kind_t : [FREE,     // step can be executed many times (no preconditions)
                         ONCE, // step may be executed once.
                         MUST, // step cannot be skipped.
                         NO_EXEC]; // step cannot be executed
// these are the leaves of the step tree.                            
struct atomic_step_template like flow_step_template {
   execution_kind : execution_kind_t;
   already_executed : bool;
   failed: bool;
   init() is also {
      execution_kind = ONCE;  // default;
   };
   description(): string is {
      result = "description missing";
   };
   feed_back():string is {
      result = "";
   };
   get_name(): string is undefined;

   get_current_atomic_step():atomic_step_template is {
      result = me;
   };
   next_step(param : list of string):bool is {
      result = TRUE;
   };
};

struct step_sequence_template like flow_step_template {
   current_subflow : flow_step_template;
   counter: uint;
   done: bool;
   init() is also {
      counter = 1;
   };
   execute():list of string is {
      last_exec_result =  current_subflow.execute();
      if done {
         result = my_returned_result;
      } else {
         result = {};
      };
   };
   get_current_atomic_step():atomic_step_template is {
      result = current_subflow.get_current_atomic_step();
   };
};

struct step_select_template like flow_step_template {
   chosen_step: flow_step_template;
   choose_step_index(): int is undefined;
   execute():list of string is {
      last_exec_result = chosen_step.execute();
      result = my_returned_result;
   };
   get_current_atomic_step():atomic_step_template is {
      result = chosen_step.get_current_atomic_step();
   };

};

struct user_select_window like vtx_window {
   buttons: list of vtx_component;
   button_panel: vtx_panel;
   step: step_user_select_template;
   handle_event(element: vtx_element, event_kind: vtx_event_kind) is {
      for i from 0 to buttons.size()-1 {
         if element==buttons[i] {
            step.user_choise = i;
            step.flag = TRUE;
         };
      };
   };
};
struct step_user_select_template like step_select_template {
   options_text: list of string;
   flag: bool;
   user_choise: int;
   set_options_text(text: list  of string) is {
      options_text = text;
   };
   choose_step_index():int is {
      var cw := new user_select_window with {
         .step = me;
      };

      for i from 0 to options_text.size()-1 {
         var option_text := append("option ",i);
         if i<options_text.size() and options_text[i]!=NULL {
            option_text = options_text[i];
         };
         cw.buttons.add(
            new vtx_button with { 
            .set_text(option_text); 
         } );
      };
      cw.button_panel = new vtx_panel with {
         .set_components(cw.buttons);
         .set_orientation(VTX_VERTICAL);
      };
      cw.set_primary_pane(cw.button_panel);
      cw.set_location(0,600);
      cw.set_size(300,200);
      cw.show();
//      while !flag {};
   };
};
struct flow_template {
   root_flow_step : flow_step_template;
//   current_subflow : atomic_step_template;
   close_step : close_connection_step; 
   null_step;
   all_clients: list of string;
   flow_started: bool;
   flow_terminated: bool;
   flow_in_last_step: bool;
   parameters : list of string;
   parameter_names : list of string;
   batch_delay: int;
   execute_next_step() is {
      if !preconditions() { // why here?
         out("pre conditions are not kept");
         return;
      };
      compute root_flow_step.execute();
   };
   run_as_batch() is {
      batch_delay = 1;
      if !preconditions() { // why here?
         out("pre conditions are not kept");
         return;
      }; 
      move_to_next_step();
      while !flow_terminated {
         compute system(append("sleep ",batch_delay));
         execute_next_step();
         move_to_next_step();
      };
   };
   // set the description of the flow by the creator
   description():string is undefined;
   get_description():list of string is {
      result = {description();"<br>"};
      result.add("<b>linked files:</b><br>");
      for each (linked_file) in linked_files() {
         result.add(appendf("<a href=%s>%s</a>\n",quote(linked_file),linked_file));
      };
   };
   get_name():string is undefined;
   // here the flow creator is responsible to check the preconditions to the flow.
   preconditions():bool is undefined;
   move_to_next_step() is {
      if flow_started {
         get_current_atomic_step().already_executed = TRUE;
      };
      if flow_in_last_step {
         flow_terminated = TRUE;
      } else {
         flow_in_last_step = root_flow_step.next_step(parameters);
      };
      flow_started = TRUE;
   };
   get_current_atomic_step():atomic_step_template is {
      if !flow_terminated {
         result = root_flow_step.get_current_atomic_step();
      } else {
         result = null_step;
      };
   };
   linked_files():list of string is {         // return a list of all linked files: e files, ecom, vsif, etc.
      result = {};                            // so the user can see them
   };
   // set the names of the parameters
   // and their default values
   set_default_parameters() is undefined;
   set_root_flow_step() is undefined;
   init() is also {
      set_default_parameters();
      set_root_flow_step();
      close_step = new;
      null_step = new;
      all_clients.resize(0);
//      move_to_next_step();   // start from step 1
   };
   close_all_connections() is {
      sft_server.close_all();
   };
};

struct flow_constants {};
extend global {
   flow_constants;
};

'>

useful steps

<'
extend global {
   sft_temp: string;
   all_sft_predefined_step_names: list of string;
   init() is also {
      all_sft_predefined_step_names = {"run_specview";
         "run_vmanager";
         "dummy_step";
         "atomic_step_quit";
         "close_connection_step"};
   };
};
struct run_specview like atomic_step_template {
   init() is also {
      execution_kind = MUST;
   };
   sn_flags: string;
   description():string is {
      result = "run Specview application by typing \"specview &\" at the command prompt";
   };
   get_name():string is {
      result = "run specview";
   };

   execute() : list of string is {
      compute sft_server.spawn_new_client(appendf("specview -gt %s ",sn_flags),client_name,FALSE);
      parent_flow.all_clients.add(client_name);
   };
};
struct run_vmanager like atomic_step_template {
   init() is also {
      execution_kind = MUST;
   };
   vm_flags: string;
   description():string is {
      result = "run vManager application by typing \"vmanager &\" at the command prompt";
   };
   get_name():string is {
      result = "run vmanager";
   };

   execute() : list of string is {
      compute system("setenv SPECMAN_PATH /vobs/vmp/vm_lib:$SPECMAN_PATH");
      //compute system("unsetenv SPECMAN_DISPLAY");
      compute sft_server.spawn_new_client(appendf("vmanager -gt %s ",vm_flags),client_name,TRUE);
      parent_flow.all_clients.add(client_name);
   };
};

struct run_specview_and_load like atomic_step_template {
   init() is also {
      execution_kind = MUST;
   };
   file_name: string;
   description():string is {
      result = append("run Specview application by typing \"specview &\" at the command prompt and load ",file_name);
   };
   get_name():string is {
      result = "run specview and load a test";
   };

   execute() : list of string is {
      compute sft_server.spawn_new_client("specview -gt",client_name,FALSE);
      send_command(append("load ",file_name));
   };
};
struct close_connection_step like atomic_step_template {
   description():string is {
      result = "close the current connection";
   };
   get_name():string is {
      result = "close_connection";
   };

   execute() : list of string is {
      send_command("sft_client.con.close()");
      sft_server.close(client_name);
   };
};

struct dummy_step like atomic_step_template {
   description() : string is {
      result = "dummy step";
   };
   get_name() : string is {
      result = "dummy step";
   };
   execute(): list of string is {};
};

struct null_step like atomic_step_template {
   description(): string is {
      result = "no current step";
   };
   get_name(): string is {
      result = "";
   };
   execute(): list of string is {
      assert FALSE;
   };
};
struct atomic_step_quit like atomic_step_template {
   description():string  is {
      result = "quit specman (and close connection)"
   };
   get_name():string  is {
      result = "quit";
   };
   execute() : list of string is {
      out("step quit");
      send_command(SOCK_QUIT_COMMAND);
      sft_server.close(client_name);
   };
};



'>