
   
<'

'>
   DATA STRUCTURES
   
<'
import sft_parse_ntf;


define ICON_FOLDER "/home/reshefm/flow_tool/icons/";
extend global {
      // check that the file exists:
   check_file(filename:string):bool is {
      var return_value :int = system(append("ls ",filename," >& tmp"));
      compute system("rm tmp");
      result = return_value == 0;
   };
   flow_checker: flow_parser_t;
   init() is also {
      flow_checker = new;
   };
};

type flow_filetype_t:[FD,E];

struct sft_flow_tree_node like  vtx_tree_node {
   kind: [GROUP,LESSON,FLOW];
   homedir: string;
   title: string;
   self_check(break_on_error:bool) is empty;
   get_lazy_text():string is {
      result = title;
   };
   get_info():list of string is {
      result = {"here we should see the node info";append("home dir: ",homedir)};
   };

   when GROUP sft_flow_tree_node {
      subgroups: list of sft_flow_tree_node;
      get_lazy_children():list of vtx_tree_node is {
         out("flow:   lazy children");
         out("+++++++++++++++++++++++++++++++++++++++++++++++++++");
         result = subgroups.as_a(list of vtx_tree_node);
      };
      get_icons():list of string  is {
         result = {append(ICON_FOLDER,"folder.gif")};
      };
      self_check(break_on_error:bool) is {
         for each in subgroups {
            it.self_check(break_on_error);
         };
      };

   };
   when LESSON sft_flow_tree_node {
      flows: list of FLOW sft_flow_tree_node;
      get_lazy_children():list of vtx_tree_node is {
         result = flows.as_a(list of vtx_tree_node);
      };
      get_icons():list of string  is {
         result = {append(ICON_FOLDER,"sequence.jpg")};
      };
      self_check(break_on_error:bool) is {
         for each in flows {
            it.self_check(break_on_error);
         };
      };

   };
   when FLOW sft_flow_tree_node {
      flow_filename: string;
      flow_name: string;
      flow_filetype: flow_filetype_t;
      file_exists_and_ok: bool;
      self_check(break_on_error:bool) is {
         file_exists_and_ok = check_file(flow_filename);
         if break_on_error {
            error("file: ",quote(flow_filename)," does not exist");
         };
         var filetype := str_split(flow_filename,".").last(TRUE); 
                  
         try {
            flow_filetype = str_upper(filetype).as_a(flow_filetype_t);
         } else {  
            if break_on_error {
               error("unknown file type: ",flow_filename);
            } else {
               warning("unknown file type: ",flow_filename);
               file_exists_and_ok = FALSE; 
            };
         };
            
         // mine the flow real title from .fd file:
         if file_exists_and_ok {
            flow_checker = new;
            case  flow_filetype {
               FD: {
                  if break_on_error {
                     flow_checker.parse_file(flow_filename);
                     flow_name = flow_checker.get_main_title();
                  } else {try {
                     flow_checker.parse_file(flow_filename);
                     flow_name = flow_checker.get_main_title();
                  } else {
                     warning("file has parsing errors: ",flow_filename);
                     flow_name = "file has parsing errors";
                     file_exists_and_ok = FALSE;
                  };};
               };
               E: { flow_name = flow_filename; };   
            };
         } else {
            flow_name = "flow does not exist";
         };
         
         title = flow_name;

      };
      get_info():list of string is only {
         result = {
            append("file name: ",flow_filename);
            append("flow name: ",flow_name)
         };

            if !file_exists_and_ok {
               result.add("can't find file");
            };
      };
      
      get_lazy_children():list of vtx_tree_node is {
      };

      get_icons():list of string  is {
         if file_exists_and_ok {
            result = {append(ICON_FOLDER,"flow_nav.gif")};
         } else {
            result = {append(ICON_FOLDER,"x.jpeg")};
         };
      };

   };
};


struct sft_flow_tree like vtx_tree {};

extend global {
   
   get_top_tree(): sft_flow_tree is {
      result = new sft_flow_tree with {
         .set_root(gen_flow_root());
      };
   };
   gen_flow_root(): GROUP sft_flow_tree_node is {
      var flow_nodes:list of FLOW sft_flow_tree_node;
      flow_nodes.resize(8);
      for i from 1 to 8 {
         flow_nodes[i-1] = new FLOW sft_flow_tree_node with {
            .title = append("flow unavailable",i);
         };
      };
      flow_nodes[0].title = "flow_simple_test";
      flow_nodes[0].flow_filename = "flow_test_2.e";
      
      flow_nodes[1].title = "generated_flow";
      flow_nodes[1].flow_filename = "/home/reshefm/flow_tool/ntf/simple_flow_2.fd";
//      flow_nodes[1].flow_name = "top_flow";
      
      flow_nodes[2].title = "select";
      flow_nodes[2].flow_filename = "/home/reshefm/flow_tool/ntf/select_example.fd";
      
      flow_nodes[7].title = "vmanager real flow";
      flow_nodes[7].flow_filename = "/home/reshefm/flow_tool/flows/vm_flow_1.fd";

      var seq_1 := new LESSON sft_flow_tree_node with {
         .flows = flow_nodes[0..3];
         .title = "flows 1-4";
      };
      var seq_2 := new LESSON sft_flow_tree_node with {
         .flows = flow_nodes[4..5];
         .title = "flows 5-6";
      };
      var seq_3 := new LESSON sft_flow_tree_node with {
         .flows = flow_nodes[6..7];
         .title = "flows 7-8";
      };
      var vm_flows := new GROUP sft_flow_tree_node with {
         .subgroups = {seq_3};
         .title = "vmanager flows";
      };
      var sn_flows := new GROUP sft_flow_tree_node with {
         .subgroups = {seq_1;seq_2};
         .title = "specman flows";
      };
      result = new GROUP sft_flow_tree_node with {
         .subgroups = {sn_flows;vm_flows};
         .title = "all flows";
      };
   };
   

};

'>