
this "flow" contains the path to a .fd file and parameters.
the execute() simply replace the parameters with values, save
the result as a .gt file, and run specview with this input.
   
<'
'>

   PARSER

<'

extend global {
   ntf_parser: flow_parser_t;
   tree_parser: flow_tree_parser_t;

   get_flow_root(tree_filename: string): GROUP sft_flow_tree_node is {
      // result = gen_flow_root();
      tree_parser = new;
      tree_parser.parse_file(tree_filename);
      result = new GROUP sft_flow_tree_node with {
         .subgroups = tree_parser.get_top_groups();
         .title = "all flows";
      };
      
   };
};
'>
extend global {
    gen_flow_root(): TREE sft_flow_tree_node is {
       var flow_nodes:list of FLOW sft_flow_tree_node;
       flow_nodes.resize(8);
       for i from 1 to 8 {
          flow_nodes[i-1] = new FLOW sft_flow_tree_node with {
             .title = append("flow unavailable",i);
          };
      };
       flow_nodes[0].title = "flow_simple_test";
       flow_nodes[0].flow_filename = "flow_test_2.e";
       
       flow_nodes[1].title = "generated_flow";
       flow_nodes[1].flow_filename = "/home/reshefm/flow_tool/ntf/simple_flow_2.fd";
//       flow_nodes[1].flow_name = "top_flow";
       
      flow_nodes[2].title = "select";
       flow_nodes[2].flow_filename = "/home/reshefm/flow_tool/ntf/select_example.fd";
      
       flow_nodes[7].title = "vmanager real flow";
       flow_nodes[7].flow_filename = "/home/reshefm/flow_tool/flows/vm_flow_1.fd";

       var seq_1 := new SEQ sft_flow_tree_node with {
          .seq = flow_nodes[0..3];
          .title = "flows 1-4";
       };
       var seq_2 := new SEQ sft_flow_tree_node with {
          .seq = flow_nodes[4..5];
          .title = "flows 5-6";
       };
       var seq_3 := new SEQ sft_flow_tree_node with {
          .seq = flow_nodes[6..7];
          .title = "flows 7-8";
       };
       var vm_flows := new TREE sft_flow_tree_node with {
          .sub_set = {seq_3};
          .title = "vmanager flows";
       };
       var sn_flows := new TREE sft_flow_tree_node with {
          .sub_set = {seq_1;seq_2};
          .title = "specman flows";
       };
       result = new TREE sft_flow_tree_node with {
          .sub_set = {sn_flows;vm_flows};
          .title = "all flows";
       };
    };
   

 };
<'

struct flow_history_node like vtx_tree_node {
   !step: atomic_step_template;
   get_lazy_text():string is {
      result = step.get_name();
   };
   get_icons():list of string is {
      result = {append(ICON_FOLDER,(step.failed)?"x.jpeg":"step.jpeg")};
   };
};
struct flow_history_root like vtx_tree_node {
//   !window: sft_main_window;
   leafs: list of flow_history_node;
   name:string;
   init() is also {
      set_id("history_root");
   };
'>
   get_lazy_children():list of vtx_tree_node is {
      out("history root:   lazy children");
      out("+++++++++++++++++++++++++++++++++++++++++++++++++++");
  //    print window.all_previous_steps;
      
      for each (step) in window.all_previous_steps {
         
         leafs.add( new flow_history_node with {
            .step = step;
         } 
         );
      };
      result = leafs.as_a(list of vtx_tree_node);
   };
<'
   get_lazy_text():string is {
//      if window.loaded_flow != NULL {
//         result = window.loaded_flow.get_name();
//     };
      result = name;
   };

};

   
struct flow_history_tree like vtx_tree {

   init() is also {
      reset();
      set_id("HISTORY");

   };
   reset() is {
      set_root(new flow_history_root);
   };
};
        

'>

   GUI
<' 

define DEMO_FLOW_TREE "flows/flow_tree_ex.ft";

struct sft_flow_config_window like vtx_window {
   parameters:list of string;
   parameter_names: list of string;
   fields: list of vtx_textfield;
   flow: flow_template;
   main_panel: vtx_panel;
   save_button: vtx_button;
   save_and_quit_button: vtx_button;
   button_panel: vtx_buttons_panel;
   initialize(source_flow: flow_template) is {
      flow = source_flow;
//      print flow.parameters;
      for i from 0 to flow.parameters.size()-1 {
         fields.add( new vtx_textfield with {
            .set_label(append(flow.parameter_names[i],": "));
            .set_text(flow.parameters[i]);
         }    );
         parameters.add(flow.parameters[i]);
      };
      save_button = new vtx_button with {
         .set_text("save changes");
      };
      save_and_quit_button = new vtx_button with {
         .set_text("save changes and quit");
      };
      button_panel = new vtx_buttons_panel with {
         .set_buttons({save_button;save_and_quit_button});
      };
      main_panel = new vtx_panel with {
         .set_components({fields.as_a(list of vtx_component);button_panel});
         .set_orientation(VTX_VERTICAL);
      };
      set_primary_pane(main_panel);
      set_title(append("configure ",flow.get_name()," parameters"));
      set_location(0,400);
      set_size(300,140+flow.parameters.size()*12);
   };
   handle_event(element: vtx_element, event_kind: vtx_event_kind) is {
      for i from 0 to parameters.size()-1 {
         if element == fields[i] {
            parameters[i] = fields[i].get_text();
         };
      };
      if element == save_button {
         for i from 0 to flow.parameters.size()-1 {
            flow.parameters[i] = parameters[i];
         };
      };
      if element == save_and_quit_button {
         for i from 0 to flow.parameters.size()-1 {
            flow.parameters[i] = parameters[i];
         };
         close();
      };
   };
};


// the main window of the application
struct sft_main_window like vtx_window {
   browser_main_panel: vtx_panel;
   browser_info: vtx_textarea;
   browser_info_panel: vtx_panel;
   browser_select_button: vtx_button;
   browser_show_errors_button: vtx_button;
   browser_button_panel: vtx_panel;
   browser_flow_tree: vtx_tree;
   browser_flow_tree_panel: vtx_splitter;
   
   flow_main_panel: vtx_panel;
   flow_info: vtx_html_viewer;
   flow_name: vtx_textarea;  
   flow_execute_button: vtx_button;
   flow_batch_button: vtx_button;
   flow_browse_button: vtx_button;
   flow_source_button: vtx_button;
   flow_config_button: vtx_button;
   flow_button_panel: vtx_panel;
   
   run_main_panel: vtx_panel;
   run_info: vtx_textarea;
   run_loaded_flow: vtx_textarea;
   run_flow_info: vtx_splitter;
   run_history: flow_history_tree;
   run_next_button: vtx_button;   // ALWAYS
   run_prev_button: vtx_button;   // ALWAYS
   run_do_button: vtx_button;     // SFT_STEPS
   run_did_it_button: vtx_button; // MANUAL_STEPS, NO_LINK
   run_manual_button: vtx_button; // SFT_STEPS
   run_abort_button: vtx_button;  // ALWAYS
   run_button_panel: vtx_panel;
   run_components: list of vtx_element;
   
   main_changer: vtx_changer;
   main_something: vtx_panel;
   main_panel: vtx_panel;
   
   loaded_flow: flow_template;
   loaded_flow_node: FLOW sft_flow_tree_node;
   all_previous_steps: list of atomic_step_template;
   
   current_displayed_step_index : int;
   //step_is_executable: bool;
//   current_step_executed: bool;
   interaction_state: [SFT_STEPS,MANUAL_STEPS,NO_LINK,RUN_NON_STOP];
   
   init() is also {
      var close_listener_action := vtx.create_action(
         "close listener",
         "View",
         "kill all applications and close listener",
         "Tool bar",
         "",
         "sft_server.kill_all_clients(); sft_server.close_listener();res",
         "",
         FALSE,
         FALSE,
         "");
      set_actions({get_actions();close_listener_action});
      set_title("Flow Tool v0.1");   
      set_id("SFT_MAIN");

   };
      
   initialize(root: sft_flow_tree_node) is {
      // browser screen
      browser_flow_tree = new sft_flow_tree with {
         .set_root(root);
         .set_id("FLOW_TREE");
         .set_background(YELLOW);
      };
      browser_info = new vtx_textarea with {
         .set_height(80);
         .set_visible_row_count(4);
         .set_background(YELLOW);
      };
      browser_flow_tree_panel = new vtx_splitter with {
         .set_first_pane(browser_flow_tree);
         .set_second_pane(browser_info);
         .set_orientation(VTX_VERTICAL);
         .set_divider_location(190);
      };
      browser_select_button = new vtx_button with {
         .set_text("Select");
         .set_tooltip("select this flow");
         .set_enabled(FALSE);
      };
      browser_show_errors_button = new vtx_button with {
         .set_text("Show errors");
         .set_tooltip("Show errors in flow");
         .set_enabled(FALSE);
      };
      browser_button_panel = new vtx_panel with {
         .set_components({browser_select_button;browser_show_errors_button});
         .set_orientation(VTX_HORIZONTAL);
      };
      browser_main_panel = new vtx_panel with {
         .set_components({browser_flow_tree_panel;browser_button_panel});
         .set_orientation(VTX_VERTICAL);
      };
      
      // flow screen
      flow_execute_button = new vtx_button with {
         .set_text("execute");
         .set_icon(append(ICON_FOLDER,"play_arrow.gif"));
         .set_tooltip("run flow with these parameters");
         .set_vertical_text_position(VTX_TOP);
         .set_horizontal_text_position(VTX_CENTER);
         

      };
      flow_batch_button = new vtx_button with {
         .set_text("Run");
         .set_icon(append(ICON_FOLDER,"play_arrow.gif"));
         .set_tooltip("run flow as batch");
         .set_vertical_text_position(VTX_TOP);
         .set_horizontal_text_position(VTX_CENTER);
      };
      flow_source_button = new vtx_button with {
         .set_icon(append(ICON_FOLDER,"source.gif"));
         .set_tooltip("view source file");
         .set_id("SOURCE");
      };
      flow_browse_button = new vtx_button with {
         .set_text("browse");
         .set_tooltip("browse flow tree");
         .set_id("BROWSE");
      };
      flow_config_button = new vtx_button with {
         .set_icon(append(ICON_FOLDER,"rotary.jpg"));
         .set_tooltip("configure parameters");
      };
      flow_button_panel = new vtx_buttons_panel with {
         .set_buttons({flow_execute_button;flow_batch_button;flow_source_button;flow_config_button;flow_browse_button});
      };
      flow_info = new vtx_html_viewer with {
         .set_background(YELLOW);
      };
      flow_name = new vtx_textarea with {
         .set_height(2);
         .set_visible_row_count(2);
         .set_background(YELLOW);
      };
      flow_main_panel = new vtx_panel with {
         .set_components({flow_name;flow_info;flow_button_panel});
         .set_orientation(VTX_VERTICAL);
      };
      
      // run screen
      run_next_button = new vtx_button with {
         .set_text("Next");
         .set_tooltip("move to next step");
         .set_enabled(FALSE);
      };
      run_do_button = new vtx_button with {
         .set_text("Do");
         .set_tooltip("perform action");
         .set_enabled(FALSE);
      };
      run_did_it_button = new vtx_button with {
         .set_text("Did it");
         .set_tooltip("click here if you did the step manually");
         .set_enabled(FALSE);
      };
      run_manual_button = new vtx_button with {
         .set_text("Manual");
         .set_tooltip("click here to switch to manual mode");
         .set_enabled(FALSE);
      };
      run_abort_button = new vtx_button with {
         .set_text("Abort");
         .set_tooltip("abort this flow");
         .set_enabled(FALSE);
      };
      run_prev_button = new vtx_button with {
         .set_text("Prev");
         .set_tooltip("see last step");
         .set_enabled(FALSE);
      };
      run_button_panel = new vtx_panel with {
         .set_components({run_next_button;run_prev_button;run_do_button;run_did_it_button;run_manual_button;run_abort_button});
         .set_orientation(VTX_HORIZONTAL);
      };
      run_info = new vtx_textarea with {
         .set_height(80);
         .set_visible_row_count(4);
         .set_background(YELLOW);
      };
      run_loaded_flow = new  vtx_textarea with {
         .set_height(20);
         .set_visible_row_count(2);
         .set_background(YELLOW);
      };
      run_history = new flow_history_tree with {
//         .initialize(me);
         .set_background(YELLOW);
      };
      run_flow_info = new vtx_splitter with {
         .set_first_pane(run_loaded_flow);
         .set_second_pane(run_history);
         .set_orientation(VTX_HORIZONTAL);
         .set_divider_location(190);
      };
      run_main_panel = new vtx_panel with {
         .set_components({run_flow_info;run_info;run_button_panel});
         .set_orientation(VTX_VERTICAL);
      };
      run_components = {
         run_main_panel;
         run_info;
         run_loaded_flow;
         run_flow_info;
         run_history;
         run_next_button;
         run_prev_button;
         run_do_button;
         run_did_it_button;
         run_manual_button;
         run_abort_button;
         run_button_panel;
      };

      current_displayed_step_index = -1;  // no step is displayed
      
      // main
      main_changer = new vtx_changer with {
         .set_components({browser_main_panel;flow_main_panel;run_main_panel});
      };
      main_something = new;
      main_panel = new vtx_panel with {
         .set_components({main_something;main_changer});
      };
      set_primary_pane(main_panel);         
   };  // initialize()
   
   show_step_info(step: atomic_step_template) is {
//      if step is a null_step {
//         run_info.set_text_lines({"no current step"});
//      } else {         
         run_info.set_text_lines({
            append("step ",current_displayed_step_index," - ",step.get_name());
            "step description:";
            step.description();
            ""});
         if step.already_executed {
            run_info.append_text_lines({(step.failed)?"failed":"done.";"";step.feed_back()},TRUE);
         };    
//      };
   };
   
   handle_event(element: vtx_element, event_kind: vtx_event_kind) is also {
      out("event: ",element.get_id(),"; ",event_kind);
      // general events 
      if element == me {
         if event_kind == VTX_PRE_CLOSE {
            sft_server.close_listener();
           // print sft_server.sock_listener;
         };
      };
      // browser events
      if element == browser_flow_tree {      
         var node := browser_flow_tree.get_selected_node().as_a(sft_flow_tree_node);
         browser_info.set_text_lines(node.get_info());
         if node is a FLOW sft_flow_tree_node (fn) and fn.file_exists_and_ok {
            browser_select_button.set_enabled(TRUE);
            browser_show_errors_button.set_enabled(FALSE);
         } else {
            browser_select_button.set_enabled(FALSE);
            browser_show_errors_button.set_enabled(TRUE);
         };
      };
      
      if element == browser_select_button {
         browser_select_button.set_enabled(FALSE);
         loaded_flow_node = browser_flow_tree.get_selected_node().as_a(FLOW sft_flow_tree_node);
//         if loaded_flow_node.flow_filename == "" {
//            browser_info.set_text_lines({"flow file unavailable"});
//         } else {
            load_loaded_flow();
            flow_name.set_text_lines({"current flow: ";loaded_flow.get_name()});
            flow_info.set_html({loaded_flow.get_description()});
            main_changer.show_component(flow_main_panel);
        // };
      };
      if element == browser_show_errors_button {
         browser_show_errors_button.set_enabled(FALSE);
         loaded_flow_node = browser_flow_tree.get_selected_node().as_a(FLOW sft_flow_tree_node);
         loaded_flow_node.self_check(TRUE);
//         load_loaded_flow();
      };
         
      // flow events
      if element == flow_execute_button {
         prepare_flow_for_execution();
         // gui:
         run_info.set_text_lines({"you started a flow";"hit Next to move to next step"});
         run_loaded_flow.set_text_lines({"current flow:";loaded_flow.get_name()});
         run_next_button.set_enabled(TRUE);
         run_manual_button.set_enabled(TRUE);
         run_abort_button.set_enabled(TRUE);
         run_history.get_root().as_a(flow_history_root).name = loaded_flow.get_name();
         main_changer.show_component(run_main_panel);

      };
      if element == flow_batch_button {
         loaded_flow.run_as_batch();
         load_loaded_flow();
      };
      if element == flow_source_button {
         show_source_window(loaded_flow_node.flow_filename);
      };
      if element == flow_config_button {
         loaded_flow.config();
      };
      if element == flow_browse_button {
         main_changer.show_component(browser_main_panel);
         browser_select_button.set_enabled(TRUE);
      };
   
   };

};
extend global {
   show_source_window(filename : string) is {
      var tokens := str_split(filename,".");
      var file_type := str_upper(tokens[tokens.size()-1]);
      var viewer: vtx_component;
      case file_type {
         "HTML": {
            var html:list of string;
            for each line in file filename {
               html.add(it);
            };
            viewer = new vtx_html_viewer with {
               .set_html(html); 
            };
         };
         "GIF": {
            viewer = new vtx_image with {
               .set_image(filename);
            };
         };
         "JPG": {
            viewer = new vtx_image with {
               .set_image(filename);
            };
         };
         default: {
            viewer = new vtx_source_viewer with {
               .set_source_file(filename,0);
            };
         };
      };
      var sp:= new vtx_panel with {
         .set_components({viewer});
      };
      var sw:= new vtx_window with {
         .set_primary_pane(sp);
      };
      sw.show();
   };
};

'>

DRIVER 

<'

extend global {
   sft_main: sft_main_window;
//   sft_server: sft_server_t;
   sft() is {
      specman("run");
      sft_main = new;
      sft_main.initialize(get_flow_root(DEMO_FLOW_TREE));

      sft_main.set_location(0,0);
      sft_main.set_size(400,400);

      sft_main.show();
      
      sft_server = new;
      sft_server.listen();

   };
   sft_batch(flow_filename:string,flow_name: string) is {
      sft_main = new;
      sft_server = new;
      sft_server.listen();
      sft_main.load_flow(flow_filename,flow_name);
      sft_main.loaded_flow.run_as_batch();
      sft_server.close_listener();
   };
      
};

'>


   RUNNER
   
<'   

// remove later
extend flow_step_template {
   init() is also {
      parent_flow = global.sft_main.loaded_flow;
   };
};



extend flow_template {

   config() is {
      var cw:= new sft_flow_config_window;
      cw.initialize(me);
      cw.show();
   };
};

extend sft_main_window {
   current_atomic_step():atomic_step_template is {
      result = (all_previous_steps.size() == 0 or all_previous_steps.size()<= current_displayed_step_index)?loaded_flow.null_step:all_previous_steps[current_displayed_step_index];
   };
   prepare_flow_for_execution() is {
      all_previous_steps.resize(0);
//      run_history = new;
      run_history.reset();
      current_displayed_step_index = -1;
      interaction_state = SFT_STEPS;
   };
   load_loaded_flow() is {
      //error();
      load_flow(loaded_flow_node.flow_filename,loaded_flow_node.flow_name);
   };
   load_flow(filename:string,flow_name:string) is {
      if str_match(filename,"/\.fd/") {
         ntf_parser = new;
         ntf_parser.parse_file(filename);
         print ntf_parser.target_file_name;
         print global.current_target_file_name;
         ntf_parser.write_e_file();
      };
      filename = str_remove_ext(filename);
      specman_command(append("@",filename,".ecom"));         
   };

      
   handle_event(element: vtx_element, event_kind: vtx_event_kind) is also {
      // run events

      if sft_server.get_control_state()==SERVER and event_kind != VTX_POST_CLOSE {  // this is as often as i can get...
         interaction_state = SFT_STEPS;
         run_did_it_button.set_enabled(FALSE);
         run_manual_button.set_enabled(TRUE);
      };
      
      //---------------------------------------
      // execute step and move to next step
      //---------------------------------------
      if element == run_do_button {
         if interaction_state == SFT_STEPS {
            run_info.append_text_lines({"";"executing now..."},TRUE);
            print 1;
            try {
               print 2;
               if current_displayed_step_index == all_previous_steps.size()-1 {        
                  print 3;
                  loaded_flow.execute_next_step();
               } else if current_atomic_step().execution_kind == FREE {
                  print 4;
                  compute current_atomic_step().execute();
               } else {
                  print 5;
                  error();
               }; 
               print 6;
            };
            me.to_front();
            element = run_next_button;
         } else {
            run_info.append_text_lines({"";"can't use Do in manual mode"},TRUE);
         };
      };
      
      
      //---------------------------------------
      // move to next step ( without execution )
      //---------------------------------------
      if element == run_next_button {
         var step : atomic_step_template;
         if current_displayed_step_index == all_previous_steps.size()-1 {

            // load next step
            loaded_flow.move_to_next_step();
            run_next_button.set_enabled(FALSE);
            step = loaded_flow.get_current_atomic_step();
            all_previous_steps.add(step);  // update current_atomic_step=step
            run_history.insert_node("history_root",new flow_history_node with {.step = step},run_history.get_root().get_child_count());
            run_history.expand_all();
         };
         current_displayed_step_index = current_displayed_step_index+1;
         show_step_info(current_atomic_step());
      };
      
      // Remove
      if element == run_did_it_button {
'>         
         if interaction_state != SFT_STEPS {
            run_do_button.set_enabled(FALSE);
            run_did_it_button.set_enabled(FALSE);
            var step := loaded_flow.get_current_atomic_step();
            current_step_executed = TRUE;
            show_step_info(step);
            run_info.append_text_lines({"";"done."},TRUE);
            run_next_button.set_enabled(TRUE);
         } else {
            run_info.append_text_lines({"";"can use 'Did it' only in manual mode"},TRUE);
         };
<'         
      };
      // will be removed
      if element == run_manual_button {
         interaction_state = MANUAL_STEPS;
         run_manual_button.set_enabled(FALSE);
         sft_server.pass_control_to_all_clients();
      };
      //----------------------------
      // go back to last step
      //----------------------------
      if element == run_prev_button {
         current_displayed_step_index = current_displayed_step_index-1;
         var step:= all_previous_steps[current_displayed_step_index];
      };
      //------------------------------
      // go to chosen step from history
      //------------------------------
      if element == run_history {
         if run_history.get_selected_id() != "history_root" {
            var step_index := run_history.get_selected_path()[1];
            print step_index;
            current_displayed_step_index = step_index;
            var step:= all_previous_steps[current_displayed_step_index];
         };
      };
      if element in run_components {
         run_history.set_selected_path({0;current_displayed_step_index});
         if loaded_flow.flow_terminated {
            run_loaded_flow.set_text_lines({"current flow:";loaded_flow.get_name();"";"  FLOW TERMINATED"});            
         };
         show_step_info(current_atomic_step());
         run_did_it_button.set_enabled(FALSE);
         if loaded_flow.flow_terminated {
            run_do_button.set_enabled(FALSE);
            run_next_button.set_enabled(FALSE);
            run_prev_button.set_enabled(FALSE);
         } else {
            print current_atomic_step();
            run_do_button.set_enabled(current_atomic_step().execution_kind == FREE or
               (current_atomic_step().execution_kind in [ONCE,MUST] and !(current_atomic_step().already_executed)));
            
            run_next_button.set_enabled(current_atomic_step().execution_kind != MUST or
               current_atomic_step().already_executed);
            run_prev_button.set_enabled(current_displayed_step_index > 0 );
         };
      };
      
      if element == run_abort_button {
         run_do_button.set_enabled(FALSE);
         run_next_button.set_enabled(FALSE);
         run_prev_button.set_enabled(FALSE);
         loaded_flow.close_all_connections();  
         load_loaded_flow();
         flow_name.set_text_lines({loaded_flow.get_name()});
         flow_info.set_html({loaded_flow.get_description()});
         main_changer.show_component(flow_main_panel);
      };


   };

};
'>
   
