<'
import sft_sockets_h;

struct sft_client {
   !con: sft_socket_interactor;
   client_gui: sft_client_control_window;
   -------------------
   -- the method completes the connection from the server side.
   -- is automatically activated if client is raised by the server
   -- using get_new_client() 
   -------------------
   connect(host:string, port:int, client_name:string) is {
      con = new sft_socket_interactor with {
         .client_name = client_name;
      };
      out("client reaching out...");
      print host;
      print port;
      con.establish_client_2(host,port);
      out("client connected. waiting commands...");
      client_gui = new sft_client_control_window with {
         .initialize(me);
      };
      client_gui.show();

      wait_for_commands();
   };
   
   disconnect() is {
      out("disconnecting from SFT...");
      con.close();
      if client_gui!=NULL {
         client_gui.close();
      };
   };

   ---------------------
   -- the main client loop.
   -- execute directly 'safe' commands,
   -- also handles 'dangerous' commands (e.g. load)
   ----------------------
   wait_for_commands() is {
      //if client_gui!=NULL {
         //    client_gui.close();
         //     client_gui = NULL;
         //   };
      while con.get_state() == CONNECTED {
         var command := con.receive_command();
         if command == SOCK_PASS_CONTROL_COMMAND {
            return;
         };
         if command == SOCK_CLOSE_COMMAND {
            disconnect();
            return;
         };
         if command == SOCK_QUIT_COMMAND {
            con.close();
            command = "exit";
         };
         if str_split(command," ")[0] in DANGER_COMMANDS {
            display.send_specman_command(append(command,"; sft_client.wait_for_commands()"));
            return;
         } else {
            if command != "" {
               specman(command);
            };
         };
      };
   };
};
extend global {
   sft_client;
   init() is also {
      sft_client = new;
   };
};

'>

   GUI
   
<'
struct sft_client_control_window like vtx_base_window {
   !parent_client: sft_client;
   main_panel: vtx_panel;
   return_button: vtx_button;
   button_panel: vtx_buttons_panel;
   initialize(client: sft_client) is {
      me.parent_client = client;
      return_button = new vtx_button with {
         .set_text("return control to SFT main");
      };
      button_panel = new vtx_buttons_panel with {
         .set_buttons({return_button});
         .set_background(YELLOW);
      };
      main_panel = button_panel;
      set_primary_pane(main_panel);
      set_title(parent_client.con.client_name);
      set_location(0,400);
      set_size(300,150);

   };
   handle_event(element: vtx_element, event_kind: vtx_event_kind) is {
      if element == return_button {
         var s: string;
         for each line in file "client_control" {
            s = it;
         };
         if s=="NO SERVER" {
            parent_client.disconnect();
         } else {
            parent_client.con.client_control = SERVER;
            files.write_string_list("client_control",{"SERVER"});
            parent_client.wait_for_commands();
            if parent_client.con.server_wait {
               parent_client.con.send("CLIENT ERROR");
            };
         };
      };
   };
};

'>
